Ext.define('analysis.view.widget.report.Widget', {extend:'Ext.panel.Panel', alias:'widget.analysisReportWidget', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:BpcCommon.lang.Current.ANALYSIS_REPORT_WIDGET_NAME, WIDGET_DESCRIPTION:BpcCommon.lang.Current.ANALYSIS_REPORT_WIDGET_DESCRIPTION, WIDGET_ICON_CLS:'x-fal fa-bar-chart', WIDGET_ADDITIONAl_ACTIONS:[{iconCls:BpcCommon.Icons.EDIT, handler:function() {
  this.configureReport();
}}]}, layout:'card', activeItem:0, minHeight:300, contentPanel:undefined, settingPanel:undefined, wrongConfigPanel:undefined, initComponent:function() {
  var me = this;
  var moduleConfiguration = this.getWidgetConfiguration();
  me.reportId = moduleConfiguration.reportId;
  me.moduleId = moduleConfiguration.moduleId;
  me.widgetTitle = moduleConfiguration.title;
  me.widgetIconCls = moduleConfiguration.iconCls;
  me.widgetShowReportTitle = moduleConfiguration.showReportTitle;
  me.loadReportConfigurationSetting(me.moduleId, me.reportId);
  me.callParent();
  me.configureReportPanel = Ext.create({xtype:'analysisExternalVariableView', localized:{title:'CORE_SETTINGS'}, iconCls:'x-fal fa-cogs', header:true, reportData:this.reportData, scrollable:true, listeners:{reportDataChanged:function(newReportData) {
    me.applyReportConfiguration(newReportData);
  }, showReportContent:function() {
    if (me.contentPanel) {
      me.getLayout().setActiveItem(me.contentPanel);
    } else {
      me.checkConfiguration();
    }
  }}});
  me.settingPanel = this.add({xtype:'analysisReportWidgetConfigurator', moduleId:this.moduleId, reportId:this.reportId, widgetTitle:this.widgetTitle, widgetIconCls:this.widgetIconCls, showReportTitle:this.widgetShowReportTitle, listeners:{reportConfigChanged:function(moduleId, reportId) {
    me.loadReportConfigurationSetting(moduleId, reportId);
    me.applyReportConfiguration({}, true);
  }}});
  me.wrongConfigPanel = this.add({xtype:'container', padding:'10 10 10 10', items:[{xtype:'box', localized:{html:'ANALYSIS_WIDGET_INVALID_CONFIG'}}, {xtype:'button', localized:{text:'ANALYSIS_SHOW_CONFIG'}, iconCls:'x-fal fa-cog', handler:function() {
    var widget = this.up('[isBpcWidget\x3dtrue]');
    widget.getLayout().setActiveItem(widget.settingPanel);
  }}]});
  this.checkConfiguration();
}, loadReportConfigurationSetting:function(moduleId, reportId) {
  this.moduleId = moduleId;
  this.reportId = reportId;
  this.reportData = analysis.assets.Helpers.getSingleReport(this.moduleId, this.reportId);
}, applyReportConfiguration:function(reportConfig, refreshConfigPanel) {
  reportConfig = reportConfig === void 0 ? {} : reportConfig;
  refreshConfigPanel = refreshConfigPanel === void 0 ? false : refreshConfigPanel;
  var me = this;
  if (!analysis.assets.Helpers.isObjectEmpty(reportConfig)) {
    me.reportData = reportConfig;
  }
  if (me.contentPanel) {
    var reportViewer = me.contentPanel.down('analysisReportViewer');
    if (reportViewer) {
      reportViewer.setNewConfiguration(me.reportData);
    }
  }
  if (refreshConfigPanel) {
    if (me.configureReportPanel) {
      me.configureReportPanel.setNewConfiguration(me.reportData);
    }
  }
}, checkConfiguration:function() {
  if (!this.moduleId || !this.reportId) {
    this.getLayout().setActiveItem(this.wrongConfigPanel);
  } else {
    this.showContent();
  }
}, showContent:function() {
  if (this.contentPanel) {
    this.remove(this.contentPanel);
  }
  this.contentPanel = this.add({xtype:'analysisReportWidgetViewPanel', moduleId:this.moduleId, reportId:this.reportId, showHeader:this.widgetShowReportTitle, reportData:this.reportData});
  this.getLayout().setActiveItem(this.contentPanel);
}, configureWidget:function() {
  if (this.settingPanel.isVisible(true)) {
    this.getLayout().setActiveItem(this.contentPanel);
  } else {
    this.getLayout().setActiveItem(this.settingPanel);
  }
}, configureReport:function() {
  var me = this;
  if (me.configureReportPanel.isVisible(true)) {
    me.getLayout().setActiveItem(me.contentPanel);
  } else {
    me.getLayout().setActiveItem(me.configureReportPanel);
  }
}, refreshWidget:function() {
  try {
    var reportViewerCmp = this.down('analysisReportViewer');
    reportViewerCmp.updateChartData();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ':ERROR while updating report', dump:e, stack:true, level:'error'});
  }
}, onSaveConfiguration:function() {
  var widgetConfigurator = this.down('analysisReportWidgetConfigurator');
  this.moduleId = widgetConfigurator.moduleId;
  this.reportId = widgetConfigurator.reportId;
  this.widgetTitle = widgetConfigurator.widgetTitle;
  this.widgetIconCls = widgetConfigurator.widgetIconCls;
  this.widgetShowReportTitle = widgetConfigurator.showReportTitle;
  this.setWidgetConfiguration({moduleId:this.moduleId, reportId:this.reportId, title:this.widgetTitle, iconCls:this.widgetIconCls, showReportTitle:this.widgetShowReportTitle});
  this.fireEvent('widgetConfigurationChange', this);
  this.checkConfiguration();
}});
Ext.define('analysis.view.widget.chart.Widget', {extend:'Ext.panel.Panel', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:BpcCommon.lang.Current.ANALYSIS_CHART_WIDGET_NAME, WIDGET_DESCRIPTION:BpcCommon.lang.Current.ANALYSIS_CHART_WIDGET_DESCRIPTION, WIDGET_ICON_CLS:'x-fal fa-bar-chart'}, layout:'card', activeItem:0, minHeight:300, configureWidget:function() {
  if (this.settingPanel.isVisible(true)) {
    this.getLayout().setActiveItem(this.contentPanel);
  } else {
    this.getLayout().setActiveItem(this.settingPanel);
  }
}, refreshWidget:function() {
  try {
    var reportViewerCmp = this.down('analysisReportViewer');
    reportViewerCmp.updateChartData();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ':ERROR while updating report', dump:e, stack:true, level:'error'});
  }
}, initComponent:function() {
  lazyLoad.AmCharts();
  var moduleConfiguration = this.getWidgetConfiguration();
  this.chartId = moduleConfiguration.chartId;
  this.moduleId = moduleConfiguration.moduleId;
  this.widgetTitle = moduleConfiguration.title;
  this.widgetIconCls = moduleConfiguration.iconCls;
  this.widgetShowReportTitle = moduleConfiguration.showReportTitle;
  this.stateId = this.stateId + this.moduleId;
  this.callParent();
  this.settingPanel = this.add({xtype:'analysisChartWidgetConfigurator', moduleId:this.moduleId, chartId:this.chartId, widgetTitle:this.widgetTitle, widgetIconCls:this.widgetIconCls, showReportTitle:this.widgetShowReportTitle});
  this.wrongConfigPanel = this.add({xtype:'container', padding:'10 10 10 10', items:[{xtype:'box', localized:{html:'ANALYSIS_WIDGET_INVALID_CONFIG'}}, {xtype:'button', localized:{text:'ANALYSIS_SHOW_CONFIG'}, iconCls:'x-fal fa-cog', handler:function() {
    var widget = this.up('[isBpcWidget\x3dtrue]');
    widget.getLayout().setActiveItem(widget.settingPanel);
  }}]});
  this.checkConfiguration();
}, checkConfiguration:function() {
  if (this.moduleId === undefined || this.chartId === undefined) {
    this.getLayout().setActiveItem(this.wrongConfigPanel);
  } else {
    this.showContent();
  }
}, showContent:function() {
  if (this.contentPanel === undefined) {
    this.remove(this.contentPanel);
  }
  this.contentPanel = this.add({xtype:'analysisChartWidgetViewPanel', moduleId:this.moduleId, chartId:this.chartId, showHeader:this.widgetShowReportTitle});
  this.getLayout().setActiveItem(this.contentPanel);
}, onSaveConfiguration:function() {
  var widgetConfigurator = this.down('analysisChartWidgetConfigurator');
  this.moduleId = widgetConfigurator.moduleId;
  this.chartId = widgetConfigurator.chartId;
  this.widgetTitle = widgetConfigurator.widgetTitle;
  this.widgetIconCls = widgetConfigurator.widgetIconCls;
  this.widgetShowReportTitle = widgetConfigurator.showReportTitle;
  this.setWidgetConfiguration({moduleId:this.moduleId, chartId:this.chartId, title:this.widgetTitle, iconCls:this.widgetIconCls, showReportTitle:this.widgetShowReportTitle});
  this.fireEvent('widgetConfigurationChange', this);
  this.checkConfiguration();
}});
Ext.define('analysis.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['analysis.view.widget.report.Widget', 'analysis.view.widget.chart.Widget'], config:{moduleConfigurationComponents:[], requiredModules:[], widgets:['analysis.view.widget.report.Widget', 'analysis.view.widget.chart.Widget']}});
Ext.define('analysis.store.ChartType', {extend:'Ext.data.Store', storeId:'analysisChartType', alias:'store.analysisChartType', autoLoad:true, data:[{framework:'amCharts', type:'pie', name:'Pie', amClass:'PieChart3D', selectorComponents:['analysisPieSeriesGrid', 'analysisPieConfigurator'], baseConfig:{'titles':[{'text':''}], 'series':[{'colors':{'list':['#cbbc6b', '#c63441', '#81A2CC', '#96bebe', '#e18b50', '#dcd9d2', '#958f77']}, 'dataFields':{'category':'label', 'value':'value', 'depthValue':'value'}, 
'alignLabels':false, 'ticks':{'disabled':true}, 'labels':{'disabled':false, 'radius':'-40%', 'text':"{value.percent.formatNumber('#.0')}%", 'fontSize':25}, 'category':'label', 'value':'value'}], 'radius':100, 'innerRadius':50, 'depth':30, 'angle':45, 'data':[], 'background':{'fill':'rgba(255,255,255,1)'}, 'cursor':{}, 'legend':{'disabled':false}}}, {framework:'amCharts', type:'xy', name:'XYChart', amClass:'XYChart', selectorComponents:['analysisXYSeriesGrid', 'analysisXYAxesConfigurator'], baseConfig:{'dateFormatter':{'inputDateFormat':'yyyy-MM-dd HH:mm:ss'}, 
'cursor':{'type':'XYCursor'}, 'titles':[{'text':'Time Chart', 'fontSize':25, 'marginBottom':30}], 'legend':{}, 'series':[{'columns':{'tooltipText':'{name}\n {dateX} : {valueY}'}, 'id':'s0', 'name':'Time Line', 'type':'LineSeries', 'dataFields':{'dateX':'timestamp', 'valueY':'sessions'}, 'stroke':'rgba(103,116,136,1)', 'fill':'rgba(225,139,80,1)', 'strokeWidth':2, 'fillOpacity':0.4, 'bullets':[{'children':[{'type':'Circle', 'width':5, 'height':5, 'horizontalCenter':'middle', 'verticalCenter':'middle'}]}]}], 
'paddingRight':20, 'xAxes':[{'type':'DateAxis', 'renderer':{'grid':{'disabled':false}, 'minGridDistance':50}, 'title':{'text':'xAxes'}, 'skipEmptyPeriods':true}], 'yAxes':[{'type':'ValueAxis', 'title':{'text':'yAxes'}, 'renderer':{'grid':{'disabled':true}, 'minGridDistance':10}}], 'scrollbarX':{'series':['s0'], 'type':'XYChartScrollbar'}}}, {framework:'amCharts', type:'gauge', name:'Gauge', baseConfig:{'innerRadius':-20, 'titles':[{'text':''}], 'xAxes':[{'type':'ValueAxis', 'min':0, 'max':100, 'strictMinMax':true, 
'startAngle':-180, 'endAngle':0, 'axisRanges':[{'value':0, 'endValue':70, 'axisFill':{'fillOpacity':1, 'fill':'rgba(103,116,136,1)', 'zIndex':-1}}, {'value':70, 'endValue':90, 'axisFill':{'fillOpacity':1, 'fill':'rgba(225,139,80,1)', 'zIndex':-1}}, {'value':90, 'endValue':100, 'axisFill':{'fillOpacity':1, 'fill':'rgba(198,52,65,1)', 'zIndex':-1}}]}]}, amClass:'GaugeChart', selectorComponents:['analysisGaugeValueSelector', 'analysisGaugeAxesConfigurator']}, {framework:'extTable', type:'table', name:'Table', 
defaultConfig:{}, selectorComponents:['analysisTableColumnsConfigurator'], baseConfig:{name:'table'}}, {framework:'extTemplate', type:'template', name:'Template', defaultConfig:{}, configComponent:undefined, selectorComponents:['analysisTemplateConfigurator'], baseConfig:{}}]});
Ext.define('analysis.Module', {singleton:true, requires:['analysis.store.ChartType'], chartListStore:undefined, constructor:function() {
  Ext.create('analysis.store.ChartType');
  if (am4core) {
    am4core.addLicense('CH260481059');
  }
}, isJsonString:function(str) {
  try {
    JSON.stringify(str);
  } catch (e) {
    return false;
  }
  return true;
}, getFormattedQueryConfig:function(query, moduleId) {
  Ext.log(this.self.getName() + ': getFormattedQueryConfig');
  try {
    var queryConfig = {};
    var queryIndex;
    if (query && Ext.isString(query)) {
      var queryStore = Ext.data.StoreManager.lookup('analysisQuery-' + moduleId);
      queryIndex = queryStore.findExact('queryName', query);
      queryConfig = query !== -1 ? queryStore.getAt(queryIndex).getData() : {};
    } else {
      queryConfig = query.getData();
    }
    if (queryConfig) {
      if (queryConfig && queryConfig.chartConfig) {
        queryConfig.chartConfig = Ext.isObject(queryConfig.chartConfig) ? queryConfig.chartConfig : JSON.parse(queryConfig.chartConfig);
      }
      if (queryConfig && queryConfig.query) {
        queryConfig.query = Ext.isObject(queryConfig.query) ? queryConfig.query : JSON.parse(queryConfig.query);
      }
      if (queryConfig.id) {
        delete queryConfig.id;
      }
    }
    return queryConfig;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR getFormattedQueryConfig', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('analysis.assets.Colors', {singleton:true, virtimoRed:'rgba(198,52,65,1)', virtimoLightBlue:'rgba(173,191,195,0.8)', virtimoGrey:'rgba(133,144,156,0.8)', virtimoBlue:'rgba(150,190,190,1)', virtimoBlueDark5:'rgba(139,183,183)', virtimoGreen:'rgba(149,143,119,1)', virtimoLightGreen:'rgba(203,188,107,1)', virtimoOrange:'rgba(225,139,80,1)', virtimoWarmGrey:'rgba(220,217,210,1)', virtimoDarkGrey:'rgba(103,116,136,1)'});
Ext.define('analysis.assets.ConfigKeys', {singleton:true, timeseriesEmptyText:BpcCommon.lang.Current.ANALYSIS_NO_TIMESERIES_AVAILABLE, refreshIcon:'x-fal fa-refresh', stateIcon:'x-fal fa-tablet', viewIcon:'x-fal fa-tablet', downloadIcon:'x-fal fa-download', defaultSaveIcon:'x-fal fa-check', defaultCancelIcon:'x-fal fa-ban', defaultEditIcon:'x-fal fa-pencil', defaultOkIcon:'x-fal fa-check', defaultAddIcon:'x-fal fa-plus', defaultRemoveIcon:'x-fal fa-trash', defaultVersion:'default_version', selectorIcon:'x-fal fa-align-justify', 
defaultFullTextSearch:BpcCommon.lang.Current.ANALYSIS_FULL_TEXT_SEARCH, views:BpcCommon.lang.Current.ANALYSIS_QUERIES, saveCurrentView:BpcCommon.lang.Current.ANALYSIS_SAVE_CURRENT_QUERY, toolbarViewManage:BpcCommon.lang.Current.ANALYSIS_MANAGE_QUERIES, toolbarViewReset:BpcCommon.lang.Current.ANALYSIS_RESET_QUERY, saveCurrentViewAsFavorite:BpcCommon.lang.Current.ANALYSIS_SAVE_AS_FAVORITE, saveCurrentViewPopupTitle:BpcCommon.lang.Current.ANALYSIS_SAVE_VIEW, saveCurrentViewPopupText:BpcCommon.lang.Current.ANALYSIS_ENTER_VIEW_NAME + 
':', viewApply:BpcCommon.lang.Current.ANALYSIS_SEND_QUERY, viewDelete:BpcCommon.lang.Current.ANALYSIS_REMOVE_QUERY, toolbarLeftFilterDefault:BpcCommon.lang.Current.ANALYSIS_NO_FILTER_SAVED, viewStates:'view_states', moduleHeaderEnabled:'module_showHeader', dayStartHour:'day_start_hour', dayStartMinute:'day_start_minute', defaultStart:'default_start', defaultEnd:'default_end', exportPrefix:'module_exportPrefix', apiApp:'default_application', instanceDefaults:'instance_defaults', confirm:BpcCommon.lang.Current.ANALYSIS_OK, 
cancel:BpcCommon.lang.Current.ANALYSIS_CANCEL, setting_minChars:'tagfield_minChars', app:'default_application', cssHacksTsGridWithBorder:'border: 0px !important; border-right: 1px solid white!important;', cssHacksTsGrid:'border: 0px !important;', uiSearchHour:BpcCommon.lang.Current.ANALYSIS_HOUR, uiSearchMinute:BpcCommon.lang.Current.ANALYSIS_MINUTE, uiSearchFrom:BpcCommon.lang.Current.ANALYSIS_FROM, uiSearchTo:BpcCommon.lang.Current.ANALYSIS_TO, apiPrefix:'cxf/analysis', chartsConfigs:'charts_configs', 
dataSetsConfigs:'dataSets_configs', reportsConfigs:'reports_configs', catalogConfiguration:'catalogConfiguration', catalogShowAllReportsFolder:'catalog_show_all_reports_folder', sourceTypes:{ELASTICSEARCH:'elasticsearch'}, dataTypes:{LIST:'list'}, relationType:{RELATION_CHARTS_TO_DATA_SET:'chartsToDataSet', RELATION_REPORTS_TO_CHART:'reportsToChart'}});
Ext.define('analysis.assets.Helpers', {singleton:true, getDataSet:function(moduleId, dataSetId, vars, previewMode) {
  var defaultVars = this.getDefaultValuesVariables(moduleId, dataSetId);
  if (!vars) {
    vars = defaultVars;
  }
  var params = Ext.apply({}, this.varsArrayToUrlParams(vars), this.varsArrayToUrlParams(defaultVars));
  vars.previewMode = previewMode;
  return Ext.Ajax.request({method:'GET', url:analysis.assets.ConfigKeys.apiPrefix + '/data/' + moduleId + '/' + dataSetId, jsonData:{}, params:params});
}, updateSettingModel:function(moduleId, configKey, newItem) {
  var currentSettingModel = BpcCommon.Api.getSetting(moduleId, configKey, true);
  var currentSetting = currentSettingModel.get('value');
  var settingIndex = currentSetting.findIndex(function(item) {
    return item.id === newItem.id;
  });
  var newSetting;
  if (settingIndex === -1) {
    currentSetting.push(newItem);
    newSetting = Ext.clone(currentSetting);
  } else {
    newSetting = Ext.Array.replace(currentSetting, settingIndex, 1, [newItem]);
  }
  currentSettingModel.set('value', newSetting);
  return currentSettingModel;
}, getDataSetConfig:function(moduleId, dataSetId) {
  var dataSetsConfig = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.dataSetsConfigs);
  return dataSetsConfig.find(function(item) {
    return item.id === dataSetId;
  });
}, varsArrayToUrlParams:function(vars) {
  var params = {};
  if (vars) {
    params = Object.fromEntries(vars.map(function(item) {
      if (item.type === 'date') {
        var value = Ext.Date.format(new Date(item.value), item.dateformat || 'Y-m-d');
        return [item.name, value];
      }
      if (item.value) {
        return [item.name, item.value];
      }
      return [undefined, undefined];
    }));
  }
  return params;
}, getModifiedData:function(moduleId, dataSetId, currentModifierIndex, vars) {
  var defaultVars = this.getDefaultValuesVariables(moduleId, dataSetId);
  if (!vars) {
    vars = defaultVars;
  }
  var index;
  if (currentModifierIndex === 0) {
    index = 0;
  } else if (currentModifierIndex && currentModifierIndex > 0) {
    index = currentModifierIndex;
  } else {
    index = -1;
  }
  var params = Ext.apply({}, this.varsArrayToUrlParams(vars), this.varsArrayToUrlParams(defaultVars));
  return Ext.Ajax.request({method:'POST', url:analysis.assets.ConfigKeys.apiPrefix + '/data/' + moduleId + '/' + dataSetId + '/modify', params:params, jsonData:{currentModifierIndex:index}});
}, getAllModifiers:function(moduleId, dataSetId) {
  var dataSetConfig = this.getDataSetConfig(moduleId, dataSetId);
  if (!dataSetConfig) {
    return null;
  }
  return dataSetConfig.modifiers;
}, showCentralWarningTextComponentsList:function(wrapperCmp) {
  if (!wrapperCmp.noElementSelectedTextCmp) {
    var msgCmp = {xtype:'bpcCenterMessageCmp', message:'CORE_NO_COMPONENT_AVAILABLE'};
    wrapperCmp.noElementSelectedTextCmp = wrapperCmp.add(msgCmp);
  }
  wrapperCmp.setActiveItem(wrapperCmp.noElementSelectedTextCmp);
}, getDefaultValuesVariables:function(moduleId, dataSetId) {
  var vars = [];
  var dataSetConfig = this.getDataSetConfig(moduleId, dataSetId);
  if (dataSetConfig) {
    vars = this.getDataSetConfig(moduleId, dataSetId).variables || [];
  }
  return vars;
}, setActiveUrl:function(moduleId, moduleRouteArray) {
  var baseModulRoute = ['analysis', moduleId, '', ''];
  var route = baseModulRoute.concat(moduleRouteArray);
  BpcCommon.Api.updateRouteWithChangeCheck('/module', route, undefined, true);
}, getChartConfiguration:function(moduleId, chartId) {
  var setting = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.chartsConfigs, false);
  if (!setting) {
    return {};
  }
  return setting.find(function(item) {
    return parseInt(item.id) === parseInt(chartId);
  });
}, getRawDataFromStore:function(store) {
  if (!store || !store.isStore) {
    return [];
  }
  return store.getRange().map(function(el) {
    return el.getData();
  });
}, getChartListStore:function(moduleId) {
  return Ext.data.StoreManager.lookup(moduleId + 'ChartListStore');
}, getSingleChart:function(moduleId, chartId) {
  var $jscomp$this = this;
  if (!moduleId) {
    return {};
  }
  var chartList = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.chartsConfigs, false);
  return chartList.find(function(el) {
    return $jscomp$this.compareIds(chartId, el.id);
  }) || {};
}, getChartName:function(moduleId, chartId) {
  var foundChart = this.getSingleChart(moduleId, chartId);
  return foundChart.name || BpcCommon.Api.getTranslation('ANALYSIS_UNKNOWN_CHART');
}, getChartVariables:function(moduleId, chartId, asDefault) {
  asDefault = asDefault === void 0 ? false : asDefault;
  var dataSet = this.getChartDataSet(moduleId, chartId);
  if (!dataSet) {
    return [];
  }
  if (!dataSet.id) {
    return [];
  }
  if (!asDefault) {
    return dataSet.variables;
  }
  var defaultVariables = this.getDefaultValuesVariables(moduleId, dataSet.id);
  return defaultVariables || [];
}, getChartDataSet:function(moduleId, chartId) {
  var dataSetId = this.getSingleChart(moduleId, chartId).dataSetId || '';
  return this.getSingleDataSet(moduleId, dataSetId);
}, getDataSetListStore:function(moduleId) {
  return Ext.data.StoreManager.lookup(moduleId + 'DataSetListStore');
}, getSingleDataSet:function(moduleId, dataSetId) {
  var $jscomp$this = this;
  if (!moduleId) {
    return {};
  }
  var dataSetList = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.dataSetsConfigs, false);
  return dataSetList.find(function(el) {
    return $jscomp$this.compareIds(dataSetId, el.id);
  }) || {};
}, getReportListStore:function(moduleId) {
  return Ext.data.StoreManager.lookup(moduleId + 'ReportListStore');
}, getSingleReport:function(moduleId, reportId) {
  var $jscomp$this = this;
  if (!moduleId) {
    return {};
  }
  var reportList = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.reportsConfigs, false);
  return reportList.find(function(el) {
    return $jscomp$this.compareIds(reportId, el.id);
  }) || {};
}, saveSingleReport:function(moduleId, reportData) {
  var reportId = reportData.id;
  if (!reportId || !moduleId) {
    return false;
  }
  var settingsName = analysis.assets.ConfigKeys.reportsConfigs;
  var settingsModel = BpcCommon.Api.getSetting(moduleId, settingsName, true);
  var reportList = settingsModel.get('value');
  var index = reportList.findIndex(function(el) {
    return el.id === reportId;
  });
  reportList.splice(index, 1, reportData);
  settingsModel.set('value', reportList);
  settingsModel.save({success:function() {
    BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('CORE_OK'));
  }, failure:function() {
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_CHART_LIST_CONFIG_SAVE_FAILURE')});
  }});
}, getReportAllDataSetVariables:function(moduleId, reportId) {
  var $jscomp$this = this;
  var foundReport = this.getSingleReport(moduleId, reportId);
  var allDataSetVariablesList = [];
  if (foundReport === {}) {
    return [];
  }
  var reportCharts = foundReport.charts;
  if (!Ext.isArray(reportCharts)) {
    return [];
  }
  reportCharts.forEach(function(chart) {
    var dataSet = $jscomp$this.getChartDataSet(moduleId, chart.chartID);
    var chartData = $jscomp$this.getSingleChart(moduleId, chart.chartID);
    var variablesList = dataSet.variables;
    if (Ext.isArray(variablesList)) {
      variablesList.forEach(function(dataSetVariable) {
        var singleVariable = Ext.clone(dataSetVariable);
        singleVariable.association = {connectedChartId:'' + chart.id, variableId:singleVariable.id};
        delete singleVariable.id;
        singleVariable.chartId = chartData.id;
        singleVariable.chartName = chartData.name;
        singleVariable.composedName = singleVariable.chartName + '_' + singleVariable.name;
        allDataSetVariablesList.push(singleVariable);
      });
    }
  });
  return allDataSetVariablesList;
}, getGlobalReportVariables:function() {
  return [{name:'globalDateRangeStart', value:this.getGlobalVariableValue('globalRelativeStartDate'), type:'date', globalId:'globalRelativeStartDate'}, {name:'globalDateRangeEnd', value:this.getGlobalVariableValue('globalRelativeEndDate'), type:'date', globalId:'globalRelativeEndDate'}, {name:'bpcUserName', value:this.getGlobalVariableValue('globalBpcUserName'), type:'text', globalId:'globalBpcUserName'}];
}, getGlobalVariableValue:function(key) {
  var value;
  switch(key) {
    case 'globalRelativeStartDate':
      value = BpcCommon.Api.getGlobalViewModel().get('global.dateRange.value.preview.start');
      break;
    case 'globalRelativeEndDate':
      value = BpcCommon.Api.getGlobalViewModel().get('global.dateRange.value.preview.end');
      break;
    case 'globalBpcUserName':
      value = BpcCommon.Api.getUserName();
      break;
    default:
      value = '';
      break;
  }
  return value;
}, getGlobalVariable:function(globalId) {
  var globalList = this.getGlobalReportVariables();
  return globalList.find(function(el) {
    return el.globalId === globalId;
  });
}, setGlobalVariablesValuesList:function(globalsList) {
  var me = this;
  if (!Ext.isArray(globalsList)) {
    return [];
  }
  var retList = Ext.clone(globalsList);
  Ext.each(retList, function(el) {
    el.value = me.getGlobalVariableValue(el.globalId);
  });
  return retList;
}, getTypeMatchingGlobalVariables:function(type) {
  var typeMatchingList = this.getGlobalReportVariables().filter(function(el) {
    return el.type === type;
  });
  var stringList = [];
  Ext.each(typeMatchingList, function(variable) {
    stringList.push(variable.globalId);
  });
  return stringList;
}, capitalizeFirstLetter:function(string) {
  return string[0].toUpperCase() + string.slice(1);
}, compareIds:function(id1, id2) {
  if (!id1 || !id2) {
    return false;
  }
  return id1.toString() === id2.toString();
}, isTypeAmChart:function(chartType) {
  var chartTypeStore = Ext.StoreManager.lookup('analysisChartType');
  if (!chartTypeStore) {
    return false;
  }
  var foundRecord = chartTypeStore.findRecord('type', chartType);
  if (!foundRecord) {
    return false;
  }
  var frameWork = foundRecord.get('framework');
  return frameWork === 'amCharts';
}, isObjectEmpty:function(obj) {
  if (Ext.isObject(obj) === false) {
    return true;
  }
  if (Object.entries(obj).length === 0) {
    return true;
  }
  return false;
}});
Ext.define('analysis.assets.Icons', {singleton:true, iconPrefix:'x-fal fa-', pieChartIcon:'chart-pie-alt', xyChartIcon:'chart-line', tableChartIcon:'table', gaugeChartIcon:'tachometer-alt-slow', templateChartIcon:'code', folderIcon:'folder-open', reportIcon:'file-image-o', getChartTypeIcon:function(chartType) {
  if (!chartType) {
    return '';
  }
  var ret = '';
  switch(chartType) {
    case 'xy':
      ret = this.wrapIcon(this.xyChartIcon);
      break;
    case 'pie':
      ret = this.wrapIcon(this.pieChartIcon);
      break;
    case 'gauge':
      ret = this.wrapIcon(this.gaugeChartIcon);
      break;
    case 'table':
      ret = this.wrapIcon(this.tableChartIcon);
      break;
    case 'template':
      ret = this.wrapIcon(this.templateChartIcon);
      break;
    default:
  }
  return ret;
}, wrapIcon:function(iconCls) {
  var icon = this.iconPrefix + iconCls;
  return '\x3ca class \x3d "' + icon + '"\x3e\x3c/a\x3e ';
}, wrapXLIcon:function(iconCls) {
  var icon = this.iconPrefix + iconCls + ' fa-5x';
  return '\x3ca class \x3d "' + icon + '"\x3e\x3c/a\x3e ';
}, getIconCls:function(iconCls) {
  return this.iconPrefix + iconCls;
}, getXLFolderIcon:function() {
  return this.wrapXLIcon(this.folderIcon);
}, getFolderIconCls:function() {
  return this.getIconCls(this.folderIcon);
}, getReportIconCls:function() {
  return this.getIconCls(this.reportIcon);
}, catalog:'x-fal fa-folder-tree', reports:'x-fal fa-file-signature', charts:'x-fal fa-analytics', datasets:'x-fal fa-database', variableAssociation:'x-fal fa-project-diagram', oneToOneAssociation:'x-fal fa-map-signs'});
Ext.define('analysis.components.AnalysisColorPicker', {extend:'Ext.ux.colorpick.Field', alias:'widget.analysisColorPicker', format:'rgba', alphaDecimalFormat:'#.##', isInit:true, listeners:{change:function(el, val) {
  if (el.isInit) {
    el.isInit = false;
  } else {
    el.fireEvent('colorSelect', el, val);
  }
}}});
Ext.define('analysis.components.AnalysisDateFormatSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisDateFormatSelector', localized:{fieldLabel:'ANALYSIS_DATE_INPUT_FORMAT'}, store:['yyyy-MM-dd HH:mm:ss'], editable:true});
Ext.define('analysis.components.AnalysisFieldSet', {extend:'Ext.form.FieldSet', alias:'widget.analysisFieldSet', layout:{type:'vbox', align:'stretch'}, collapsible:true, matchFieldWidth:true, padding:20});
Ext.define('analysis.components.AnalysisInstancePicker', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisInstancePicker', localized:{fieldLabel:'ANALYSIS_INSTANCE_SELECTOR_COMBO_LABEL', emptyText:'ANALYSIS_INSTANCE_SELECTOR_COMBO_EMPTY_TEXT'}, labelWidth:200, margin:'0 20px 10px 10px', displayField:'instanceName', valueField:'moduleId', forceSelection:true, initComponent:function() {
  this.fillStore();
  this.callParent();
}, fillStore:function() {
  var instancesStore = BpcCommon.Api.getModuleInstances('analysis');
  var rawData = analysis.assets.Helpers.getRawDataFromStore(instancesStore);
  this.store = rawData;
}});
Ext.define('analysis.components.AnalysisOrganisationSelector', {extend:'BpcCommon.component.form.field.rightsRolesOrganisations.OrganisationsTagField', alias:'widget.analysisOrganisationSelector', localized:{fieldLabel:'ANALYSIS_ORGANISATIONS_SELECTOR_FIELD_LABEL', emptyText:'ANALYSIS_ORGANISATIONS_SELECTOR_EMPTY_TEXT'}, initComponent:function() {
  this.callParent();
}});
Ext.define('analysis.components.AnalysisRightsSelector', {extend:'BpcCommon.component.form.field.rightsRolesOrganisations.RightsTagField', alias:'widget.analysisRightsSelector', localized:{fieldLabel:'ANALYSIS_RIGHTS_SELECTOR_FIELD_LABEL', emptyText:'ANALYSIS_RIGHTS_SELECTOR_EMPTY_TEXT'}, initComponent:function() {
  this.callParent();
}});
Ext.define('analysis.components.AnalysisRolesSelector', {extend:'BpcCommon.component.form.field.rightsRolesOrganisations.RolesSelectTagField', alias:'widget.analysisRolesSelector', localized:{fieldLabel:'ANALYSIS_ROLES_SELECTOR_FIELD_LABEL', emptyText:'ANALYSIS_ROLES_SELECTOR_EMPTY_TEXT'}, initComponent:function() {
  this.callParent();
}});
Ext.define('analysis.components.AnalysisValueField', {extend:'Ext.container.Container', alias:'widget.analysisValueField', layout:{type:'vbox', align:'stretch'}, readOnly:false, formField:undefined, initComponent:function() {
  var me = this;
  me.defaults = {fieldLabel:BpcCommon.Api.getTranslation('CORE_VALUE')};
  me.items = [{xtype:'bpcTextField', typeAttr:'text', listeners:{change:me.onChangeValue.bind(me)}, bind:{hidden:"{record.type !\x3d\x3d 'text'}", disabled:"{record.type !\x3d\x3d 'text'}", value:'{record.value}'}}, {xtype:'bpcNumberField', typeAttr:'number', listeners:{change:me.onChangeValue.bind(me)}, bind:{hidden:"{record.type !\x3d\x3d 'number'}", disabled:"{record.type !\x3d\x3d 'number'}", value:'{record.value}'}}, {xtype:'bpcComboBox', typeAttr:'boolean', listeners:{change:me.onChangeValue.bind(me)}, 
  store:[true, false], bind:{hidden:"{record.type !\x3d\x3d 'boolean'}", disabled:"{record.type !\x3d\x3d 'boolean'}", value:'{record.value}'}}, {xtype:'bpcDateField', typeAttr:'date', listeners:{change:me.onChangeValue.bind(me)}, bind:{hidden:"{record.type !\x3d\x3d 'date'}", disabled:"{record.type !\x3d\x3d 'date'}", value:'{record.value}'}}, {xtype:'bpcComboBox', typeAttr:'list', listeners:{change:me.onChangeValue.bind(me)}, bind:{hidden:"{record.type !\x3d\x3d 'list'}", disabled:"{record.type !\x3d\x3d 'list'}", 
  value:'{record.value}'}}];
  this.callParent();
}, onChangeValue:function(cmp, newValue, prevValue) {
  if (this.record.get('type') === cmp.typeAttr) {
    if (prevValue !== null) {
      this.fireEvent('customChange');
    }
  }
}});
Ext.define('analysis.model.QueryModel', {extend:'Ext.data.Model', fields:[{name:'queryName', defaultValue:'query' + Date.now(), type:'string'}, {name:'xtype', defaultValue:'analysisChart', type:'string'}, {name:'index', type:'string'}, {name:'type', type:'string'}, {name:'query', type:'string', defaultValue:JSON.stringify({'size':100, 'query':{'bool':{'must_not':[], 'should':[], 'must':[{'match_all':{}}]}}, 'aggs':{'Status':{'terms':{field:'STATUS'}}}}, null, '\t'), convert:function(val) {
  if (Ext.isString(val)) {
    return JSON.stringify(JSON.parse(val), null, 4);
  }
  return JSON.stringify(val, null, 4);
}}, {name:'recordFn', type:'string'}, {name:'chartConfig', type:'string', defaultValue:JSON.stringify({}), convert:function(val) {
  if (Ext.isString(val)) {
    return JSON.stringify(JSON.parse(val), null, 4);
  } else if (Ext.isArray(val)) {
    var value = [];
    Ext.Array.each(val, function(config) {
      if (Ext.isString(config)) {
        value.push(JSON.parse(config));
      } else {
        value.push(config);
      }
    });
    return JSON.stringify(value, null, 4);
  }
  return JSON.stringify(val, null, 4);
}}, {name:'dataPaths', defaultValue:[]}]});
Ext.define('analysis.model.ReportChartsModel', {extend:'BpcCommon.component.data.ObservableModel', fields:[{name:'title', type:'string', defaultValue:''}, {name:'id', type:'string'}, {name:'chartID', type:'number', defaultValue:''}, {name:'variables', defaultValue:[]}, {name:'additionalParameters', defaultValue:{}}]});
Ext.define('analysis.model.ReportVariableAssociationModel', {extend:'BpcCommon.component.data.ObservableModel', fields:[{name:'id', type:'string'}, {name:'variableId', type:'number'}, {name:'connectedChartId', type:'number'}]});
Ext.define('analysis.model.ReportVariablesModel', {extend:'BpcCommon.component.data.ObservableModel', fields:[{name:'id', type:'string'}, {name:'name', defaultValue:'Report Variable', type:'string'}, {name:'type', defaultValue:'number', type:'string'}, {name:'value', defaultValue:''}, {name:'association', defaultValue:[]}, {name:'userVisibility', defaultValue:true}, {name:'externalSource', type:'boolean', defaultValue:false}, {name:'globalId', type:'string', defaultValue:''}, {name:'amountAssociations', 
type:'number', defaultValue:0, convert:function(data, record) {
  return record.get('association').length;
}, depends:['association']}], validators:{name:{type:'length', min:1}, type:{type:'inclusion', list:['number', 'text', 'boolean', 'bool', 'list', 'date']}}});
Ext.define('analysis.model.TableColumnsModel', {extend:'BpcCommon.component.data.ObservableModel', fields:[{name:'id', type:'string'}, {name:'text', defaultValue:'Column Header', type:'string'}, {name:'dataIndex', defaultValue:'', type:'string'}, {name:'flex', defaultValue:1, type:'number'}, {name:'additionalParameters', defaultValue:{flex:1, style:''}}]});
Ext.define('BPC.model.ViewState', {extend:'Ext.data.Model', fields:[{name:'id', type:'int'}, {name:'state'}, {name:'name'}], proxy:{type:'rest', url:'/bpc-core/storage/analysis_view_state', reader:{type:'json'}, writer:{type:'json', writeAllFields:true}}});
Ext.define('analysis.model.XYSeriesModel', {extend:'Ext.data.Model', fields:[{name:'type', defaultValue:'ColumnSeries', type:'string'}, {name:'xAttr', defaultValue:'timestamp', type:'string'}, {name:'yAttr', defaultValue:'value', type:'string'}]});
Ext.define('analysis.store.AbstractInstanceStore', {extend:'Ext.data.Store', moduleId:'', constructor:function(config) {
  config.storeId = this.config.storeId + '-' + config.moduleId;
  this.callParent(arguments);
}});
Ext.define('analysis.store.Chart', {extend:'analysis.store.AbstractInstanceStore', storeId:'analysisChart', data:[{id:1, name:'Chart 1'}, {id:2, name:'Chart  2'}, {id:3, name:'Chart  3'}, {id:4, name:'Chart  4'}]});
Ext.define('analysis.store.DataSource', {extend:'analysis.store.AbstractInstanceStore', storeId:'analysisDataSource', data:[{id:1, name:'Data Source 1'}, {id:2, name:'Data Source 2'}, {id:3, name:'Data Source 3'}, {id:4, name:'Data Source 4'}]});
Ext.define('analysis.store.Index', {extend:'analysis.store.AbstractInstanceStore', storeId:'analysisIndex', proxy:{type:'ajax', url:'cxf//analysis/analysis/indices', reader:{type:'json'}}});
Ext.define('analysis.store.Query', {extend:'analysis.store.AbstractInstanceStore', storeId:'analysisQuery', autoLoad:true, model:'analysis.model.QueryModel', proxy:{type:'ajax', url:'cxf/analysis/analysis/getSavedQueries', reader:{type:'json'}}, listeners:{load:function(store, records, successful) {
  if (successful) {
    Ext.GlobalEvents.fireEvent('queryStoreLoaded', records);
  }
}}});
Ext.define('analysis.store.ReportTree', {extend:'Ext.data.TreeStore', storeId:'analysisReportTree', constructor:function(config) {
  config.storeId = this.config.storeId + '-' + config.moduleId;
  config = Ext.apply({root:BpcCommon.Api.getSetting(config.moduleId, analysis.assets.ConfigKeys.catalogConfiguration)}, config);
  this.callParent([config]);
}, reloadTreeStore:function() {
  Ext.log(this.self.getName() + ': reloadTreeStore');
  try {
    var me = this;
    var root = BpcCommon.Api.getSetting(me.moduleId, analysis.assets.ConfigKeys.catalogConfiguration);
    me.setRoot(root);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR reloadTreeStore', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('analysis.Store.ViewType', {extend:'Ext.data.Store', storeId:'analysisViewType', data:[{id:'table', name:'Tabelle', iconCls:'x-fal fa-table', xtype:'grid', defaultConfiguration:{}}, {id:'linechart', name:'Linien Diagramm', iconCls:'x-fal fa-chart-line', xtype:'', defaultConfiguration:{}}, {id:'barchart', name:'Balken Diagramm', iconCls:'x-fal fa-chart-bar', xtype:'', defaultConfiguration:{}}, {id:'piechart', name:'Kuchen Diagramm', iconCls:'x-fal fa-chart-pie', xtype:'', defaultConfiguration:{}}]});
Ext.define('analysis.view.AnalysisModuleHeader', {extend:'Ext.toolbar.Toolbar', alias:'widget.analysisModuleHeader', layout:{type:'hbox', pack:'end', align:'stretch'}, overflowHandler:'scroller', moduleId:undefined, initComponent:function() {
  Ext.log(this.self.getName() + ': initComponent');
  try {
    this.items = [{xtype:'toolbar', itemId:'stateButtons', overflowHandler:'scroller', items:[], hidden:false, flex:2, defaults:{enableToggle:true, toggleGroup:'analysisHeaderFavs', tooltip:BpcCommon.Api.getTranslation('ANALYSIS_APPLY_VIEW')}}];
    this.callParent();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}, updateViewModelItem:function(item, value) {
  Ext.log(this.self.getName() + ': updateViewModel');
  try {
    this.getViewModel().set(item, value);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateViewModel', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('analysis.view.Main', {extend:'Ext.panel.Panel', alias:'widget.bpcAnalysis', controller:'analysisController', layout:'fit', margin:'3 0 0 0 ', stateful:true, stateId:'analysis-', bpcSkipStateInjection:true, globalStoreClasses:['analysis.Store.ViewType'], store:[], viewModel:true, items:[], moduleId:undefined, initComponent:function() {
  var me = this;
  if (me.moduleId) {
    me.defaults = {moduleId:me.moduleId};
    me.stateId = me.stateId + me.moduleId;
  }
  me.loadStoresFromSettings();
  me.callParent(arguments);
  Ext.Deferred.all([lazyLoad.AmCharts(), lazyLoad.DOMPurify()]).then(function() {
    me.add({xtype:'analysisMain', moduleType:'module'});
    me.updateInstance(me.moduleCfg, me.moduleRoute);
  });
}, updateInstance:function(moduleCfg, routeArray) {
  var me = this;
  try {
    if (routeArray && Ext.isArray(routeArray) && routeArray.length !== 0) {
      var editorType = routeArray[0];
      var editorId = routeArray[1];
      if (editorType === 'data') {
        me.jumpTo('analysisDataSetEditorContainer', editorId);
      } else if (editorType === 'chart') {
        me.jumpTo('analysisChartEditorContainer', editorId);
      } else if (editorType === 'report') {
        me.jumpTo('analysisReportEditorContainer', editorId);
      } else if (editorType === 'catalog') {
        me.jumpTo('analysisCatalogViewerContainer', editorId);
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateInstance', dump:e, stack:true, level:'error'});
  }
}, loadStoresFromSettings:function() {
  var dataSetListSetting = BpcCommon.Api.getSetting(this.moduleId, analysis.assets.ConfigKeys.dataSetsConfigs);
  var dataSetListStore = Ext.create('Ext.data.Store', {storeId:this.moduleId + 'DataSetListStore', autoLoad:true, model:'analysis.view.dataSetEditor.dataSetConfigForm.DataSetModel'});
  dataSetListStore.setData(dataSetListSetting);
  var chartListSetting = BpcCommon.Api.getSetting(this.moduleId, analysis.assets.ConfigKeys.chartsConfigs);
  var chartListStore = Ext.create('Ext.data.Store', {storeId:this.moduleId + 'ChartListStore', autoLoad:true, model:'analysis.view.chartEditor.chartConfigForm.ChartModel'});
  chartListStore.setData(chartListSetting);
  var reportListSetting = BpcCommon.Api.getSetting(this.moduleId, analysis.assets.ConfigKeys.reportsConfigs);
  var reportListStore = Ext.create('Ext.data.Store', {storeId:this.moduleId + 'ReportListStore', autoLoad:true, model:'analysis.view.reportEditor.reportConfigForm.ReportModel'});
  reportListStore.setData(reportListSetting);
}, addAmChartLicense:function() {
  am4core.addLicense('CH260481059');
}, jumpTo:function(cmpType, id) {
  var me = this;
  var mainView = me.down('analysisMain');
  if (!mainView) {
    return;
  }
  var targetCmp = mainView.down(cmpType);
  if (!targetCmp) {
    Ext.log({level:'error', message:'No such component with xtype: ' + cmpType});
  } else {
    mainView.setActiveItem(targetCmp);
    if (id) {
      var listView = targetCmp.down("[cmpType\x3d'listItems']");
      var activeRecord = listView.getStore().findRecord('id', id);
      listView.setSelection(activeRecord);
    }
  }
}});
Ext.define('analysis.view.MainController', {extend:'Ext.app.ViewController', alias:'controller.analysisController', control:{'[routePath]':{show:'updateUrl', activate:'updateUrl', afterrender:'updateUrl'}}, updateUrl:function(currentView) {
  var moduleId = currentView.up('bpcAnalysis').moduleId;
  var getPreviousPathEls = function(view, pathEls) {
    var parentCmp = view.up('[routePath]');
    if (parentCmp && parentCmp.routePath && parentCmp.routePath !== 'analysis') {
      pathEls.unshift(parentCmp.routePath);
      getPreviousPathEls(parentCmp, pathEls);
    } else {
      return pathEls;
    }
  };
  var getFollowingPathEls = function(view, pathEls) {
    var childCmps;
    if (view.query('[routePath]:visible').length !== 0) {
      childCmps = view.query('[routePath]:visible');
    } else {
      childCmps = view.query('[routePath]');
    }
    var childCmp;
    for (var $jscomp$iter$0 = $jscomp.makeIterator(childCmps), $jscomp$key$cmp = $jscomp$iter$0.next(); !$jscomp$key$cmp.done; $jscomp$key$cmp = $jscomp$iter$0.next()) {
      var cmp = $jscomp$key$cmp.value;
      {
        var parentCmp = cmp.up('[routePath]');
        if (parentCmp.id === view.id) {
          childCmp = cmp;
        }
      }
    }
    if (childCmp && childCmp.routePath) {
      pathEls.push(childCmp.routePath);
      getFollowingPathEls(childCmp, pathEls);
    } else {
      return pathEls;
    }
  };
  var pathEls = [currentView.routePath];
  getPreviousPathEls(currentView, pathEls);
  getFollowingPathEls(currentView, pathEls);
  analysis.assets.Helpers.setActiveUrl(moduleId, pathEls);
}});
Ext.define('analysis.view.shared.SharedView', {extend:'Ext.tab.Panel', alias:'widget.analysisMain', itemId:'sharedView', moduleType:undefined, stateful:true, stateId:undefined, tabPosition:'left', tabRotation:0, rightToEditDataSet:false, rightToEditChart:false, rightToEditReport:false, rightToEditCatalog:false, viewModel:{data:{globalLiveUpdate:true}}, initComponent:function() {
  this.defaults = {moduleId:this.moduleId};
  this.stateId = this.xtype + '-' + this.moduleId;
  this.checkUserRightsRolesOrganisations();
  this.on('afterrender', this.onAfterRender, this);
  var items = [];
  if (Ext.isDefined(this.moduleType)) {
    if (this.moduleType === 'module') {
      items = [{xtype:'analysisCatalogViewerContainer', iconCls:'x-fal fa-folder-tree', localized:{tooltip:'ANALYSIS_CATALOG_VIEWER_TOOLTIP'}, rightToEdit:this.rightToEditCatalog}, {xtype:'analysisReportEditorContainer', iconCls:'x-fal fa-file-signature', localized:{tooltip:'ANALYSIS_REPORT_EDITOR_TOOLTIP'}, hidden:!this.rightToEditReport}, {xtype:'analysisChartEditorContainer', iconCls:'x-fal fa-analytics', routePath:'chart', localized:{tooltip:'ANALYSIS_CHART_EDITOR_TOOLTIP'}, hidden:!this.rightToEditChart}, 
      {xtype:'analysisDataSetEditorContainer', iconCls:'x-fal fa-database', routePath:'data', localized:{tooltip:'ANALYSIS_DATA_SET_EDITOR_TOOLTIP'}, hidden:!this.rightToEditDataSet}];
    }
  } else {
    items = [{xtype:'box', html:BpcCommon.Api.getTranslation('ANALYSIS_ERROR_NO_MODULE_OR_WIDGET')}];
  }
  this.items = items;
  this.callParent(arguments);
}, checkUserRightsRolesOrganisations:function() {
  this.rightToEditDataSet = BpcCommon.Api.hasUserRight('analysisEditDataSet') || BpcCommon.Api.hasUserRole('analysisDataSetEditor') || BpcCommon.Api.hasUserOrganisation('analysisDataSetEditors');
  this.rightToEditChart = BpcCommon.Api.hasUserRight('analysisEditChart') || BpcCommon.Api.hasUserRole('analysisChartEditor') || BpcCommon.Api.hasUserOrganisation('analysisChartEditors');
  this.rightToEditReport = BpcCommon.Api.hasUserRight('analysisEditReport') || BpcCommon.Api.hasUserRole('analysisReportEditor') || BpcCommon.Api.hasUserOrganisation('analysisReportEditors');
  this.rightToEditCatalog = BpcCommon.Api.hasUserRight('analysisEditCatalog') || BpcCommon.Api.hasUserRole('analysisCatalogEditor') || BpcCommon.Api.hasUserOrganisation('analysisCatalogEditors');
}, onAfterRender:function() {
  this.layout.setActiveItem(0);
}});
Ext.define('analysis.view.catalogViewer.CatalogViewerContainer', {extend:'Ext.panel.Panel', alias:'widget.analysisCatalogViewerContainer', layout:{type:'hbox', align:'stretch'}, viewModel:{data:{}}, routePath:'catalog', initComponent:function() {
  this.items = [{xtype:'analysisCatalogViewerTree', split:true, collapsible:true, collapseDirection:'left', minWidth:300, width:300, mainReference:this, moduleId:this.moduleId, rightToEdit:this.rightToEdit}, {xtype:'bpcSplitter'}, {xtype:'panel', flex:3, itemId:'analysisCatalogViewerWrapper', items:[], mainReference:this, moduleId:this.moduleId, layout:'fit'}];
  this.callParent();
}});
Ext.define('analysis.view.catalogViewer.catalogViewerTree.CatalogViewerTree', {extend:'Ext.tree.Panel', alias:'widget.analysisCatalogViewerTree', itemId:'analysisCatalogViewerTree', controller:'analysisCatalogViewerTreeController', cmpType:'listItems', rightToEdit:undefined, selModel:{mode:'SINGLE'}, layout:'fit', rootVisible:false, viewConfig:{markDirty:false, plugins:{treeviewdragdrop:{}}}, sortableColumns:false, localized:{title:'ANALYSIS_CATALOG_TREE_TITLE'}, minButtonWidth:30, buttons:undefined, 
initComponent:function() {
  var me = this;
  var sheet = window.document.styleSheets[0];
  sheet.insertRule('.catalog-tree-element-disabled {\n         visibility: hidden !important;\n      }', sheet.cssRules.length);
  me.store = Ext.create('Ext.data.TreeStore', {storeId:'analysisCatalogTreeStore'});
  me.columns = [{xtype:'treecolumn', dataIndex:'name', flex:1}, {xtype:'actioncolumn', width:80, hidden:!this.rightToEdit, items:[{iconCls:BpcCommon.Icons.ADD, tooltip:BpcCommon.Api.getTranslation('ANALYSIS_CATALOG_ADD_REPORT_BUTTON'), handler:'addReport', getClass:function(v, meta, rec) {
    if (rec.get('treeType') === 'report' || rec.get('parentId') === 'allReportsFolder' || rec.get('id') === 'allReportsFolder') {
      return 'catalog-tree-element-disabled';
    }
    return BpcCommon.Icons.ADD;
  }}, {iconCls:'x-fal fa-folder-plus', ui:'secondary', tooltip:BpcCommon.Api.getTranslation('ANALYSIS_CATALOG_ADD_FOLDER_BUTTON'), handler:'addFolder', getClass:function(v, meta, rec) {
    if (rec.get('treeType') === 'report' || rec.get('parentId') === 'allReportsFolder' || rec.get('id') === 'allReportsFolder') {
      return 'catalog-tree-element-disabled';
    }
    return 'x-fal fa-folder-plus';
  }}, {iconCls:BpcCommon.Icons.DELETE, tooltip:BpcCommon.Api.getTranslation('CORE_DELETE'), handler:'deleteElement', getClass:function(v, meta, rec) {
    if (rec.get('treeType') === 'rootNode' || rec.get('parentId') === 'allReportsFolder' || rec.get('id') === 'allReportsFolder') {
      return 'catalog-tree-element-disabled';
    }
    return BpcCommon.Icons.DELETE;
  }}]}];
  me.buttons = [{iconCls:'x-fal fa-sync', localized:{tooltip:'ANALYSIS_REFRESH', text:'ANALYSIS_REFRESH'}, handler:'onRefreshCatalog'}, {xtype:'button', ui:'primary', localized:{tooltip:'CORE_SAVE', text:'CORE_SAVE'}, iconCls:BpcCommon.Icons.SAVE, handler:'onSave'}];
  this.callParent();
}});
Ext.define('analysis.view.catalogViewer.catalogViewerTree.CatalogViewerTreeController', {extend:'Ext.app.ViewController', alias:'controller.analysisCatalogViewerTreeController', control:{'analysisCatalogViewerTree':{afterrender:'onAfterRender', select:'onSelect', beforedrop:'onBeforeDrop'}}, listen:{}, onAfterRender:function() {
  this.initiateStore();
}, reselectReport:function() {
  var view = this.getView();
  var selectedRecord = this.getTreeSelection();
  view.setSelection(false);
  view.setSelection(selectedRecord);
}, getTreeSelection:function() {
  var view = this.getView();
  var selection = view.getSelection();
  return Ext.isArray(selection) ? selection[0] : 0;
}, initiateStore:function() {
  var me = this;
  var view = me.getView();
  var moduleId = view.moduleId;
  var treeStore = view.getStore();
  var setting = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.catalogConfiguration, false);
  if (!setting) {
    return;
  }
  var allReportsFolderExpanded = false;
  var allReportsFolder = treeStore.findRecord('internId', 'allReportsFolder');
  if (allReportsFolder) {
    allReportsFolderExpanded = allReportsFolder.get('expanded');
  }
  treeStore.setRoot(setting);
  view.expandAll();
  me.addAllReportsFolder(allReportsFolderExpanded);
  var firstReportNode = treeStore.findNode('treeType', 'report');
  if (firstReportNode) {
    view.setSelection(firstReportNode);
  } else if (view.getRootNode().firstChild) {
    view.setSelection(view.getRootNode().firstChild);
  }
}, onSelect:function(rowModel, record) {
  var view = this.getView();
  var catalogViewer = view.up().down('#analysisCatalogViewerWrapper');
  var selectionType = record.get('treeType');
  var isUiCollapsed = record.get('isUiCollapsed');
  if (isUiCollapsed === undefined || isUiCollapsed === null) {
    isUiCollapsed = true;
  }
  var renderItems = this.selectRenderItems(selectionType, record, isUiCollapsed);
  var renderCmp = {xtype:'container', padding:0, layout:{type:'hbox', align:'stretch'}, routePath:record.get('id'), items:renderItems, mainReference:view.mainReference};
  catalogViewer.removeAll();
  record.catalogViewer = catalogViewer.add([renderCmp]);
}, selectRenderItems:function(selectionType, record, isUiCollapsed) {
  var view = this.getView();
  var moduleId = view.moduleId;
  var reportId = record.get('reportId');
  var reportData = analysis.assets.Helpers.getSingleReport(moduleId, reportId);
  var rightTotEdit = view.rightToEdit;
  var renderItems;
  switch(selectionType) {
    case 'report':
      renderItems = [{xtype:'analysisExternalReportViewer', moduleId:view.moduleId, reportData:reportData, margin:0, flex:3}, {xtype:'bpcSplitter', itemId:'reportSettingsSplitter', collapseTarget:'next'}, {xtype:'analysisCatalogReportUI', record:record, collapsible:true, collapsed:isUiCollapsed, collapseDirection:'right', flex:1, moduleId:view.moduleId, mainReference:view.mainReference, hidden:!rightTotEdit}];
      record.expand(true);
      break;
    case 'chart':
      renderItems = [{xtype:'analysisChartViewer', chartConfig:record.get('config'), moduleId:view.moduleId, minWidth:500}, {xtype:'panel', title:'ui'}];
      break;
    case 'folder':
      renderItems = [{xtype:'container', flex:3, layout:'fit', items:[{xtype:'analysisFolderCenterPanel'}]}, {xtype:'bpcSplitter', itemId:'folderSettingsSplitter', collapseTarget:'next'}, {xtype:'analysisCatalogFolderUI', collapsible:true, collapseDirection:'right', collapsed:isUiCollapsed, record:record, moduleId:view.moduleId, flex:1, hidden:!rightTotEdit}];
      break;
    case 'rootNode':
      renderItems = [{xtype:'container', flex:3, layout:'fit', items:[{xtype:'analysisFolderCenterPanel'}]}];
      break;
  }
  return renderItems;
}, onRefreshCatalog:function() {
  var view = this.getView();
  var selection = this.getTreeSelection();
  if (!Ext.isObject(selection)) {
    this.initiateStore();
    return;
  }
  var rawStoreData = analysis.assets.Helpers.getRawDataFromStore(view.getStore());
  var selectionIndex = rawStoreData.findIndex(function(el) {
    return el.id === selection.get('id');
  });
  if (selection.get('treeType') !== 'report') {
    this.initiateStore();
    view.setSelection(selectionIndex);
    return;
  }
  try {
    var catalogContainer = view.mainReference;
    var reportViewer = catalogContainer.down('analysisExternalReportViewer');
    var reportData = reportViewer.reportData;
    var layout = reportData.layout;
    if (layout === 'tab') {
      var tabPanel = reportViewer.down('tabpanel');
      var activeTab = tabPanel.getActiveTab();
      var activeTabIndex = tabPanel.items.items.findIndex(function(el) {
        return el === activeTab;
      });
      this.initiateStore();
      view.setSelection(selectionIndex);
      reportViewer = catalogContainer.down('analysisExternalReportViewer');
      tabPanel = reportViewer.down('tabpanel');
      tabPanel.setActiveTab(activeTabIndex);
      return;
    }
    this.initiateStore();
    view.setSelection(selectionIndex);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR catalog selection', dump:e, stack:true, level:'error'});
  }
}, onSave:function() {
  var view = this.getView();
  var store = view.getStore();
  var settingModel = BpcCommon.Api.getSetting(view.moduleId, analysis.assets.ConfigKeys.catalogConfiguration, true);
  var settingData = store.getRoot().serialize();
  settingData = this.removeAllReportsFolder(settingData);
  settingModel.set('value', settingData);
  settingModel.save({success:function() {
    BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('ANALYSIS_CATALOG_SUCCESSFUL_SAVE'));
  }, failure:function(record, operation) {
    var error = operation.error;
    try {
      var response = JSON.parse(error.response.responseText);
      BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
    } catch (err) {
      Ext.log({level:'error', message:'Save Catalog error'});
    }
  }});
}, onBeforeDrop:function(node, data, overModel) {
  if (Ext.isArray(data.records)) {
    var dropRecord = data.records[0];
    var newReport = {id:Date.now(), reportId:dropRecord.get('reportId'), treeType:dropRecord.get('treeType'), name:dropRecord.get('name'), leaf:dropRecord.get('leaf')};
    var allReportsId = 'allReportsFolder';
    if (dropRecord) {
      var parentId = dropRecord.get('parentId');
      if (overModel.get('parentId') === allReportsId || overModel.get('id') === allReportsId) {
        return false;
      }
      if (parentId === allReportsId) {
        if (overModel.isLeaf() === true) {
          overModel.parentNode.insertBefore(newReport, overModel);
        } else {
          overModel.appendChild(newReport);
        }
        return false;
      }
    }
  }
}, addAllReportsFolder:function(expanded) {
  expanded = expanded === void 0 ? false : expanded;
  var me = this;
  var view = me.getView();
  var moduleId = view.moduleId;
  var treeStore = view.getStore();
  var showAllReportsFolder = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.catalogShowAllReportsFolder, false);
  if (!showAllReportsFolder) {
    return;
  }
  var reportList = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.reportsConfigs, false);
  var reportFiles = [];
  if (Ext.isArray(reportList)) {
    reportList.forEach(function(el) {
      reportFiles.push({reportId:el.id, treeType:'report', dynamic:true, name:el.name, leaf:true, parentId:'allReportsFolder'});
    });
  }
  var allReportFolder = {leaf:false, name:'All Reports', parentId:'root', id:'allReportsFolder', expanded:expanded, treeType:'rootNode', dynamic:true, internId:'allReportsFolder', children:reportFiles};
  var rootNode = treeStore.getRootNode();
  var existingFolder = treeStore.findNode('id', 'allReportsFolder');
  if (existingFolder) {
    treeStore.remove(existingFolder);
  }
  rootNode.appendChild(allReportFolder);
}, removeAllReportsFolder:function(rootNode) {
  var allReportFolderIndex = rootNode.children.findIndex(function(el) {
    return el.id === 'allReportsFolder';
  });
  if (allReportFolderIndex >= -1) {
    rootNode.children.splice(allReportFolderIndex);
  }
  return rootNode;
}, addReport:function(cmp, val) {
  var view = this.getView();
  view.setSelection(val);
  var newReport = {name:'newReport', leaf:true, treeType:'report', isUiCollapsed:false};
  this.addItem(newReport);
}, addFolder:function(cmp, val) {
  var view = this.getView();
  view.setSelection(val);
  var newFolder = {name:'Folder', leaf:false, treeType:'folder', expanded:true, isUiCollapsed:false};
  this.addItem(newFolder);
}, addItem:function(newItem) {
  var view = this.getView();
  newItem.id = Date.now().toString();
  var selection = view.getSelection();
  var parentNode = undefined;
  if (selection.length === 0 || selection[0].parentNode === null) {
    parentNode = view.getRootNode().getChildAt(0);
  } else {
    if (selection[0].isLeaf()) {
      parentNode = selection[0].parentNode;
    } else {
      parentNode = selection[0];
    }
  }
  var addedItem = parentNode.appendChild(newItem);
  view.setSelection(addedItem);
}, deleteElement:function(view, rowIndex, colIndex, item, e, record) {
  if (record.isRoot()) {
    return;
  }
  Ext.Msg.show({msg:BpcCommon.Api.getTranslation('ANALYSIS_DELETE_CATALOG_ELEMENT_CONFIRM_TEXT') + '\x3cbr/\x3e ' + BpcCommon.Api.getTranslation('ANALYSIS_DELETE_CATALOG_ELEMENT_CONFIRM_TEXT_2'), buttons:Ext.Msg.YESNO, title:BpcCommon.Api.getTranslation('ANALYSIS_DELETE_CATALOG_ELEMENT_CONFIRM_TITLE'), fn:function(buttonValue) {
    if (buttonValue === 'yes') {
      if (record.isLeaf()) {
        record.remove();
      } else {
        record.removeAll();
        record.remove();
      }
    }
  }});
}});
Ext.define('analysis.view.catalogViewer.components.ChartSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisCatalogChartSelector', localized:{fieldLabel:'ANALYSIS_CATALOG_CHART_SELECTOR_FIELD_LABEL', emptyText:'ANALYSIS_CHART_SELECTOR_EMPTY_TEXT'}, displayField:'name', valueField:'id', forceSelection:true, moduleId:undefined, store:undefined, initComponent:function() {
  this.createStore();
  this.callParent();
  this.showAmountReports();
}, createStore:function() {
  if (!this.moduleId) {
    return;
  }
  var chartList = BpcCommon.Api.getSetting(this.moduleId, analysis.assets.ConfigKeys.chartsConfigs, false);
  this.store = chartList;
}, showAmountReports:function() {
  var chartList = analysis.assets.Helpers.getRawDataFromStore(this.store);
  var amountCharts = chartList.length;
  var emptyString = '' + amountCharts + BpcCommon.Api.getTranslation('ANALYSIS_AMOUNT_FOUND_CHARTS_EMPTY_TEXT');
  this.setEmptyText(emptyString);
}});
Ext.define('analysis.view.catalogViewer.components.FolderCenterPanel', {extend:'Ext.panel.Panel', alias:'widget.analysisFolderCenterPanel', record:undefined, fieldSetCmp:undefined, layout:'fit', localized:{title:'ANALYSIS_CATALOG_FOLDER'}, frameHeader:true, items:[{xtype:'bpcCenterMessageCmp', message:analysis.assets.Icons.getXLFolderIcon()}], initComponent:function() {
  this.callParent();
}});
Ext.define('analysis.view.catalogViewer.components.FolderUI', {extend:'Ext.panel.Panel', alias:'widget.analysisCatalogFolderUI', items:undefined, record:undefined, fieldSetCmp:undefined, layout:'fit', localized:{title:'ANALYSIS_CATALOG_FOLDER_SETTINGS_TITLE'}, initComponent:function() {
  this.callParent();
  this.createItems();
  this.on('afterrender', this.onAfterRender, this);
  this.on('collapse', this.onCollapse, this);
  this.on('expand', this.onExpand, this);
}, onExpand:function() {
  this.record.set('isUiCollapsed', false);
}, onCollapse:function() {
  this.record.set('isUiCollapsed', true);
}, onAfterRender:function() {
  this.add(this.panelCmp);
}, createItems:function() {
  var initName = this.record.get('name');
  this.folderNameField = Ext.create({xtype:'bpcTextField', localized:{fieldLabel:'ANALYSIS_FOLDER_NAME'}, value:initName, enableKeyEvents:true, listeners:{keyup:this.onChangeName.bind(this)}});
  this.fieldSetCmp = {xtype:'analysisFieldSet', items:[this.folderNameField], moduleId:this.moduleId, localized:{title:'ANALYSIS_DATASET_BASIC_SETTINGS'}};
  this.panelCmp = {xtype:'container', items:[this.fieldSetCmp]};
}, createButtons:function() {
  return [{xtype:'button', ui:'primary', localized:{text:'CORE_DELETE'}, iconCls:'fal fa-trash', handler:this.onDeleteRecord.bind(this)}, {xtype:'button', ui:'primary', localized:{text:'CORE_SAVE'}, iconCls:'fal fa-save', handler:this.onSaveConfiguration.bind(this)}];
}, onSaveConfiguration:function() {
  var newName = this.folderNameField.getValue();
  this.record.set('name', newName);
}, onDeleteRecord:function() {
}, onChangeName:function(el) {
  this.record.set('isUiCollapsed', true);
  this.record.set('name', el.value);
}});
Ext.define('analysis.view.catalogViewer.components.ReportSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisCatalogReportSelector', localized:{fieldLabel:'ANALYSIS_CATALOG_REPORT_SELECTOR_FIELD_LABEL', emptyText:'ANALYSIS_REPORT_SELECTOR_EMPTY_TEXT'}, displayField:'name', valueField:'id', forceSelection:true, moduleId:undefined, store:undefined, initComponent:function() {
  this.createStore();
  this.callParent();
  this.showAmountReports();
}, createStore:function() {
  if (!this.moduleId) {
    return;
  }
  var reportList = BpcCommon.Api.getSetting(this.moduleId, analysis.assets.ConfigKeys.reportsConfigs, false);
  this.store = reportList;
}, showAmountReports:function() {
  var reportList = analysis.assets.Helpers.getRawDataFromStore(this.store);
  var amountReports = reportList.length;
  var emptyString = '' + amountReports + BpcCommon.Api.getTranslation('ANALYSIS_AMOUNT_FOUND_REPORTS_EMPTY_TEXT');
  this.setEmptyText(emptyString);
}});
Ext.define('analysis.view.catalogViewer.components.ReportUI', {extend:'Ext.panel.Panel', alias:'widget.analysisCatalogReportUI', items:undefined, layout:'fit', record:undefined, fieldSetCmp:undefined, UIFieldWidth:100, localized:{title:'ANALYSIS_CATALOG_REPORT_SETTINGS_TITLE'}, initComponent:function() {
  this.callParent();
  this.createItems();
  this.on('afterrender', this.addPanel, this);
  this.on('collapse', this.onCollapse, this);
  this.on('expand', this.onExpand, this);
}, onExpand:function() {
  this.record.set('isUiCollapsed', false);
}, onCollapse:function() {
  this.record.set('isUiCollapsed', true);
}, addPanel:function() {
  this.add(this.panelCmp);
}, createItems:function() {
  var initName = this.record.get('name');
  var reportId = this.record.get('reportId') || '';
  this.reportNameField = Ext.create({xtype:'bpcTextField', fieldLabel:BpcCommon.Api.getTranslation('ANALYSIS_REPORT_TITLE'), value:initName, width:this.UIFieldWidth, emptyText:'Title', enableKeyEvents:true, listeners:{keyup:this.onChangeName.bind(this)}});
  this.reportSelector = Ext.create({xtype:'analysisCatalogReportSelector', moduleId:this.moduleId, value:reportId, width:this.UIFieldWidth, listeners:{change:this.onReportSelection.bind(this)}});
  this.fieldSetCmp = {xtype:'analysisFieldSet', items:[this.reportNameField, this.reportSelector], localized:{title:'ANALYSIS_DATASET_BASIC_SETTINGS'}};
  this.panelCmp = {xtype:'container', items:[this.fieldSetCmp]};
}, createButtons:function() {
  return [{xtype:'button', ui:'primary', localized:{text:'CORE_DELETE'}, iconCls:'fal fa-trash'}, {xtype:'button', ui:'primary', localized:{text:'CORE_SAVE'}, iconCls:'fal fa-save', handler:this.onSaveConfiguration.bind(this)}];
}, onReportSelection:function(el, reportId) {
  this.record.set('reportId', reportId);
  var tree = this.up('analysisCatalogViewerContainer').down('analysisCatalogViewerTree');
  if (tree) {
    var controller = tree.getController();
    setTimeout(function() {
      if (Ext.isFunction(controller.reselectReport)) {
        controller.reselectReport();
      }
    }, 100);
  }
  this.setReportCollapsed();
}, setReportCollapsed:function() {
  this.record.set('isUiCollapsed', true);
}, onChangeName:function(el) {
  this.record.set('name', el.value);
  this.setReportCollapsed();
}, onSaveConfiguration:function() {
  var catalogData = this.record.getData();
  var reportId = catalogData.reportId;
  var moduleId = this.mainReference.moduleId;
  var reportData = analysis.assets.Helpers.getSingleReport(moduleId, reportId);
  var newReportData = Ext.apply(reportData, catalogData);
  analysis.assets.Helpers.saveSingleReport(moduleId, newReportData);
}});
Ext.define('analysis.view.chartEditor.ChartEditor', {extend:'Ext.panel.Panel', alias:'widget.analysisChartEditor', controller:'analysisChartEditorController', layout:{type:'hbox', align:'stretch'}, scrollable:true, viewModel:{data:{record:undefined, loadedDataSet:undefined, dataNotLoadedFlag:true}}, chartConfig:undefined, routePath:':chartId', chartConfigCmp:undefined, chartPreviewCmp:undefined, attrKeyStore:undefined, defaultChartStore:undefined, initComponent:function() {
  this.chartId = this.record.id;
  this.routePath = this.record.id;
  this.callParent();
  var vm = this.getViewModel();
  vm.set('record', this.record);
  this.createItems();
  this.add([this.chartConfigCmp, {xtype:'bpcSplitter', collapseTarget:'next'}, this.chartPreviewCmp]);
  this.on('afterrender', this.onAfterRender.bind(this));
}, createItems:function() {
  this.chartConfigCmp = Ext.create({xtype:'analysisChartConfigForm', localized:{title:'ANALYSIS_CHART_CONFIGURATION'}, viewModel:{parent:this.getViewModel()}, flex:1, split:true, moduleId:this.moduleId, mainReference:this});
  this.chartPreviewCmp = Ext.create({localized:{title:'ANALYSIS_PREVIEW'}, xtype:'analysisChartPreViewer', viewModel:{parent:this.getViewModel()}, flex:1, collapsible:true, collapsed:false, collapseDirection:'right', moduleId:this.moduleId, mainReference:this});
}, onAfterRender:function() {
  var me = this;
  var vm = me.getViewModel();
  vm.bind('{record.config}', this.onRecordChanged, this, {deep:true});
  vm.bind('{record.dataSetId}', this.onDataSetChanged, this);
  this.listenOnDataLoad();
  this.createAttributeKeyStore();
  this.createDefaultChartStore();
}, listenOnDataLoad:function() {
  if (this.chartPreviewCmp) {
    this.chartPreviewCmp.chartViewer.on('successDataLoad', this.onSuccessDataLoad, this);
  }
}, onSuccessDataLoad:function() {
  if (this.chartPreviewCmp && this.chartPreviewCmp.chartViewer) {
    var vm = this.getViewModel();
    var loadedDataSet = this.chartPreviewCmp.chartViewer.dataSet || [];
    vm.set('loadedDataSet', loadedDataSet);
    vm.set('dataNotLoadedFlag', false);
    this.fillAttributeKeyStore();
  }
}, onDataSetChanged:function() {
  if (this.chartPreviewCmp && this.chartPreviewCmp.chartViewer) {
    this.getViewModel().set('dataNotLoadedFlag', true);
    this.chartPreviewCmp.chartViewer.reloadData();
  }
}, onRecordChanged:function() {
  var liveUpdate = this.getViewModel().get('globalLiveUpdate');
  if (liveUpdate === false) {
    return;
  }
  if (this.chartPreviewCmp) {
    this.chartPreviewCmp.chartViewer.chartConfig = this.getViewModel().get('record').getData();
    this.chartPreviewCmp.chartViewer.reconfigureChart();
  }
}, createDefaultChartStore:function() {
  this.defaultChartStore = Ext.create('Ext.data.Store', {proxy:{type:'memory', reader:{type:'json'}, autoload:true}});
  this.fillDefaultChartStore();
}, fillDefaultChartStore:function() {
  var vm = this.getViewModel();
  var chartType = vm.get('record.chartType');
  var defaultCharts = BpcCommon.Api.getSetting('analysis', 'defaultCharts');
  var specificChartDefaults = defaultCharts[chartType] || [];
  this.defaultChartStore.loadRawData(specificChartDefaults);
}, loadDefaultChartconfig:function(defaultConfiguration) {
  var vm = this.getViewModel();
  vm.set('record.config', defaultConfiguration);
  this.chartConfigCmp.updateSpecificChartCmp();
}, createAttributeKeyStore:function() {
  this.attrKeyStore = Ext.create('Ext.data.Store', {fields:[{name:'attr', type:'string'}], proxy:{type:'memory', reader:{type:'json'}, autoload:true}});
}, fillAttributeKeyStore:function() {
  var dataKeys = this.getAttributeKeyTypes().allAttributes;
  this.attrKeyStore.loadRawData(dataKeys);
}, getAttributeKeyTypes:function() {
  var me = this;
  var firstEntry = me.getFirstDataEntry();
  var allAttributes = [];
  var stringAttributes = [];
  var numberAttributes = [];
  Ext.Array.each(Ext.Object.getAllKeys(firstEntry), function(el) {
    var attrEl = {attr:el};
    allAttributes.push(attrEl);
    var dataType = typeof firstEntry[el];
    if (dataType === 'string') {
      stringAttributes.push(attrEl);
    } else if (dataType === 'number') {
      numberAttributes.push(attrEl);
    }
  });
  return {allAttributes:allAttributes, stringAttributes:stringAttributes, numberAttributes:numberAttributes};
}, getFirstDataEntry:function() {
  var me = this;
  var vm = me.getViewModel();
  var chartData = vm.get('loadedDataSet') || [];
  var inputDataType = typeof chartData;
  var chartDataType;
  if (inputDataType === 'object') {
    chartDataType = Ext.isArray(chartData) ? 'array' : 'object';
  } else if (inputDataType === 'number' || inputDataType === 'string') {
    chartDataType = 'singleValue';
  }
  var attributeObject = {};
  switch(chartDataType) {
    case 'object':
      attributeObject = chartData;
      break;
    case 'array':
      attributeObject = chartData[0];
      break;
    case 'singleValue':
      attributeObject = {singleValue:chartData};
  }
  return attributeObject;
}});
Ext.define('analysis.view.chartEditor.ChartEditorContainer', {extend:'Ext.panel.Panel', alias:'widget.analysisChartEditorContainer', itemId:'analysisChartEditorContainer', layout:{type:'hbox', align:'stretch'}, viewModel:{data:{}}, routePath:'chart', initComponent:function() {
  this.defaults = {moduleId:this.moduleId};
  this.items = [{xtype:'analysisChartList', split:true, collapsible:true, collapseDirection:'left', width:300, minWidth:300}, {xtype:'bpcSplitter'}, {xtype:'panel', layout:'card', itemId:'analysisChartEditorWrapper', flex:3, items:[]}];
  this.callParent();
}});
Ext.define('analysis.view.chartEditor.ChartEditorController', {extend:'Ext.app.ViewController', alias:'controller.analysisChartEditorController', setNewGeneralConfig:function(newGeneralChart) {
  var me = this;
  var vm = me.getViewModel();
  vm.set('record', newGeneralChart);
  me.updateChart();
}, getPieSeries:function() {
  var me = this;
  var vm = me.getViewModel();
  var chartSeries = vm.get('record.config.series');
  var output = [];
  Ext.Array.each(chartSeries, function(el) {
    var flatSerie = {type:el.type, category:el.dataFields.category, value:el.dataFields.value};
    output.push(flatSerie);
  });
  return output;
}, setPieSeries:function(newSeries) {
  var me = this;
  var vm = me.getViewModel();
  var config = vm.get('record.config');
  var nestedSeries = [];
  Ext.Array.each(newSeries, function(el) {
    var Serie = {type:el.type, dataFields:{category:el.category, value:el.value}};
    nestedSeries.push(Serie);
  });
  var chartConfig = Ext.Object.merge(config, {series:nestedSeries});
  me.setNewConfiguration(chartConfig);
}, getXAxesDataIndex:function() {
  var me = this;
  var xAxesType = me.getXAxesType();
  var dataIndex;
  switch(xAxesType) {
    case 'DateAxis':
      dataIndex = 'dateX';
      break;
    case 'ValueAxis':
      dataIndex = 'valueX';
      break;
    case 'CategoryAxis':
      dataIndex = 'categoryX';
      break;
    default:
      dataIndex = '';
  }
  return dataIndex;
}, getXYSeries:function() {
  var me = this;
  var vm = me.getView().getViewModel();
  var chartSeries = vm.get('record.config.series');
  var seriesDataAttribute = me.getXAxesDataIndex();
  var output = [];
  if (!Ext.isArray(chartSeries)) {
    return output;
  }
  Ext.Array.each(chartSeries, function(el) {
    var flatSerie = {type:el.type, categoryX:el.dataFields[seriesDataAttribute], valueY:el.dataFields.valueY};
    output.push(flatSerie);
  });
  return output;
}, getXYAxes:function() {
  var view = this.getView();
  var vm = view.getViewModel();
  var xAxes = vm.get('record.config.xAxes');
  var yAxes = vm.get('record.config.yAxes');
  return {xAxes:xAxes, yAxes:yAxes};
}, getXAxesType:function() {
  var me = this;
  var axesConfiguration = me.getXYAxes();
  return axesConfiguration.xAxes[0].type || '';
}, getYAxesType:function() {
  var axesConfiguration = this.getXYAxes();
  return axesConfiguration.yAxes[0].type || '';
}, setXYAxes:function(axesConfig) {
  var me = this;
  var config = this.getChartConfiguration();
  var newConfig = Ext.Object.merge(config, {});
  me.setNewConfiguration(newConfig);
}, changeXYAxes:function(newConfig) {
  var me = this;
  var existingConfig = me.getXYAxes();
  if (!Ext.isArray(existingConfig[newConfig.axisType])) {
    return;
  }
  switch(newConfig.axisAttribute) {
    case 'title':
      existingConfig[newConfig.axisType][0].title.text = newConfig.value;
      break;
    case 'value':
      existingConfig[newConfig.axisType][0].type = newConfig.value;
      break;
  }
  me.setXYAxes(existingConfig);
}, getChartConfiguration:function() {
  var view = this.getView();
  var vm = view.getViewModel();
  return Ext.clone(vm.get('record.config'));
}, setNewConfiguration:function(chartConfig) {
  var view = this.getView();
  var vm = view.getViewModel();
  vm.set('record.config', chartConfig);
}, updateChart:function() {
  var me = this;
  var view = me.getView();
  var chartViewComponent = view.up().down('#analysisChartPreViewer');
  chartViewComponent.fireEvent('updateChart');
}, getChartData:function() {
  var view = this.getView();
  var vm = view.getViewModel();
  return vm.get('record.config.data');
}, setChartData:function(responseData) {
  var vm = this.getViewModel();
  var view = this.getView();
  vm.set('record.config.data', responseData);
  view.chartConfigCmp.fireEvent('ChangeDataSet');
  view.chartPreviewCmp.fireEvent('ChangeDataSet');
  view.fillAttributeKeyStore();
}, loadServerData:function() {
  var me = this;
  var view = me.getView();
  var vm = view.getViewModel();
  var moduleId = view.moduleId;
  var dataSetId = vm.get('record.dataSetId');
  if (!dataSetId || !view) {
    return 0;
  }
  view.mask(BpcCommon.Api.getTranslation('ANALYSIS_LOADING_DATA'));
  analysis.assets.Helpers.getModifiedData(moduleId, dataSetId, false, false).then({success:function(response) {
    var responseData = Ext.decode(response.responseText);
    BpcCommon.Api.showNotification({text:'Loaded ' + responseData.length + 'Datasets'});
    me.setChartData(responseData);
    view.unmask();
  }, failure:function() {
    view.unmask();
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_LOADING_DATA_FAILURE'), type:'error'});
  }});
}, setDefaultChartConfig:function(defaultConfig) {
  this.setNewConfiguration(defaultConfig);
}, getChartSeries:function() {
  var vm = this.getView().getViewModel();
  var chartSeries = vm.get('record.config.series');
  if (!Ext.isArray(chartSeries)) {
    return [];
  }
  return chartSeries;
}, setChartSeries:function(newSeries) {
  var config = this.getChartConfiguration();
  config.series = newSeries;
  this.setNewConfiguration(config);
}, mergeChartSeries:function(newSeries) {
  var oldSeries = this.getChartSeries();
  var mergedSeries = [];
  newSeries.forEach(function(el, idx) {
    var serie;
    if (oldSeries[idx]) {
      serie = Ext.Object.merge(oldSeries[idx], el);
    } else {
      serie = el;
    }
    mergedSeries.push(serie);
  });
  this.setChartSeries(mergedSeries);
}, replaceChartSerie:function(serie, index) {
  var me = this;
  var config = this.getChartConfiguration();
  var oldSeries = config.series;
  var newSeries = Ext.Array.replace(oldSeries, index, 1, [serie]);
  var chartConfig = Ext.Object.merge(config, {series:newSeries});
  me.setNewConfiguration(chartConfig);
}, convertXYSeries:function(series) {
  if (!Ext.isArray(series) || series.length === 0 || series[0] === undefined) {
    return [];
  }
  var xAttribute = '', yAttribute = '';
  var xAxesType = this.getXAxesType();
  switch(xAxesType) {
    case 'DateAxis':
      xAttribute = 'dateX';
      break;
    case 'ValueAxis':
      xAttribute = 'valueX';
      break;
    case 'CategoryAxis':
      xAttribute = 'categoryX';
      break;
  }
  var yAxesType = this.getYAxesType();
  switch(yAxesType) {
    case 'DateAxis':
      yAttribute = 'dateY';
      break;
    case 'ValueAxis':
      yAttribute = 'valueY';
      break;
    case 'CategoryAxis':
      yAttribute = 'categoryY';
      break;
  }
  series.forEach(function(el, idx) {
    var xDataAttr = el['xAttr'] || '';
    var yDataAttr = el['yAttr'] || '';
    var newDataFields = {};
    newDataFields[xAttribute] = xDataAttr;
    newDataFields[yAttribute] = yDataAttr;
    el.dataFields = newDataFields;
    el.id = 's' + idx;
    delete el.xAttr;
    delete el.yAttr;
  });
  return series;
}});
Ext.define('analysis.view.chartEditor.chartConfigForm.ChartConfigForm', {extend:'Ext.form.Panel', alias:'widget.analysisChartConfigForm', controller:'analysisChartConfigFormController', scrollable:true, viewModel:{data:{}, formulas:{hasUnsavedChanges:{bind:{bindTo:'{record}', deep:true}, get:function(record) {
  return record ? record.dirty : false;
}}}}, layout:{type:'vbox', align:'stretch'}, bodyPadding:10, routePath:'editor', buttons:undefined, generalConfigCmp:undefined, specificChartCmp:undefined, initComponent:function() {
  this.createButtons();
  this.callParent();
  this.on('afterrender', this.onAfterRender, this);
}, onAfterRender:function() {
  this.generalConfigCmp = this.createGeneralConfig();
  this.specificChartCmp = this.createSpecificChartUI();
  this.add(this.generalConfigCmp, this.specificChartCmp);
}, createButtons:function() {
  var itemArray = [{xtype:'toggleslidefield', localized:{fieldLabel:'ANALYSIS_LIVE_UPDATE_FIELD_LABEL'}, labelAlign:'top', labelWidth:40, bind:{value:'{globalLiveUpdate}'}}, {iconCls:'x-fal fa-exclamation-triangle warningColor', ui:'apptoolbardefault', localized:{text:'ANALYSIS_UNSAVED_CHANGES', tooltip:' ANALYSIS_UNSAVED_CHANGES'}, bind:{hidden:'{!record.dirty}'}, handler:'onSave'}, '-\x3e', {xtype:'button', localized:{text:'ANALYSIS_VIEW_DATA'}, iconCls:'fal fa-database', ui:'secondary', bind:{disabled:'{dataNotLoadedFlag}'}, 
  handler:this.openDataView.bind(this)}, {xtype:'button', localized:{text:'ANALYSIS_TEST_QUERY'}, iconCls:'fal fa-play', ui:'secondary', handler:this.applyChartConfig.bind(this)}, {xtype:'button', ui:'secondary', tooltip:BpcCommon.Api.getTranslation('CORE_REFRESH'), iconCls:'fal fa-sync', handler:this.reloadData.bind(this), margin:10}, {xtype:'button', ui:'primary', localized:{text:'CORE_SAVE'}, iconCls:'fal fa-save', handler:'onSave', margin:10}];
  this.dockedItems = [{xtype:'toolbar', dock:'bottom', ui:'footer', overflowHandler:'scroller', items:itemArray}];
}, openDataView:function() {
  this.detailConfigCmp = Ext.create({xtype:'analysisDataDetailPanel', mainReference:this.mainReference});
  this.detailWindow = Ext.create('BpcCommon.component.window.Window', {items:[this.detailConfigCmp], localized:{title:'ANALYSIS_CHART_EDITOR_DATA_WINDOW_TITLE'}, listeners:{}});
}, createGeneralConfig:function() {
  return Ext.create({xtype:'analysisGeneralChartConfig', moduleId:this.moduleId, mainReference:this.mainReference, viewModel:{parent:this.getViewModel()}, listeners:{ChangeChartType:this.onChangeChartType.bind(this)}});
}, onChangeChartType:function() {
  this.mainReference.fillDefaultChartStore();
  this.loadBaseConfiguration();
  this.updateSpecificChartCmp();
}, loadBaseConfiguration:function() {
  var vm = this.mainReference.getViewModel();
  var chartType = vm.get('record.chartType');
  var baseConfig = Ext.data.StoreManager.lookup('analysisChartType').findRecord('type', chartType).get('baseConfig');
  vm.set('record.config', baseConfig);
}, updateSpecificChartCmp:function() {
  var cmpIndex = this.items.indexOf(this.specificChartCmp);
  this.remove(this.specificChartCmp);
  this.specificChartCmp = this.createSpecificChartUI();
  if (cmpIndex !== -1) {
    this.insert(cmpIndex, this.specificChartCmp);
  }
}, createSpecificChartUI:function() {
  return Ext.create({xtype:'analysisSpecificChartConfigurator', mainReference:this.mainReference, viewModel:{parent:this.getViewModel()}});
}, reloadData:function() {
  this.mainReference.onDataSetChanged();
}, applyChartConfig:function() {
  this.mainReference.onRecordChanged();
}});
Ext.define('analysis.view.chartEditor.chartConfigForm.ChartConfigFormController', {extend:'Ext.app.ViewController', alias:'controller.analysisChartConfigFormController', onSave:function() {
  var view = this.getView();
  var mainReference = view.mainReference;
  var vm = mainReference.getViewModel();
  var moduleId = mainReference.moduleId;
  var record = vm.get('record');
  if (!view.isValid()) {
    BpcCommon.Api.showNotification({text:'Validierung fehlgeschlagen', popUp:true, type:'error'});
    return;
  }
  return record.saveChart(moduleId, {success:function() {
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_CHART_LIST_CONFIG_SAVED')});
    record.save();
  }, failure:function() {
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_CHART_LIST_CONFIG_SAVE_FAILURE')});
  }});
}, changeDataSet:function(el, value) {
  var me = this;
  var view = me.getView();
  var controller = view.up('analysisChartEditor').getController();
  controller.setChartData(value);
}, openCodeView:function() {
  var me = this;
  var view = me.getView();
  var mainReference = view.mainReference;
  var vm = mainReference.getViewModel();
  var config = vm.get('record.config');
  Ext.create({title:BpcCommon.Api.getTranslation('ANALYSIS_CODE_TITLE'), xtype:'bpcCodeEditorWindow.json', context:vm, initValue:config, readOnly:false, setting:'record', onApplyChange:me.saveCodeView.bind(me)});
}, saveCodeView:function(el) {
  var editorContent = el.up('bpcCodeEditorWindow').editor.getValue();
  var newConfig = JSON.parse(editorContent);
  this.getView().up('analysisChartEditor').getController().setNewConfiguration(newConfig);
  el.up('bpcCodeEditorWindow').close();
}});
Ext.define('analysis.view.chartEditor.chartConfigForm.ChartModel', {extend:'Ext.data.Model', idProperty:'id', fields:[{name:'id', type:'string'}, {name:'name', type:'string'}, {name:'chartType', type:'string'}, {name:'dataSetId', type:'string'}, {name:'config', defaultValue:{}}], proxy:{type:'memory'}, saveChart:function(moduleId, handlers) {
  var newSetting = this.getData();
  if (moduleId) {
    var newSettingModel = analysis.assets.Helpers.updateSettingModel(moduleId, analysis.assets.ConfigKeys.chartsConfigs, newSetting);
    newSettingModel.save(handlers);
  }
}});
Ext.define('analysis.view.chartEditor.chartConfigForm.DataDetailPanel', {extend:'Ext.panel.Panel', alias:'widget.analysisDataDetailPanel', layout:'fit', jsonFieldCmp:undefined, UICmp:undefined, mainReference:undefined, initComponent:function() {
  var me = this;
  me.createJSONFieldComponent();
  me.items = [this.jsonFieldCmp];
  me.buttons = [{iconCls:'x-fal fa-sync', handler:me.reloadData.bind(me)}];
  me.callParent();
}, reloadData:function() {
  this.mainReference.chartPreviewCmp.chartViewer.reloadData();
  this.remove(this.jsonFieldCmp);
  this.createJSONFieldComponent();
  this.add(this.jsonFieldCmp);
}, createDataUI:function() {
  this.variablesGridCmp = Ext.create({xtype:'analysisContextVariablesGrid', dataSetId:this.mainReference.getViewModel().get('record.dataSetId'), moduleId:this.mainReference.moduleId, refresh:this.onVariablesChange.bind(this), listeners:{onDataChange:this.onVariablesChange.bind(this)}});
  this.UICmp = Ext.create({xtype:'analysisFieldSet', items:[this.variablesGridCmp], layout:'fit'});
}, onVariablesChange:function() {
  var variablesGrid = this.variablesGridCmp;
  var variablesGridStore = variablesGrid.getStore();
  var variablesGridStoreData = analysis.assets.Helpers.getRawDataFromStore(variablesGridStore);
  this.mainReference.chartPreviewCmp.chartViewer.setDataVariables(variablesGridStoreData);
}, createJSONFieldComponent:function() {
  var loadedData = this.mainReference.getViewModel().get('loadedDataSet');
  this.jsonFieldCmp = Ext.create({xtype:'bpcJsonField', editorConfigs:{readOnly:true}, value:loadedData, layout:'fit', editable:false});
}});
Ext.define('analysis.view.chartEditor.chartConfigForm.GeneralConfig', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisGeneralChartConfig', layout:{type:'vbox', align:'stretch'}, maxHeight:220, localized:{title:'ANALYSIS_DATASET_BASIC_SETTINGS'}, viewModel:{data:{record:undefined}}, itemId:'generalChartConfigFieldSet', mainReference:undefined, detailWindow:undefined, detailConfigCmp:undefined, chartNameSel:undefined, chartTypeSel:undefined, dataSetSel:undefined, defaultChartSel:undefined, 
initComponent:function() {
  this.defaults = {moduleId:this.moduleId};
  this.createGeneralConfig();
  this.items = [{xtype:'fieldcontainer', layout:'hbox', items:[this.chartNameSel, this.chartTypeSel]}, {xtype:'fieldcontainer', layout:'hbox', items:[this.dataSetSel, this.defaultChartSel]}];
  this.callParent();
  this.on('afterrender', this.onAfterRender, this);
}, onAfterRender:function() {
}, createGeneralConfig:function() {
  var me = this;
  var vm = this.mainReference.getViewModel();
  var chartType = vm.get('record.chartType');
  var isAmChart = analysis.assets.Helpers.isTypeAmChart(chartType);
  this.defaultChartSel = Ext.create({xtype:'analysisDefaultChartConfigSelector', chartType:vm.get('record.chartType'), mainReference:this.mainReference, labelWidth:100, flex:1, margin:'0 0 0 10'});
  this.chartNameSel = Ext.create({xtype:'bpcTextField', localized:{fieldLabel:'ANALYSIS_CHART_NAME_SELECTOR_FIELD_LABEL'}, allowBlank:false, value:vm.get('record.name'), labelWidth:100, flex:1, margin:'0 0 0  10', itemId:'generalConfigChartNameInputField', listeners:{change:this.onchangeChartName.bind(this)}});
  this.chartTypeSel = Ext.create('analysis.view.chartEditor.components.chartTypeSelector', {localized:{fieldLabel:'ANALYSIS_CHART_TYPE'}, value:vm.get('record.chartType'), listeners:{change:this.onChartTypeChange.bind(this)}, labelWidth:100, flex:1, margin:'0 0 0 10', triggers:{openDetail:{hidden:!isAmChart, cls:'x-fal fa-cogs', handler:me.openDetailView.bind(me), weight:-2, itemId:'generalConfigOpenDetailTrigger', tooltip:BpcCommon.Api.getTranslation('ANALYSIS_ADVANCED_SETTINGS')}}, itemId:'generalConfigChartTypeCombobox'});
  this.dataSetSel = Ext.create({xtype:'analysisDataSetSelector', moduleId:me.moduleId, localized:{fieldLabel:'ANALYSIS_CHART_DATA_SET'}, value:vm.get('record.dataSetId'), listeners:{change:this.onDataSetChange.bind(this)}, labelWidth:100, flex:1, margin:'0 0 0  10', matchFieldWidth:false});
}, onchangeChartName:function(el, val) {
  var vm = this.mainReference.getViewModel();
  vm.set('record.name', val);
}, onDataSetChange:function() {
  var vm = this.mainReference.getViewModel();
  var newDataSetId = this.dataSetSel.value;
  vm.set('record.dataSetId', newDataSetId);
  this.mainReference.onDataSetChanged();
  var controller = this.mainReference.getController();
  controller.loadServerData(this.moduleId, newDataSetId);
}, onChartTypeChange:function(el, chartType) {
  var isAmChart = analysis.assets.Helpers.isTypeAmChart(chartType);
  this.chartTypeSel.triggers.openDetail.setHidden(!isAmChart);
  var vm = this.mainReference.getViewModel();
  vm.set('record.chartType', chartType);
  this.fireEvent('ChangeChartType');
}, openDetailView:function() {
  var me = this;
  var vm = this.mainReference.getViewModel();
  this.detailConfigCmp = Ext.create({xtype:'analysisGeneralConfigDetail', record:vm.get('record'), mainReference:this.mainReference, viewModel:{parent:this.getViewModel()}});
  this.detailWindow = Ext.create('BpcCommon.component.window.Window', {items:[this.detailConfigCmp], localized:{title:'ANALYSIS_CHART_EDITOR_DETAIL_WINDOW_TITLE'}, listeners:{closeSave:me.closeSaveDetailView.bind(me)}});
}, closeSaveDetailView:function(el) {
  var newConfig = el.getViewModel().get('detailConfig');
  var vm = this.mainReference.getViewModel();
  vm.set('record.config', newConfig.config);
}});
Ext.define('analysis.view.chartEditor.chartConfigForm.GeneralConfigDetail', {extend:'Ext.panel.Panel', alias:'widget.analysisGeneralConfigDetail', layout:{type:'hbox', align:'stretch'}, viewModel:{data:{chartConfig:undefined, titleActive:undefined, chartTitle:undefined, detailConfig:undefined, autoUpdate:true}}, defaults:{margin:10}, jsonFieldCmp:undefined, chartPreviewCmp:undefined, uiFormCmp:undefined, UIFormCmp:undefined, mainFormCmp:undefined, defaultChartCmp:undefined, mainReference:undefined, 
initComponent:function() {
  var me = this;
  var vm = me.getViewModel();
  me.defaults = {moduleId:me.moduleId};
  var cloneConfig = Ext.clone(this.mainReference.record.getData());
  vm.set('detailConfig', cloneConfig);
  if (Ext.isArray(cloneConfig.config.titles)) {
    vm.set('chartTitle', cloneConfig.config.titles[0].text);
  }
  me.createFormComponent();
  me.createChartPreviewComponent();
  me.createJSONFieldComponent();
  vm.bind('{detailConfig}', this.onViewModelChange, this, {deep:true});
  me.items = [this.uiFormCmp, this.chartPreviewCmp, {xtype:'bpcSplitter', collapseTarget:'next'}, this.jsonFieldCmp];
  me.buttons = [{xtype:'toggleslidefield', localized:{fieldLabel:'ANALYSIS_LIVE_UPDATE_FIELD_LABEL'}, labelAlign:'top', labelWidth:40, bind:{value:'{globalLiveUpdate}'}}, '-\x3e', {iconCls:'x-fal fa-sync', handler:me.onSyncChart.bind(me), localized:{tooltip:'ANALYSIS_RELOAD_CHART_CONFIGURATION'}}, {iconCls:'x-fal fa-times', localized:{tooltip:'ANALYSIS_CANCEL', text:'ANALYSIS_CANCEL'}, handler:function() {
    me.up().fireEvent('closeNoSave', me);
    me.up().close();
  }}, {iconCls:'x-fal fa-save', localized:{tooltip:'ANALYSIS_APPLY', text:'ANALYSIS_APPLY'}, handler:function() {
    me.up().fireEvent('closeSave', me);
    me.up().close();
  }}];
  me.callParent();
}, onViewModelChange:function() {
  var vm = this.getViewModel();
  var autoupdate = vm.get('globalLiveUpdate');
  if (autoupdate === true) {
    this.onSyncChart();
  }
}, onSyncChart:function() {
  var vm = this.getViewModel();
  this.chartPreviewCmp.chartConfig = vm.get('detailConfig');
  this.chartPreviewCmp.reconfigureChartUI();
}, createFormComponent:function() {
  this.createUIForm();
  this.uiFormCmp = Ext.create('Ext.panel.Panel', {bodyPadding:5, flex:1, items:[this.mainFormCmp, this.UIFormCmp, this.advancedSettingsUI]});
}, createUIForm:function() {
  var vm = this.getViewModel();
  var animationActive = vm.get('detailConfig.animationActive') || false;
  var legendActive = Ext.isObject(vm.get('detailConfig.config.legend'));
  var scrollBarXActive = Ext.isObject(vm.get('detailConfig.config.scrollbarX'));
  var scrollBarYActive = Ext.isObject(vm.get('detailConfig.config.scrollbarY'));
  var titleActive = Ext.isArray(vm.get('detailConfig.config.titles'));
  var cursorActive = Ext.isObject(vm.get('detailConfig.config.cursor'));
  var dateInputFormat = vm.get('detailConfig.config.dateFormatter.inputDateFormat') || '';
  vm.set('chartTitle', vm.get('detailConfig.config.titles.0.text') || '');
  this.mainFormCmp = Ext.create({xtype:'analysisFieldSet', localized:{title:'ANALYSIS_DATASET_BASIC_SETTINGS'}, items:[{xtype:'fieldcontainer', layout:'hbox', items:[{xtype:'bpcTextField', localized:{fieldLabel:'ANALYSIS_CHART_TITLE_FIELD_LABEL'}, value:vm.get('chartTitle'), listeners:{change:this.onTypeTitle.bind(this)}, editable:true}, {xtype:'checkbox', localized:{fieldLabel:'ANALYSIS_CHART_SHOW_TITLE_FIELD_LABEL'}, labelWidth:100, margin:'0 20px 10px 10px', flex:1, value:titleActive, listeners:{change:this.changeShowTitle.bind(this)}}]}]});
  this.UIFormCmp = Ext.create({xtype:'analysisFieldSet', localized:{title:'ANALYSIS_DETAIL_CHART_CONFIGURATION_WINDOW_TITLE'}, items:[{xtype:'analysisColorPicker', labelWidth:200, localized:{fieldLabel:'ANALYSIS_CHART_BACKGROUND_COLOR_PICKER_LABEL'}, value:vm.get('detailConfig.config.background.fill') || '#FFFFFF', listeners:{change:this.setChartBackgroundColor.bind(this)}}, {xtype:'fieldcontainer', layout:'hbox', items:[{xtype:'checkbox', localized:{fieldLabel:'ANALYSIS_SHOW_LEGEND_FIELD_LABEL'}, 
  flex:1, value:legendActive, listeners:{change:this.changeShowLegend.bind(this)}, editable:false}, {xtype:'checkbox', fieldLabel:'Animation', flex:1, value:animationActive, listeners:{change:this.changeActivateAnimations.bind(this)}, editable:false}]}, {xtype:'fieldcontainer', layout:'hbox', items:[{xtype:'checkbox', fieldLabel:'Scrollbar X', flex:1, value:scrollBarXActive, listeners:{change:this.changeScrollbarX.bind(this)}, editable:false}, {xtype:'checkbox', fieldLabel:'Scrollbar Y', flex:1, 
  value:scrollBarYActive, listeners:{change:this.changeScrollbarY.bind(this)}, editable:false}]}, {xtype:'fieldcontainer', layout:'hbox', items:[{xtype:'checkbox', fieldLabel:'Cursor', flex:1, value:cursorActive, listeners:{change:this.changeCursor.bind(this)}, editable:false}]}]});
  this.advancedSettingsUI = Ext.create({xtype:'analysisFieldSet', localized:{title:'ANALYSIS_ADVANCED_SETTINGS'}, items:[{xtype:'fieldcontainer', layout:'hbox', items:[{xtype:'analysisDateFormatSelector', flex:1, value:dateInputFormat, listeners:{change:this.changeDateInputFormat.bind(this)}}]}]});
}, createChartPreviewComponent:function() {
  var vm = this.getViewModel();
  this.chartPreviewCmp = Ext.create({xtype:'analysisChartViewer', chartConfig:vm.get('detailConfig'), flex:1, moduleId:this.mainReference.moduleId});
}, createJSONFieldComponent:function() {
  this.jsonFieldCmp = Ext.create({xtype:'panel', collapseDirection:'right', flex:1, layout:'fit', items:[{xtype:'bpcJsonField', collapsible:true, bind:{value:{bindTo:'{detailConfig}', deep:true}}, editable:false}]});
}, setChartBackgroundColor:function(el, newColor) {
  var me = this;
  var vm = me.getViewModel();
  var newBackground = vm.get('detailConfig.config.background') || {fill:''};
  newBackground.fill = newColor;
  vm.set('detailConfig.config.background', newBackground);
}, changeShowTitle:function(el, titleActive) {
  var me = this;
  var vm = me.getViewModel();
  var chartTitle = vm.get('chartTitle');
  var newTitle = [{'text':chartTitle, 'fontSize':25, 'marginBottom':30}];
  if (titleActive) {
    vm.set('detailConfig.config.titles', newTitle);
  } else {
    vm.set('detailConfig.config.titles', '');
  }
}, onTypeTitle:function(el, val) {
  this.getViewModel().set('chartTitle', val);
  this.changeShowTitle(undefined, true);
}, changeShowLegend:function(el, value) {
  var me = this;
  var vm = me.getViewModel();
  var newLegend = {};
  if (value) {
    vm.set('detailConfig.config.legend', newLegend);
  } else {
    var config = vm.get('detailConfig.config');
    delete config.legend;
    vm.set('detailConfig.config', config);
  }
}, changeActivateAnimations:function(el, value) {
  var me = this;
  var vm = me.getViewModel();
  if (value) {
    vm.set('detailConfig.animationActive', true);
  } else {
    vm.set('detailConfig.animationActive', false);
  }
}, changeScrollbarX:function(el, value) {
  var me = this;
  var vm = me.getViewModel();
  if (value) {
    vm.set('detailConfig.config.scrollbarX', {type:'XYChartScrollbar', series:['s0']});
  } else {
    var config = vm.get('detailConfig.config');
    delete config.scrollbarX;
    vm.set('detailConfig.config', config);
  }
}, changeScrollbarY:function(el, value) {
  var me = this;
  var vm = me.getViewModel();
  if (value) {
    vm.set('detailConfig.config.scrollbarY', {type:'XYChartScrollbar', series:['s0']});
  } else {
    var config = vm.get('detailConfig.config');
    delete config.scrollbarY;
    vm.set('detailConfig.config', config);
  }
}, changeCursor:function(el, val) {
  var me = this;
  var vm = me.getViewModel();
  if (val) {
    vm.set('detailConfig.config.cursor', {});
  } else {
    var config = vm.get('detailConfig.config');
    delete config.cursor;
    vm.set('detailConfig.config', config);
  }
}, changeDateInputFormat:function(el, val) {
  var vm = this.getViewModel();
  var config = vm.get('detailConfig.config');
  if (val === '' || !val) {
    delete config.dateFormatter;
  } else {
    config.dateFormatter = {inputDateFormat:val};
  }
  vm.set('detailConfig.config', config);
}});
Ext.define('analysis.view.chartEditor.chartList.ChartList', {extend:'Ext.grid.Panel', alias:'widget.analysisChartList', controller:'analysisChartListController', itemId:'analysisChartList', reference:'analysisChartList', cmpType:'listItems', localized:{title:'ANALYSIS_CHARTS'}, minButtonWidth:30, plugins:{ptype:'cellediting', clicksToEdit:1}, features:[{ftype:'grouping'}], listeners:{select:'onSelect', afterrender:'onAfterRender'}, moduleId:undefined, initComponent:function() {
  this.store = Ext.create('Ext.data.ChainedStore', {source:analysis.assets.Helpers.getChartListStore(this.moduleId), groupField:'chartType', sorters:['name']});
  this.columns = [{localized:{text:'CORE_NAME'}, dataIndex:'name', flex:2}, {text:'ID', dataIndex:'id', hidden:true}, {localized:{text:'CORE_TYPE'}, dataIndex:'chartType', flex:1, renderer:function(chartType) {
    return analysis.assets.Icons.getChartTypeIcon(chartType);
  }.bind(this)}, {xtype:'actioncolumn', width:70, sortable:false, menuDisabled:true, align:'center', items:[{iconCls:'x-fal fa-copy', localized:{tooltip:'ANALYSIS_DUPLICATE'}, handler:'onDuplicateChartConfig'}, {iconCls:'x-fal fa-trash', localized:{tooltip:'CORE_DELETE'}, handler:'onRemoveChartConfig', itemId:'removeChartButton'}]}];
  this.createButtons();
  this.callParent();
}, addNewChart:function(preSelectedDataSet) {
  var chartStore = this.getStore();
  var controller = this.getController();
  var xyBaseConfig = Ext.data.StoreManager.lookup('analysisChartType').findRecord('type', 'xy').get('baseConfig');
  var newChart = {name:'new Chart', id:Date.now().toString(), chartType:'xy', dataSetId:preSelectedDataSet || '', config:xyBaseConfig};
  var newElement = chartStore.add(newChart);
  this.setSelection(newElement);
  controller.saveChartListSetting();
}, createButtons:function() {
  var $jscomp$this = this;
  this.buttons = [{iconCls:'x-fal fa-plus', localized:{tooltip:'ANALYSIS_ADD'}, handler:function() {
    $jscomp$this.addNewChart();
  }, itemId:'addNewChartButton'}];
}});
Ext.define('analysis.view.chartEditor.chartList.ChartListController', {extend:'Ext.app.ViewController', alias:'controller.analysisChartListController', onSelect:function(row, record) {
  var view = this.getView();
  var chartEditor = view.up().down('#analysisChartEditorWrapper');
  if (!record.chartEditor) {
    var item = {xtype:'analysisChartEditor', minWidth:500, record:record, moduleId:view.moduleId};
    record.chartEditor = chartEditor.add(item);
  }
  chartEditor.setActiveItem(record.chartEditor);
}, onAfterRender:function() {
  var me = this;
  me.chartListEmpty();
}, chartListEmpty:function() {
  var view = this.getView();
  if (view.getStore().getData().items.length === 0) {
    var editorsWrapper = view.up('analysisChartEditorContainer').down('#analysisChartEditorWrapper');
    analysis.assets.Helpers.showCentralWarningTextComponentsList(editorsWrapper);
  } else {
    view.setSelection(view.getStore().first());
  }
}, saveChartListSetting:function() {
  var me = this;
  var view = me.getView();
  var chartStore = view.getStore();
  var rawData = analysis.assets.Helpers.getRawDataFromStore(chartStore);
  var moduleId = view.moduleId;
  var settingModel = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.chartsConfigs, true);
  Ext.Array.each(rawData, function() {
  });
  settingModel.set('value', rawData);
  settingModel.save({success:function() {
    BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('CORE_OK'));
  }, failure:function(record, operation) {
    var error = operation.error;
    try {
      var response = JSON.parse(error.response.responseText);
      BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
    } catch (err) {
      Ext.log({level:'error', message:'Create Chart config error'});
    }
  }});
}, onRemoveChartConfig:function(grid, rowIndex) {
  var me = this;
  var view = me.getView();
  var chartStore = view.getStore();
  var rec = chartStore.getAt(rowIndex);
  Ext.Msg.show({title:BpcCommon.Api.getTranslation('ANALYSIS_DELETE_CHART_CONFIRM_TITLE'), message:BpcCommon.Api.getTranslation('ANALYSIS_DELETE_CHART_CONFIRM_TEXT'), buttons:Ext.Msg.YESNO, icon:Ext.Msg.QUESTION, fn:function(btn) {
    if (btn === 'yes') {
      chartStore.remove(rec);
      me.saveChartListSetting();
      me.chartListEmpty();
    }
  }});
}, onDuplicateChartConfig:function() {
  var me = this;
  var grid = me.getView();
  var selectedRecord = grid.getSelection()[0];
  if (selectedRecord) {
    var id = Date.now().toString();
    var newRecordData = Ext.apply(selectedRecord.getData(), {name:'Copy of ' + selectedRecord.get('name'), id:id});
    var moduleId = grid.moduleId;
    var settingsModel = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.chartsConfigs, true);
    var chartList = settingsModel.get('value');
    chartList.push(newRecordData);
    settingsModel.set('value', chartList);
    settingsModel.save({success:function() {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('CORE_OK'));
      var newRecord = grid.getStore().add(newRecordData);
      grid.setSelection(newRecord);
    }, failure:function(record, operation) {
      var error = operation.error;
      try {
        var response = JSON.parse(error.response.responseText);
        BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
      } catch (err) {
        Ext.log({level:'error', message:'Create Chart config error'});
      }
    }});
  }
}});
Ext.define('analysis.view.chartEditor.chartViewer.ChartPreViewer', {extend:'Ext.panel.Panel', alias:'widget.analysisChartPreViewer', itemId:'analysisChartPreViewer', flex:1, scrollable:true, layout:{type:'vbox', align:'stretch'}, minWidth:500, viewModel:{data:{}}, buttons:undefined, variablesFieldSetCmp:undefined, variablesGridCmp:undefined, chartTargetCmp:undefined, chartViewer:undefined, initComponent:function() {
  var me = this;
  this.variablesFieldSetCmp = Ext.create({xtype:'analysisFieldSet', localized:{title:'ANALYSIS_CONTEXT_VARIABLES'}, flex:1, layout:'fit', collapsible:true, collapsed:true, minHeight:200, items:[]});
  this.createVariablesGrid();
  this.chartTargetCmp = Ext.create('Ext.container.Container', {id:me.id + 'charTarget', flex:3, scrollable:true, layout:'fit'});
  this.items = [this.variablesFieldSetCmp, this.chartTargetCmp];
  this.buttons = this.createButtons();
  this.callParent();
  this.on('ChangeDataSet', this.onChangeDataSet, this);
  this.reloadChart();
}, createVariablesGrid:function() {
  var vm = this.mainReference.getViewModel();
  var dataSetId = vm.get('record.dataSetId') || '';
  if (this.variablesGridCmp && this.variablesFieldSetCmp) {
    this.variablesFieldSetCmp.remove(this.variablesGridCmp);
  }
  this.variablesGridCmp = Ext.create({xtype:'analysisContextVariablesGrid', dataSetId:dataSetId, moduleId:this.moduleId, refresh:this.onVariablesChange.bind(this), listeners:{onDataChange:this.onVariablesChange.bind(this)}});
  this.variablesFieldSetCmp.add(this.variablesGridCmp);
}, onChangeDataSet:function() {
  this.createVariablesGrid();
}, reconfigureChartUI:function() {
  this.chartViewer.reconfigureChartUI();
}, reloadData:function() {
  this.chartViewer.reloadData();
}, createButtons:function() {
  var vm = this.mainReference.getViewModel();
  var chartConfig = vm.get('record');
  return ['-\x3e', {xtype:'analysisrelatedItemsSelectorBtn', ui:'primary', localized:{text:'ANALYSIS_REPORT_EDITOR_TOOLTIP'}, iconCls:'x-fal fa-file-signature', relation:analysis.assets.ConfigKeys.relationType.RELATION_REPORTS_TO_CHART, moduleId:this.moduleId, chartId:chartConfig.id, margin:5}];
}, onVariablesChange:function() {
  var variablesGrid = this.variablesGridCmp;
  var variablesGridStore = variablesGrid.getStore();
  var variablesGridStoreData = analysis.assets.Helpers.getRawDataFromStore(variablesGridStore);
  this.chartViewer.setDataVariables(variablesGridStoreData);
}, reloadChart:function() {
  var target = this.chartTargetCmp;
  var vm = this.mainReference.getViewModel();
  var chartConfig = vm.get('record').getData();
  this.chartViewer = Ext.create({xtype:'analysisChartViewer', chartConfig:chartConfig, moduleId:this.mainReference.moduleId, mainReference:this.mainReference});
  target.removeAll();
  target.add(this.chartViewer);
}, createAmChart:function() {
  var me = this;
  var targetId = me.id + 'charTarget';
  var targetCmp = me.down('#' + targetId);
  if (!me.rendered) {
    me.on('afterrender', me.createAmChart, me, {single:true});
    return;
  }
  targetCmp.removeAll();
  targetCmp.add();
}, checkDataValid:function() {
  var vm = this.mainReference.getViewModel();
  var chartData = vm.get('record.config.data');
  var errorMessage = '', dataValid = true;
  if (!Ext.isArray(chartData) || chartData.length <= 0) {
    errorMessage = 'Data is not Valid';
    dataValid = false;
  }
  return {errorMessage:errorMessage, dataValid:dataValid};
}, createErrorChart:function() {
}});
Ext.define('analysis.view.chartEditor.chartViewer.ChartViewController', {extend:'Ext.app.ViewController', alias:'controller.analysisChartViewController', control:{'#':{}}});
Ext.define('analysis.view.chartEditor.chartViewer.ChartViewer', {extend:'Ext.container.Container', alias:'widget.analysisChartViewer', chartConfig:undefined, variables:[], moduleId:undefined, dataSet:undefined, chartInstance:undefined, cloneConfig:undefined, targetCmp:undefined, viewModel:{data:{chartInstance:undefined}}, layout:'fit', initComponent:function() {
  this.callParent();
  this.createChartTarget();
  this.on('afterrender', this.onAfterRender, this);
  this.on('beforedestroy', this.onDestroy, this);
}, reloadData:function() {
  this.loadDataFromDataSet();
}, reconfigureChartUI:function() {
  this.renderChart();
}, setDataVariables:function(newVariableList) {
  if (!Ext.isArray(newVariableList)) {
    return;
  }
  this.variables = newVariableList;
  this.loadDataFromDataSet();
}, onDestroy:function() {
  this.disposeChartCmp();
}, onAfterRender:function() {
  this.loadDataFromDataSet();
}, centerMsg:function(msg) {
  this.targetCmp.removeAll();
  var errCmp = Ext.create({xtype:'bpcCenterMessageCmp', message:msg || 'error'});
  this.targetCmp.add(errCmp);
}, createChartTarget:function() {
  this.targetCmp = Ext.create({xtype:'container', id:this.id + 'charTarget', layout:'fit'});
  this.add(this.targetCmp);
}, reconfigureChart:function() {
  if (this.chartConfig.dataSetId) {
    this.loadDataFromDataSet();
  } else {
    this.centerMsg('ANALYSIS_NO_DATA_SET');
  }
}, loadDataFromDataSet:function() {
  var me = this;
  if (!Ext.isObject(this.chartConfig)) {
    me.centerMsg('ANALYSIS_NO_CHART_CONFIG');
    return;
  }
  var moduleId = me.moduleId;
  var dataSetId = me.chartConfig.dataSetId;
  var variables = me.variables || false;
  if (!dataSetId) {
    me.centerMsg('ANALYSIS_NO_DATA_SET');
    return;
  }
  if (!moduleId) {
    me.centerMsg('ANALYSIS_NO_MODULE_REF');
    return;
  }
  analysis.assets.Helpers.getModifiedData(moduleId, dataSetId, false, variables).then(function(response) {
    me.dataSet = Ext.decode(response.responseText);
    me.fireEvent('successDataLoad');
    me.renderChart();
  }, function() {
    me.centerMsg('ANALYSIS_LOAD_DATA_ERROR');
  });
}, renderChart:function() {
  this.disposeChartCmp();
  if (!this.chartConfig) {
    this.centerMsg('ANALYSIS_NO_CHART_CONFIG');
    return;
  }
  this.selectChartType();
}, disposeChartCmp:function() {
  if (this.chartInstance && this.chartInstance.dispose) {
    this.chartInstance.dispose();
  }
}, selectChartType:function() {
  var chartType = this.chartConfig['chartType'];
  this.cloneConfig = Ext.clone(this.chartConfig['config']);
  this.cloneConfig.data = this.dataSet;
  this.cloneConfig.chartType = chartType;
  switch(chartType) {
    case 'xy':
      this.renderAmChart();
      break;
    case 'pie':
      this.renderAmChart();
      break;
    case 'gauge':
      this.setGaugeData();
      this.renderAmChart();
      break;
    case 'table':
      this.renderTableChart();
      break;
    case 'template':
      this.renderTemplateChart();
      break;
    default:
      break;
  }
}, renderTableChart:function() {
  this.targetCmp.removeAll();
  var tableStore = Ext.create('Ext.data.Store', {});
  tableStore.loadRawData(this.dataSet);
  var columns = this.chartConfig.config.columns || [];
  if (Ext.isArray(columns) && columns.length >= 0) {
    columns.forEach(function(el) {
      if (el && el.id) {
        Ext.apply(el, el.additionalParameters);
        delete el.additionalParameters;
        delete el.id;
      }
    });
  }
  this.targetCmp.add({xtype:'gridpanel', store:tableStore, columns:columns});
}, setGaugeData:function() {
  var $jscomp$this = this;
  var handsList = this.cloneConfig.gaugeSeries;
  var chartData;
  if (!this.dataSet) {
    this.centerMsg('ANALYSIS_LOAD_DATA_ERROR');
    return;
  }
  if (Ext.isArray(this.dataSet) && this.dataSet.length > 0) {
    chartData = this.dataSet[0];
  } else {
    chartData = this.dataSet;
  }
  this.cloneConfig.hands = [];
  handsList.forEach(function(el) {
    $jscomp$this.cloneConfig.hands.push({type:'ClockHand', value:chartData[el.dataAttribute] || 0, fill:el.fill, innerRadius:el.innerRadius, radius:el.radius, startWidth:el.startWidth, pin:{disabled:true}, stroke:el.stroke});
  });
}, renderAmChart:function() {
  this.targetCmp.removeAll();
  var targetId = this.targetCmp.getId();
  try {
    var amTypeString = Ext.data.StoreManager.lookup('analysisChartType').findRecord('type', this.cloneConfig.chartType).get('amClass');
    var amType = am4charts[amTypeString];
    this.chartInstance = am4core.createFromConfig(this.cloneConfig, targetId, amType);
    am4core.useTheme(am4themes_animated);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR render amChart', dump:e, stack:true, level:'error'});
  }
}, renderTemplateChart:function() {
  var templateContent = this.chartConfig.config.templateContent;
  var tpl = new Ext.XTemplate(templateContent);
  var content = tpl.apply(this.dataSet);
  var cleanContent = DOMPurify.sanitize(content);
  var wrapDiv = document.createElement('div');
  var shadowRoot = wrapDiv.attachShadow({mode:'open'});
  var contentDiv = document.createElement('div');
  wrapDiv.setAttribute('data-testid', 'analysisShadowHost');
  contentDiv.innerHTML = cleanContent;
  shadowRoot.appendChild(contentDiv);
  this.targetCmp.removeAll();
  this.targetCmp.add({xtype:'component', listeners:{afterrender:function(cmp) {
    cmp.getEl().append(shadowRoot.host);
  }}});
}});
Ext.define('analysis.view.chartEditor.components.ChartDataSelector', {extend:'Ext.container.Container', alias:'widget.analysisChartDataSelector', localized:{title:'ANALYSIS_DATA_SELECTOR_TITLE'}, viewModel:{data:{record:undefined}}, layout:'fit', chartType:undefined, chartConfig:undefined, axesConfigCmp:undefined, seriesFieldSetCmp:undefined, seriesConfigCmp:undefined, mainReference:undefined, initComponent:function() {
  this.callParent();
  this.on('ChangeDataSet', this.onChangeDataSet, this);
}, onChangeDataSet:function() {
  if (this.seriesConfigCmp) {
    this.seriesConfigCmp.fireEvent('ChangeDataSet');
  }
}, createItems:function() {
  var vm = this.getViewModel();
  this.chartType = vm.get('record.chartType');
  var dataSelector = Ext.data.StoreManager.lookup('analysisChartType').findRecord('type', this.chartType).get('dataSelectorComponent');
  var axesSelector = Ext.data.StoreManager.lookup('analysisChartType').findRecord('type', this.chartType).get('axesSelectorComponent');
  if (axesSelector) {
    this.axesConfigCmp = Ext.create({xtype:axesSelector, viewModel:vm, mainReference:this.mainReference});
    this.add(this.axesConfigCmp);
  }
  if (dataSelector) {
    this.seriesConfigCmp = Ext.create({xtype:dataSelector, viewModel:vm, mainReference:this.mainReference});
    this.seriesFieldSetCmp = Ext.create('Ext.form.FieldSet', {localized:{title:'ANALYSIS_DATA_SELECTOR_TITLE'}, items:[this.seriesConfigCmp]});
    this.add(this.seriesFieldSetCmp);
  }
}});
Ext.define('analysis.view.chartEditor.components.chartTypeSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisChartTypeSelector', fieldLabel:'ChartType', queryMode:'local', displayField:'name', valueField:'type', store:'analysisChartType', editable:false});
Ext.define('analysis.view.chartEditor.components.DefaultChartConfigSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisDefaultChartConfigSelector', valueField:'config', displayField:'name', queryMode:'local', anyMatch:true, localized:{fieldLabel:'ANALYSIS_DEFAULT_CHART_SELECTOR_FIELD_LABEL', emptyText:'ANALYSIS_DEFAULT_CHART_SELECTOR_EMPTY_TEXT'}, editable:false, chartType:undefined, initComponent:function() {
  var me = this;
  me.callParent();
  this.on('afterrender', this.fillStore, this);
  this.on('change', this.onChangeDefaultConfig, this);
}, fillStore:function() {
  this.store = this.mainReference.defaultChartStore;
}, onChangeDefaultConfig:function(el, val) {
  this.mainReference.loadDefaultChartconfig(val);
}});
Ext.define('analysis.view.chartEditor.components.DefaultChartConfigConfigurator', {extend:'Ext.container.Container', alias:'widget.DefaultChartConfigConfigurator', layout:'fit', localized:{title:'ANALYSIS_CHART_DEFAULT_CONFIGURATOR_TITLE'}, chartType:undefined, styleSelector:undefined, testDataCheckCmp:undefined, testData:{}, viewModel:{}, initComponent:function() {
  this.callParent();
  this.styleSelector = Ext.create('analysis.view.chartEditor.components.DefaultChartConfigSelector', {chartType:this.chartType, fieldLabel:'DefaultChart', listeners:{change:this.onSetDefaultStyle.bind(this)}});
  this.add([this.styleSelector, this.testDataCheckCmp]);
}, onChangeUseTestData:function(el, val) {
  var vm = this.getViewModel();
  var testData = this.testData[this.chartType];
  if (val) {
    vm.set('dataSet', testData);
  } else {
    vm.set('dataSet', []);
  }
}, onSetDefaultStyle:function(el, val) {
  this.fireEvent('SetDefaultStyle', val);
  var vm = this.mainReference.getViewModel();
  vm.set('record.config', val);
  this.mainReference.chartConfigCmp.updateSpecificChartCmp();
}});
Ext.define('analysis.view.chartEditor.components.GaugeChart.analysisGaugeAxesConfigurator', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisGaugeAxesConfigurator', localized:{title:'ANALYSIS_GAUGE_CHART_AXES_CONFIGURATOR_TITLE'}, newRangeElement:{value:0, endValue:0, color:'rgba(255,255,255,1)'}, mainReference:undefined, axesFormCmp:undefined, sectionGridCmp:undefined, sectionGriStore:undefined, initComponent:function() {
  this.callParent();
  this.on('afterrender', this.onAfterrender, this);
}, onAfterrender:function() {
  this.createAxesForm();
  this.createSectionGrid();
  this.fillSectionStore();
  this.sectionGriStore.on('datachanged', this.onStoreDataChanged, this);
}, onErrorMessage:function(msg) {
  this.removeAll();
  this.add({xtype:'bpcCenterMessageCmp', message:msg});
}, createAxesForm:function() {
  var vm = this.mainReference.getViewModel();
  var innerRadiusDefaultValue = vm.get('record.config.innerRadius');
  var defaultStartAngle = vm.get('record.config.startAngle') || -180;
  var defaultEndAngle = vm.get('record.config.endAngle') || 0;
  var xAxes = vm.get('record.config.xAxes.0');
  var defaultMinAxesValue = xAxes.min;
  var defaultMaxAxesValue = xAxes.max;
  this.axesFormCmp = Ext.create({xtype:'container', items:[{xtype:'container', layout:{type:'hbox'}, defaults:{labelWidth:100, margin:'0 20px 10px 10px'}, items:[{xtype:'bpcNumberField', fieldLabel:BpcCommon.Api.getTranslation('ANALYSIS_START_VALUE'), value:defaultMinAxesValue, attr:'min', listeners:{change:this.setAxesAttribute.bind(this)}}, {xtype:'bpcNumberField', fieldLabel:BpcCommon.Api.getTranslation('ANALYSIS_END_VALUE'), value:defaultMaxAxesValue, attr:'max', listeners:{change:this.setAxesAttribute.bind(this)}}]}, 
  {xtype:'container', layout:{type:'hbox'}, defaults:{labelWidth:100, margin:'0 20px 10px 10px'}, items:[{xtype:'bpcNumberField', fieldLabel:BpcCommon.Api.getTranslation('ANALYSIS_START_ANGLE'), value:defaultStartAngle, listeners:{change:this.onChangeStartAngle.bind(this)}}, {xtype:'bpcNumberField', fieldLabel:BpcCommon.Api.getTranslation('ANALYSIS_END_ANGLE'), value:defaultEndAngle, listeners:{change:this.onChangeEndAngle.bind(this)}}]}, {xtype:'container', layout:{type:'hbox'}, defaults:{labelWidth:100, 
  margin:'0 20px 10px 10px'}, items:[{xtype:'bpcNumberField', fieldLabel:BpcCommon.Api.getTranslation('ANALYSIS_INNER_RADIUS'), value:innerRadiusDefaultValue, listeners:{change:this.onChangeInnerRadius.bind(this)}}]}]});
  this.add(this.axesFormCmp);
}, getChartConfiguration:function() {
  var vm = this.getViewModel();
  return Ext.clone(vm.get('record.config'));
}, setChartConfiguration:function(config) {
  var vm = this.getViewModel();
  vm.set('record.config', config);
}, onChangeInnerRadius:function(el, val) {
  var config = this.getChartConfiguration();
  config.innerRadius = val;
  this.setChartConfiguration(config);
}, onChangeStartAngle:function(el, val) {
  var config = this.getChartConfiguration();
  config.startAngle = val;
  this.setChartConfiguration(config);
}, onChangeEndAngle:function(el, val) {
  var config = this.getChartConfiguration();
  config.endAngle = val;
  this.setChartConfiguration(config);
}, setAxesAttribute:function(el, value) {
  var config = this.getChartConfiguration();
  var attr = el.attr;
  config.xAxes[0][attr] = value;
  this.setChartConfiguration(config);
}, createSectionGrid:function() {
  this.sectionGriStore = Ext.create('Ext.data.Store', {data:[], fields:[{name:'value'}, {name:'endValue'}, {name:'color'}, {name:'opacity'}], sorters:[], proxy:{type:'memory', reader:{type:'json'}, writer:{type:'json', writeAllFields:true}, autoload:true}});
  this.sectionGridCmp = Ext.create({xtype:'grid', viewConfig:{markDirty:false}, localized:{title:'ANALYSIS_CHART_GAUGE_AXES_RANGES'}, store:this.sectionGriStore, columns:[{xtype:'rownumberer'}, {flex:1, text:BpcCommon.Api.getTranslation('ANALYSIS_START_VALUE'), dataIndex:'value', editor:{completeOnEnter:false, field:{xtype:'bpcNumberField'}}}, {flex:1, text:BpcCommon.Api.getTranslation('ANALYSIS_END_VALUE'), dataIndex:'endValue', editor:{completeOnEnter:false, field:{xtype:'bpcNumberField'}}}, {flex:1, 
  text:BpcCommon.Api.getTranslation('ANALYSIS_COLOR'), dataIndex:'color', editor:{completeOnEnter:false, field:{xtype:'analysisColorPicker'}}}, {xtype:'actioncolumn', width:50, sortable:false, menuDisabled:true, align:'left', items:[{iconCls:'x-fal fa-trash', tooltip:BpcCommon.Api.getTranslation('CORE_DELETE'), handler:function(grid, rowIndex) {
    grid.getStore().removeAt(rowIndex);
  }}]}], buttons:[{iconCls:'x-fal fa-plus', localized:{tooltip:'ANALYSIS_ADD'}, handler:this.onAddRange.bind(this)}], selModel:'cellmodel', plugins:{ptype:'cellediting', clicksToEdit:1}});
  this.add(this.sectionGridCmp);
}, onAddRange:function() {
  this.newRangeElement.id = Date.now();
  this.sectionGriStore.add(this.newRangeElement);
}, onStoreDataChanged:function() {
  var storeData = analysis.assets.Helpers.getRawDataFromStore(this.sectionGriStore);
  var config = this.getChartConfiguration();
  var xAxes = config.xAxes;
  var axesRanges = xAxes[0].axisRanges;
  var newAxesRange = [];
  storeData.forEach(function(el, idx) {
    var newRangeEl = {value:el.value, endValue:el.endValue, axisFill:{fill:el.color, fillOpacity:1}};
    delete el.color;
    delete el.opacity;
    var oldRangeEl = axesRanges[idx] || {};
    newAxesRange.push(Ext.merge(oldRangeEl, newRangeEl));
  });
  config.xAxes[0].axisRanges = newAxesRange;
  this.setChartConfiguration(config);
}, updateChartPreview:function() {
  this.mainReference.onRecordChanged();
}, fillSectionStore:function() {
  var vm = this.mainReference.getViewModel();
  var chartConfig = vm.get('record.config');
  if (!Ext.isObject(chartConfig)) {
    this.onErrorMessage('no valid chart config');
    return;
  }
  var xAxes = vm.get('record.config.xAxes');
  if (!Ext.isArray(xAxes[0].axisRanges)) {
    this.onErrorMessage('no valid axes configuration');
    return;
  }
  var axisRanges = xAxes[0].axisRanges;
  axisRanges.forEach(function(el) {
    el.color = el.axisFill.fill.replace('#', '');
    el.opacitiy = el.axisFill.fillOpacity;
  });
  this.sectionGriStore.loadRawData(axisRanges);
}, onUpdateComponent:function() {
}});
Ext.define('analysis.view.chartEditor.components.GaugeChart.GaugeValueSelector', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisGaugeValueSelector', localized:{title:'ANALYSIS_GAUGE_DATA_SELECTOR_TITLE'}, viewModel:{}, newHandsElement:{type:'ClockHand', value:0, fill:'#e18b50', stroke:'#c63441', innerRadius:'0%', radius:'80%', startWidth:15, pin:{disabled:true}, dataAttribute:''}, mainReference:undefined, handsGriCmp:undefined, handsGriStore:undefined, initComponent:function() {
  this.callParent();
  this.on('afterrender', this.onAfterrender, this);
}, onAfterrender:function() {
  this.createHandsGrid();
}, onErrorMessage:function(msg) {
  this.removeAll();
  this.add({xtype:'bpcCenterMessageCmp', message:msg});
}, createHandsGrid:function() {
  this.handsGriStore = Ext.create('Ext.data.Store', {fields:[{name:'value'}, {name:'fill'}, {name:'stroke'}, {name:'innerRadius'}, {name:'radius'}, {name:'startWidth'}, {name:'dataAttribute'}], sorters:[{property:'value', direction:'ASC'}], proxy:{type:'memory', reader:{type:'json'}, writer:{type:'json', writeAllFields:true}, autoload:true}});
  this.fillHandsStore();
  this.handsGriStore.on('datachanged', this.onStoreDataChanged, this);
  this.handsGriCmp = Ext.create({xtype:'grid', viewConfig:{markDirty:false}, localized:{title:'ANALYSIS_CHART_GAUGE_DATA_POINTER'}, store:this.handsGriStore, columns:[{xtype:'rownumberer'}, {text:BpcCommon.Api.getTranslation('ANALYSIS_GAUGE_DATA_SELECTOR_ATTRIBUTE'), dataIndex:'dataAttribute', itemId:'dataAttributeColumn', editor:{completeOnEnter:false, field:{xtype:'combobox', store:this.mainReference.attrKeyStore, displayField:'attr', valueField:'attr'}}}, {text:BpcCommon.Api.getTranslation('ANALYSIS_GAUGE_DATA_SELECTOR_COLOR'), 
  dataIndex:'fill', editor:{completeOnEnter:false, field:{xtype:'analysisColorPicker'}}}, {text:BpcCommon.Api.getTranslation('ANALYSIS_GAUGE_DATA_SELECTOR_BORDER_COLOR'), dataIndex:'stroke', editor:{completeOnEnter:false, field:{xtype:'analysisColorPicker'}}}, {text:BpcCommon.Api.getTranslation('ANALYSIS_INNER_RADIUS'), dataIndex:'innerRadius', editor:{completeOnEnter:false, field:{xtype:'bpcTextField'}}}, {text:BpcCommon.Api.getTranslation('ANALYSIS_OUTER_RADIUS'), dataIndex:'radius', editor:{completeOnEnter:false, 
  field:{xtype:'bpcTextField'}}}, {text:BpcCommon.Api.getTranslation('ANALYSIS_GAUGE_DATA_SELECTOR_START_WIDTH'), dataIndex:'startWidth', editor:{completeOnEnter:false, field:{xtype:'bpcNumberField'}}}, {xtype:'actioncolumn', width:50, sortable:false, menuDisabled:true, align:'left', items:[{iconCls:'x-fal fa-trash', tooltip:BpcCommon.Api.getTranslation('CORE_DELETE'), handler:function(grid, rowIndex) {
    grid.getStore().removeAt(rowIndex);
  }}]}], buttons:[{iconCls:'x-fal fa-plus', localized:{tooltip:'ANALYSIS_ADD'}, handler:this.onAddRange.bind(this)}], selModel:'cellmodel', plugins:{ptype:'cellediting', clicksToEdit:1}});
  this.add(this.handsGriCmp);
}, isValidDataSetId:function(dataSetId) {
  if (dataSetId && dataSetId !== -1) {
    return true;
  }
  return false;
}, onAddRange:function() {
  this.newHandsElement.id = Date.now();
  this.handsGriStore.add(this.newHandsElement);
}, onStoreDataChanged:function() {
  console.error('onStoreDataChanged');
  var storeData = analysis.assets.Helpers.getRawDataFromStore(this.handsGriStore);
  var vm = this.getViewModel();
  var config = Ext.clone(vm.get('record.config'));
  config.gaugeSeries = storeData;
  vm.set('record.config', config);
}, fillHandsStore:function() {
  var vm = this.getViewModel();
  var chartConfig = vm.get('record.config');
  if (!Ext.isObject(chartConfig)) {
    this.onErrorMessage('no valid chart config');
    return;
  }
  var hands = vm.get('record.config.gaugeSeries');
  if (!Ext.isArray(hands)) {
    hands = [];
  }
  this.handsGriStore.loadRawData(hands);
}, updateChartPreview:function() {
  this.mainReference.getController().updateChart();
}, onUpdateComponent:function() {
  this.fillHandsStore();
}});
Ext.define('analysis.view.chartEditor.components.JumpToReportButton', {extend:'Ext.SplitButton', alias:'widget.analysisJumpToReportButton', localized:{text:'Jump to Report'}, mainReference:undefined, initComponent:function() {
  this.handler = this.onMainClick.bind(this);
  this.menu = this.createMenu();
  this.callParent();
}, createMenu:function() {
  return Ext.create('Ext.menu.Menu', {items:this.createMenuItems()});
}, createMenuItems:function() {
  var $jscomp$this = this;
  var moduleId = this.mainReference.moduleId;
  var reportListStore = Ext.data.StoreManager.lookup(moduleId + 'ReportListStore');
  var reportList = analysis.assets.Helpers.getRawDataFromStore(reportListStore);
  if (!Ext.isArray(reportList)) {
    return [];
  }
  var menuItems = [];
  reportList.forEach(function(el) {
    var menuItem = {text:el.name, handler:$jscomp$this.onItemClick.bind($jscomp$this), report:el};
    menuItems.push(menuItem);
  });
  return menuItems;
}, onItemClick:function() {
}, onMainClick:function() {
  var mainAnalysisClass = this.up('bpcAnalysis');
  mainAnalysisClass.jumpToReportEditor('foo');
}});
Ext.define('analysis.view.chartEditor.components.PieChart.PieConfigurator', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisPieConfigurator', localized:{title:'ANALYSIS_PIE_CONFIGURATOR_TITLE'}, mainReference:undefined, viewModel:{enabled3D:undefined, enabledLabels:undefined, enabledLegend:undefined}, chartController:undefined, initComponent:function() {
  this.callParent();
  this.on('afterrender', this.onAfterrender, this);
  this.chartController = this.mainReference.getController();
}, onAfterrender:function() {
  this.getInitRenderConfgiuration();
  this.createUI();
}, getInitRenderConfgiuration:function() {
  var vm = this.mainReference.getViewModel();
  var enabled3D = vm.get('record.enabled3D') || false;
  var enabledLabels = !vm.get('record.config.series.0.labels.disabled') || false;
  var enabledLegend = !vm.get('record.config.legend.disabled') || false;
  var ivm = this.getViewModel();
  ivm.set('enabled3D', enabled3D);
  ivm.set('enabledLabels', enabledLabels);
  ivm.set('enabledLegend', enabledLegend);
}, createUI:function() {
  var vm = this.mainReference.getViewModel();
  var enabled3D = vm.get('record.enabled3D') || false;
  var enabledLabels = !vm.get('record.config.series.0.labels.disabled') || false;
  var enabledLegend = !vm.get('record.config.legend.disabled') || false;
  var labelFontSize = vm.get('record.config.series.0.labels.fontSize') || 16;
  var depthValue = vm.get('record.config.depth') || 0;
  var angle = vm.get('record.config.angle') || 0;
  var useDepthValue = typeof vm.get('record.config.series.0.dataFields.depthValue') === 'string';
  var outerRadius = vm.get('record.config.radius') || 0;
  var innerRadius = vm.get('record.config.innerRadius') || 0;
  var scale = vm.get('record.config.scale') || 1;
  var startAngle = vm.get('record.config.startAngle') || -180;
  var stopAngle = vm.get('record.config.stopAngle') || 180;
  var ivm = this.getViewModel();
  ivm.set('enabled3D', enabled3D);
  ivm.set('enabledLabels', enabledLabels);
  this.scaleUI = Ext.create({xtype:'fieldcontainer', layout:'hbox', defaults:{labelWidth:100, flex:1, margin:'0 10 0 0'}, items:[{xtype:'bpcNumberField', localized:{fieldLabel:'ANALYSIS_PI_SCALE_FIELD_LABEL'}, fieldLabel:'Scale', minValue:0, value:scale, flex:1, listeners:{change:this.onChangeScale.bind(this)}}]});
  this.radiusUI = Ext.create({xtype:'fieldcontainer', layout:'hbox', defaults:{labelWidth:100, flex:1, margin:'0 10 0 0'}, items:[{xtype:'bpcNumberField', localized:{fieldLabel:'ANALYSIS_PI_INNER_RADIUS_FIELD_LABEL'}, minValue:0, value:innerRadius, flex:1, listeners:{change:this.onChangeInnerRadius.bind(this)}}, {xtype:'bpcNumberField', localized:{fieldLabel:'ANALYSIS_PI_OUTER_RADIUS_FIELD_LABEL'}, minValue:0, value:outerRadius, flex:1, listeners:{change:this.onChangeOuterRadius.bind(this)}}]});
  this.AngleUI = Ext.create({xtype:'fieldcontainer', layout:'hbox', defaults:{labelWidth:100, flex:1, margin:'0 10 0 0'}, items:[{xtype:'bpcNumberField', localized:{fieldLabel:'ANALYSIS_PI_START_ANGLE_FIELD_LABEL'}, value:startAngle, flex:1, listeners:{change:this.onChangeStartAngle.bind(this)}}, {xtype:'bpcNumberField', localized:{fieldLabel:'ANALYSIS_PI_STOP_ANGLE_FIELD_LABEL'}, value:stopAngle, flex:1, listeners:{change:this.onChangeStopAngle.bind(this)}}]});
  this.selector3D = Ext.create({xtype:'checkbox', localized:{fieldLabel:'ANALYSIS_PI_3_D_FIELD_LABEL'}, value:enabled3D, labelWidth:100, listeners:{change:this.onChange3D.bind(this)}});
  this.details3D = Ext.create({xtype:'fieldcontainer', layout:'hbox', margin:'0 0 0 50', defaults:{margin:'0 10 0 10', labelWidth:130, labelAlign:'right'}, items:[{xtype:'bpcNumberField', localized:{fieldLabel:'ANALYSIS_DEPTH_FIELD_LABEL'}, minValue:0, value:depthValue, flex:3, listeners:{change:this.onChangeDepth.bind(this)}}, {xtype:'checkbox', localized:{fieldLabel:'ANALYSIS_USE_DEPTH_FIELD_LABEL'}, value:useDepthValue, flex:2, listeners:{change:this.onChangeUseValueDepth.bind(this)}}, {xtype:'bpcNumberField', 
  localized:{fieldLabel:'ANALYSIS_3D_ANGLE_FIELD_LABEL'}, minValue:0, flex:3, value:angle, listeners:{change:this.onChangeAngle.bind(this)}}], bind:{hidden:'{!enabled3D}'}});
  this.selectorLabels = Ext.create({xtype:'checkbox', localized:{fieldLabel:'ANALYSIS_ENABLE_LABELS_FIELD_LABEL'}, value:enabledLabels, labelWidth:100, listeners:{change:this.onChangeLabel.bind(this)}});
  this.detailsLabels = Ext.create({xtype:'fieldcontainer', layout:'hbox', margin:'0 0 0 100', defaults:{margin:'0 10 0 10', labelWidth:130, labelAlign:'right'}, items:[{xtype:'bpcNumberField', localized:{fieldLabel:'ANALYSIS_LABEL_FONT_SIZE_FIELD_LABEL'}, minValue:0, value:labelFontSize, flex:3, listeners:{change:this.onChangeLabelFontSize.bind(this)}}], bind:{hidden:'{!enabledLabels}'}});
  this.selectorLegend = Ext.create({xtype:'checkbox', localized:{fieldLabel:'ANALYSIS_LABEL_ENABLE_LEGEND_FIELD_LABEL'}, value:enabledLegend, labelWidth:100, listeners:{change:this.onChangeLegend.bind(this)}});
  this.add([this.scaleUI, this.radiusUI, this.AngleUI, this.selector3D, this.details3D, this.selectorLabels, this.detailsLabels, this.selectorLegend]);
}, onChange3D:function(cmp, val) {
  var ivm = this.getViewModel();
  ivm.set('enabled3D', val);
  var config = this.chartController.getChartConfiguration();
  var vm = this.mainReference.getViewModel();
  vm.set('record.enabled3D', val);
  if (val) {
    config.series[0].type = 'PieSeries3D';
  } else {
    config.series[0].type = 'PieSeries';
  }
  this.chartController.setNewConfiguration(config);
}, onChangeLabel:function(el, val) {
  var ivm = this.getViewModel();
  ivm.set('enabledLabels', val);
  var config = this.chartController.getChartConfiguration();
  var labelsDisabled;
  if (val) {
    labelsDisabled = false;
  } else {
    labelsDisabled = true;
  }
  config.series[0].labels = {disabled:labelsDisabled};
  this.chartController.setNewConfiguration(config);
}, onChangeDepth:function(el, val) {
  var config = this.chartController.getChartConfiguration();
  config.depth = val;
  this.chartController.setNewConfiguration(config);
}, onChangeAngle:function(el, val) {
  var config = this.chartController.getChartConfiguration();
  config.angle = val;
  this.chartController.setNewConfiguration(config);
}, onChangeUseValueDepth:function(el, val) {
  var config = this.chartController.getChartConfiguration();
  if (val) {
    config.series[0].dataFields.depthValue = config.series[0].dataFields.value;
  } else {
    delete config.series[0].dataFields.depthValue;
  }
  this.chartController.setNewConfiguration(config);
}, onChangeInnerRadius:function(el, val) {
  var config = this.chartController.getChartConfiguration();
  config.innerRadius = val;
  this.chartController.setNewConfiguration(config);
}, onChangeOuterRadius:function(el, val) {
  var config = this.chartController.getChartConfiguration();
  config.radius = val;
  this.chartController.setNewConfiguration(config);
}, onChangeScale:function(el, val) {
  var config = this.chartController.getChartConfiguration();
  config.scale = val;
  this.chartController.setNewConfiguration(config);
}, onChangeStartAngle:function(el, val) {
  var config = this.chartController.getChartConfiguration();
  config.startAngle = val;
  this.chartController.setNewConfiguration(config);
}, onChangeStopAngle:function(el, val) {
  var config = this.chartController.getChartConfiguration();
  config.endAngle = val;
  this.chartController.setNewConfiguration(config);
}, onChangeLabelFontSize:function(el, val) {
  var config = this.chartController.getChartConfiguration();
  config.series[0].labels = {fontSize:val};
  this.chartController.setNewConfiguration(config);
}, onChangeLegend:function(el, val) {
  var config = this.chartController.getChartConfiguration();
  config.legend = {disabled:!val};
  this.chartController.setNewConfiguration(config);
}});
Ext.define('analysis.view.chartEditor.components.PieChart.PieSeriesGrid', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisPieSeriesGrid', localized:{title:'ANALYSIS_PIE_SERIES_GRID_TITLE'}, mainReference:undefined, seriesGridCmp:undefined, seriesGridStore:undefined, initComponent:function() {
  this.callParent();
  this.on('afterrender', this.onAfterrender, this);
}, onAfterrender:function() {
  this.createSeriesGrid();
  this.add([this.seriesGridCmp]);
}, readSeries:function() {
  var controller = this.mainReference.getController();
  return controller.getChartSeries();
}, createSeriesGrid:function() {
  this.seriesGridStore = Ext.create('Ext.data.Store', {fields:[{name:'category', mapping:'dataFields.category'}, {name:'value', mapping:'dataFields.value'}]});
  this.seriesGridStore.loadRawData(this.readSeries());
  this.seriesGridStore.on('datachanged', this.onStoreDataChanged, this);
  this.seriesGridCmp = Ext.create('Ext.grid.Panel', {viewConfig:{markDirty:false}, store:this.seriesGridStore, selModel:'cellmodel', plugins:{ptype:'cellediting', clicksToEdit:1}, columns:this.createColumns()});
}, onStoreDataChanged:function() {
  var nestedData = BpcCommon.Util.getSerializedStoreData(this.seriesGridStore, 'json', {type:'json', writeAllFields:true, expandData:true, nameProperty:'mapping'});
  if (!Ext.isArray(nestedData)) {
    nestedData = [nestedData];
  }
  var controller = this.mainReference.getController();
  controller.setChartSeries(nestedData);
}, createColumns:function() {
  return [{text:BpcCommon.Api.getTranslation('ANALYSIS_PIE_SERIES_GRID_LABEL_TEXT'), dataIndex:'category', flex:1, editor:{completeOnEnter:false, field:{xtype:'combobox', store:this.mainReference.attrKeyStore, displayField:'attr', valueField:'attr'}}}, {text:BpcCommon.Api.getTranslation('ANALYSIS_PIE_SERIES_GRID_Y_VALUE_TEXT'), dataIndex:'value', flex:1, editor:{completeOnEnter:false, field:{xtype:'combobox', store:this.mainReference.attrKeyStore, displayField:'attr', valueField:'attr'}}}];
}});
Ext.define('analysis.view.chartEditor.components.SpecificChartConfigurator', {extend:'Ext.container.Container', alias:'widget.analysisSpecificChartConfigurator', localized:{title:'ANALYSIS_DATA_SELECTOR_TITLE'}, viewModel:{data:undefined}, axesConfigCmp:undefined, seriesFieldSetCmp:undefined, seriesConfigCmp:undefined, mainReference:undefined, attributeStore:undefined, initComponent:function() {
  this.viewModel = this.mainReference.getViewModel();
  this.on('afterrender', this.onAfterRender, this);
  this.callParent();
}, onAfterRender:function() {
  this.createItems();
}, createItems:function() {
  var $jscomp$this = this;
  var vm = this.getViewModel();
  this.chartType = vm.get('record.chartType');
  if (!this.chartType || this.chartType === '') {
    return;
  }
  var components = Ext.data.StoreManager.lookup('analysisChartType').findRecord('type', this.chartType).get('selectorComponents');
  components.forEach(function(specificCmp) {
    var newComponent = Ext.create({xtype:specificCmp, mainReference:$jscomp$this.mainReference, viewModel:{parent:$jscomp$this.getViewModel()}});
    $jscomp$this.add(newComponent);
  });
}});
Ext.define('analysis.view.chartEditor.components.TableChart.TableColumnsConfigurator', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisTableColumnsConfigurator', localized:{title:'ANALYSIS_TABLE_CONFIGURATOR_TITLE'}, dataAttributes:[], viewModel:{}, allAttributeStore:undefined, mainReference:undefined, columnsGridCmp:undefined, columnsGridStore:undefined, initComponent:function() {
  this.callParent();
  this.on('afterrender', this.onAfterRender, this);
}, onAfterRender:function() {
  this.createColumnsGrid();
}, readColumnsConfig:function() {
  var vm = this.mainReference.getViewModel();
  var columns = vm.get('record.config.columns');
  if (!Ext.isArray(columns)) {
    return [];
  }
  return columns;
}, createColumnsGrid:function() {
  var columnns = this.readColumnsConfig();
  this.columnsGridStore = Ext.create('Ext.data.Store', {model:'analysis.model.TableColumnsModel'});
  this.columnsGridStore.loadRawData(columnns);
  this.columnsGridStore.on('datachanged', this.onStoreDataChanged, this);
  this.columnsGridCmp = Ext.create('Ext.grid.Panel', {store:this.columnsGridStore, selModel:'cellmodel', plugins:{ptype:'cellediting', clicksToEdit:1}, viewConfig:{markDirty:false, plugins:{ptype:'gridviewdragdrop'}}, columns:this.createColumns(), buttons:this.createButtons()});
  this.add(this.columnsGridCmp);
}, onStoreDataChanged:function() {
  var myNestedData = BpcCommon.Util.getSerializedStoreData(this.columnsGridStore, 'json', {type:'json', writeAllFields:true, expandData:true, nameProperty:'mapping'});
  if (!Ext.isArray(myNestedData)) {
    if (myNestedData) {
      myNestedData = [myNestedData];
    } else {
      myNestedData = [];
    }
  }
  this.writeToRecord(myNestedData);
}, writeToRecord:function(newData) {
  var controller = this.mainReference.getController();
  var config = controller.getChartConfiguration();
  config.columns = newData;
  controller.setNewConfiguration(config);
}, onAddColumn:function() {
  var newColumn = Ext.create('analysis.model.TableColumnsModel', {id:Date.now().toString()});
  this.columnsGridStore.add(newColumn);
}, createButtons:function() {
  var me = this;
  return [{iconCls:'x-fal fa-plus', localized:{tooltip:'ANALYSIS_ADD'}, handler:me.onAddColumn.bind(me)}];
}, createColumns:function() {
  return [{xtype:'bpcHandleColumn'}, {xtype:'rownumberer'}, {text:BpcCommon.Api.getTranslation('ANALYSIS_TABLE_CONFIGURATOR_HEADER_TEXT'), dataIndex:'text', align:'left', sortable:false, editor:{completeOnEnter:false, field:{xtype:'bpcTextField'}}}, {text:BpcCommon.Api.getTranslation('ANALYSIS_TABLE_CONFIGURATOR_DATA_ATTRIBUTE'), dataIndex:'dataIndex', align:'left', flex:1, editor:{completeOnEnter:false, field:{xtype:'bpcComboBox', store:this.mainReference.attrKeyStore, displayField:'attr', valueField:'attr'}}}, 
  {text:BpcCommon.Api.getTranslation('ANALYSIS_LAYOUT_PARAMETER'), xtype:'bpcSettingColumn', type:'json', dataIndex:'additionalParameters', sortable:false, flex:1}, {xtype:'actioncolumn', width:50, sortable:false, menuDisabled:true, align:'left', items:[{iconCls:'x-fal fa-trash', tooltip:BpcCommon.Api.getTranslation('CORE_DELETE'), handler:function(grid, rowIndex) {
    grid.getStore().removeAt(rowIndex);
  }}]}];
}});
Ext.define('analysis.view.chartEditor.components.TemplateChart.TemplateConfigurator', {extend:'Ext.panel.Panel', alias:'widget.analysisTemplateConfigurator', layout:{type:'vbox', align:'stretch'}, helpLink:'https://docs.sencha.com/extjs/7.1.0/classic/Ext.XTemplate.html', initComponent:function() {
  this.createItems();
  this.createButtons();
  this.callParent();
}, createButtons:function() {
  this.bbar = [];
}, createItems:function() {
  this.htmlEditor = Ext.create({xtype:'bpcEditorField', layout:{type:'vbox', align:'stretch'}, minHeight:350, width:'100%', editorLanguage:'html', value:this.mainReference.getViewModel().get('record.config.templateContent'), listeners:{change:this.onChangeContent.bind(this)}});
  this.helpLinkCmp = Ext.create({xtype:'displayfield', hideLabel:true, height:50, margin:10, value:'\x3ca target\x3d"_blank" href\x3d' + this.helpLink + '\x3e\n                        \x3ci class\x3d"fal fa-info-circle"\x3e\x3c/i\x3e\n                        ' + BpcCommon.Api.getTranslation('ANALYSIS_SEE_X_TEMPLATE_DOCUMENTATION') + '\n                     \x3c/a\x3e'});
  this.items = [{xtype:'analysisFieldSet', localized:{title:'ANALYSIS_TEMPLATE_CONFIGURATOR_TITLE'}, layout:{type:'vbox'}, items:[this.htmlEditor, this.helpLinkCmp]}];
}, onChangeContent:function(el, val) {
  var controller = this.mainReference.getController();
  var config = controller.getChartConfiguration();
  config.templateContent = val;
  controller.setNewConfiguration(config);
}});
Ext.define('analysis.view.chartEditor.components.XYChart.AxesDetail', {extend:'Ext.panel.Panel', alias:'widget.analysisAxesDetail', layout:{type:'hbox', align:'stretch'}, viewModel:{data:{record:undefined, axesType:undefined, axesConfig:undefined}}, initComponent:function() {
  var me = this;
  var vm = me.getViewModel();
  vm.set('axesType', me.axesType);
  me.setJSONRecord(me.record);
  vm.bind('{axesConfig}', me.setAxesToConfig.bind(me), {deep:true});
  var showGrid = vm.get('axesConfig.renderer.grid.disabled') || true;
  var initBaseInterval = vm.get('axesConfig.baseInterval.timeUnit') || '';
  me.items = [{xtype:'container', flex:1, items:[{xtype:'analysisFieldSet', localized:{title:'CORE_SETTINGS'}, layout:'fit', margin:10, items:[{xtype:'analysisAxesTypeSelector', localized:{fieldLabel:'ANALYSIS_AXES_TYPE'}, bind:{value:'{axesConfig.type}'}, editable:false, labelWidth:200, matchFieldWidth:false, margin:'0 20px 10px 10px'}, {xtype:'bpcTextField', localized:{fieldLabel:'ANALYSIS_AXES_TITLE'}, bind:{value:'{axesConfig.title.text}'}, labelWidth:200, matchFieldWidth:false, margin:'0 20px 10px 10px'}]}, 
  {xtype:'analysisFieldSet', localized:{title:'ANALYSIS_STYLE_SETTINGS'}, items:[{xtype:'fieldcontainer', layout:'hbox', margin:'0 20px 10px 10px', items:[{xtype:'checkbox', localized:{fieldLabel:'ANALYSIS_SHOW_GRID_LINES'}, labelWidth:200, value:!showGrid, flex:1, listeners:{change:me.changeShowGrid.bind(me)}}, {xtype:'bpcNumberField', labelWidth:200, localized:{fieldLabel:'ANALYSIS_MINIMAL_GRID_DISTANCE'}, flex:1, listeners:{change:me.changeMinGridDistance.bind(me)}}]}, {xtype:'bpcComboBox', localized:{fieldLabel:'ANALYSIS_BASE_INTERVAL'}, 
  value:initBaseInterval, labelWidth:200, matchFieldWidth:false, margin:'0 20px 10px 10px', store:['second', 'minute', 'hour', 'day', 'week', 'month'], listeners:{change:me.changeBaseInterval.bind(me)}}]}]}, {xtype:'bpcJsonField', itemID:'seriesConfigJson', alias:'widget.analysisSeriesConfigJson', bind:{value:{bindTo:'{axesConfig}', deep:true}}, flex:1}];
  me.buttons = [{iconCls:'x-fal fa-times', localized:{tooltip:'ANALYSIS_CANCEL', text:'ANALYSIS_CANCEL'}, handler:function() {
    me.up().fireEvent('closeNoSave', me);
    me.up().close();
  }}, {iconCls:'x-fal fa-save', localized:{tooltip:'ANALYSIS_SAVE', text:'ANALYSIS_SAVE'}, handler:function() {
    me.up().fireEvent('closeSave', me);
    me.up().close();
  }}];
  me.callParent();
}, setJSONRecord:function(record) {
  var me = this;
  var vm = me.getViewModel();
  var axesConfig = record[vm.get('axesType')][0];
  vm.set('axesConfig', axesConfig);
  vm.set('record', record);
}, setAxesToConfig:function() {
  var me = this;
  var vm = me.getViewModel();
  var newConfig = vm.get('axesConfig');
  var axesType = vm.get('axesType');
  var routePath = 'record.' + axesType;
  vm.set(routePath, [newConfig]);
}, setBackgroundOpacitiy:function(el) {
  var me = this;
  var vm = me.getViewModel();
  vm.set('record.config.background.opacity', el.value);
}, setChartBackgroundColor:function(newColor) {
  var me = this;
  var vm = me.getViewModel();
  var newBackground = vm.get('record.config.background') || {fill:''};
  newBackground.fill = '#' + newColor;
  vm.set('record.config.background', newBackground);
}, changeShowGrid:function(el, value) {
  var me = this;
  var vm = me.getViewModel();
  var axesRenderer = vm.get('axesConfig.renderer') || {};
  var newAxesRenderer = {grid:{disabled:!value}};
  var newSetting = Ext.merge(axesRenderer, newAxesRenderer);
  vm.set('axesConfig.renderer', newSetting);
}, changeBaseInterval:function(el, value) {
  var me = this;
  var vm = me.getViewModel();
  var baseInterval = vm.get('axesConfig.baseInterval') || {timeUnit:'', count:undefined};
  baseInterval.timeUnit = value;
  baseInterval.count = baseInterval.count || 1;
  vm.set('axesConfig.baseInterval', baseInterval);
}, changeMinGridDistance:function(el, value) {
  var me = this;
  var vm = me.getViewModel();
  var renderer = vm.get('axesConfig.renderer') || {minGridDistance:undefined};
  renderer.minGridDistance = value;
  vm.set('axesConfig.renderer', renderer);
}});
Ext.define('analysis.view.chartEditor.components.XYChart.AxesTypeSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisAxesTypeSelector', valueField:'value', displayField:'name', queryMode:'local', editable:false, localized:{emptyText:'ANALYSIS_XY_CHART_AXES_SELECTOR_COMBO_EMPTY_TEXT'}, axesTypes:[{key:'ANALYSIS_VALUE_AXES_TYPE', value:'ValueAxis'}, {key:'ANALYSIS_CATEGORY_AXES_TYPE', value:'CategoryAxis'}, {key:'ANALYSIS_DATE_AXES_TYPE', value:'DateAxis'}], initComponent:function() {
  this.loadValues();
  this.callParent();
}, loadValues:function() {
  this.axesTypes.map(function(el) {
    el.name = BpcCommon.Api.getTranslation(el.key);
    return el;
  });
  this.store = Ext.create('Ext.data.Store', {autoLoad:true});
  this.store.loadRawData(this.axesTypes);
}});
Ext.define('analysis.view.chartEditor.components.XYChart.BulletSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisBulletSelector', localized:{fieldLabel:'ANALYSIS_CHART_BULLETS'}, valueField:'comboValue', displayField:'comboDisplay', initComponent:function() {
  this.store = [{comboValue:'Rectangle', comboDisplay:BpcCommon.Api.getTranslation('ANALYSIS_CHART_RECTANGLE')}, {comboValue:'Circle', comboDisplay:BpcCommon.Api.getTranslation('ANALYSIS_CHART_CIRCLE')}];
  this.callParent();
}});
Ext.define('analysis.view.chartEditor.components.XYChart.XYAxesConfigurator', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisXYAxesConfigurator', title:'Axes Selector', localized:{title:'ANALYSIS_XY_CHART_AXES_CONFIGURATOR_TITLE'}, viewModel:{data:{}}, axesFieldCmp:undefined, xAxesConfig:undefined, yAxesConfig:undefined, baseAxesCmp:undefined, mainReference:undefined, initComponent:function() {
  this.callParent();
  this.on('afterrender', this.onAfterRender, this);
}, onAfterRender:function() {
  this.mainReference.getViewModel().bind('{record.config}', this.onRefreshData, this, {deep:true});
  this.refreshUI();
}, onRefreshData:function() {
  this.refreshUI();
}, getAxesData:function() {
  var vm = this.mainReference.getViewModel();
  var chartConfig = vm.get('record.config');
  if (!chartConfig) {
    return;
  }
  if (Ext.isArray(chartConfig.xAxes) && Ext.isArray(chartConfig.yAxes)) {
    this.xAxesConfig = chartConfig.xAxes[0];
    this.yAxesConfig = chartConfig.yAxes[0];
  }
}, getAxesType:function(axesData) {
  if (!Ext.isArray(axesData)) {
    return {};
  }
  return axesData[0].type;
}, refreshUI:function() {
  this.getAxesData();
  if (this.axesFieldCmp) {
    this.remove(this.axesFieldCmp);
  }
  this.createTypeSelector();
  if (this.items) {
    this.add(this.axesFieldCmp);
  }
}, createTypeSelector:function() {
  var xAxesType = this.xAxesConfig.type;
  var yAxesType = this.yAxesConfig.type;
  this.axesFieldCmp = Ext.create({xtype:'fieldcontainer', layout:'hbox', items:[{xtype:'analysisAxesTypeSelector', itemId:'analysisXAxesTypeSelector', localized:{fieldLabel:'ANALYSIS_XY_X_AXES_TYPE'}, axesType:'xAxes', axesAttribute:'value', value:xAxesType, listeners:{change:this.setXAxesType.bind(this)}, triggers:{openDetail:{cls:'x-fal fa-cogs', weight:-2, handler:this.openDetailView.bind(this)}}, flex:1, margin:'0 0 0 10', labelWidth:100}, {xtype:'analysisAxesTypeSelector', itemId:'analysisYAxesTypeSelector', 
  localized:{fieldLabel:'ANALYSIS_XY_Y_AXES_TYPE'}, axesType:'yAxes', axesAttribute:'value', value:yAxesType, listeners:{change:this.setYAxesType.bind(this)}, triggers:{openDetail:{cls:'x-fal fa-cogs', weight:-2, handler:this.openDetailView.bind(this)}}, flex:1, margin:'0 0 0 10', labelWidth:100}]});
}, setXAxesType:function(el) {
  var me = this;
  var controller = me.up('analysisChartEditor').getController();
  var axesConfig = controller.getXYAxes();
  if (!Ext.isArray(axesConfig.xAxes)) {
    return;
  }
  axesConfig.xAxes[0].type = el.value;
  controller.setXYAxes(axesConfig);
}, setYAxesType:function(el) {
  var controller = this.mainReference.getController();
  var axesConfig = controller.getXYAxes();
  if (!Ext.isArray(axesConfig.yAxes)) {
    return;
  }
  axesConfig.yAxes[0].type = el.value;
  controller.setXYAxes(axesConfig);
}, openDetailView:function(el) {
  var me = this;
  var vm = this.mainReference.getViewModel();
  Ext.create({xtype:'bpcWindow', localized:{title:'ANALYSIS_AXES_CONFIGURATION'}, items:[{xtype:'analysisAxesDetail', itemId:'analysisAxesDetail', record:vm.get('record.config'), axesType:el.axesType}], listeners:{closeSave:me.closeSaveDetailView.bind(me)}});
}, closeSaveDetailView:function(el) {
  var newRecord = Ext.clone(el.getViewModel().get('record'));
  var controller = this.mainReference.getController();
  controller.setNewConfiguration(newRecord);
}});
Ext.define('analysis.view.chartEditor.components.XYChart.XYSeriesTypeSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.XYSeriesTypeSelector', store:['LineSeries', 'ColumnSeries', 'ColumnSeries3D', 'ConeSeries'], editable:false});
Ext.define('analysis.view.chartEditor.components.XYChart.series.LineSeriesStyle', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisLineSeriesStyle', localized:{title:'ANALYSIS_STYLE_SETTINGS'}, margin:10, layout:{type:'vbox', align:'stretch'}, emptyColor:'rgba(0,0,0,0)', serie:undefined, initComponent:function() {
  var me = this;
  me.items = me.createFieldSet();
  me.callParent();
}, createFieldSet:function() {
  var me = this;
  var bulletsTypeFromSerie = '';
  try {
    bulletsTypeFromSerie = this.serie.bullets[0].children[0].type;
  } catch (e) {
    bulletsTypeFromSerie = '';
  }
  return [{xtype:'analysisColorPicker', localized:{fieldLabel:'ANALYSIS_CHART_LINE_COLOR_PICKER_LABEL'}, value:this.serie.stroke || this.emptyColor, listeners:{colorSelect:me.setLineColor.bind(me)}, triggers:{openDetail:{cls:'x-fal fa-times', weight:-2, handler:me.removeLineColor.bind(me), tooltip:BpcCommon.Api.getTranslation('ANALYSIS_REMOVE_PROPERTY')}}}, {xtype:'bpcNumberField', localized:{fieldLabel:'ANALYSIS_CHART_LINE_WIDTH_PICKER_LABEL'}, value:this.serie.strokeWidth || undefined, minValue:0, 
  listeners:{change:me.setLineWidth.bind(me)}, triggers:{openDetail:{cls:'x-fal fa-times', weight:-2, handler:me.removeLineWidth.bind(me), tooltip:BpcCommon.Api.getTranslation('ANALYSIS_REMOVE_PROPERTY')}}}, {xtype:'analysisColorPicker', localized:{fieldLabel:'ANALYSIS_CHART_FILL_COLOR_PICKER_LABEL'}, value:this.serie.fill || this.emptyColor, listeners:{colorSelect:me.setFillColor.bind(me)}, triggers:{openDetail:{cls:'x-fal fa-times', weight:-2, handler:me.removeFillColor.bind(me), tooltip:BpcCommon.Api.getTranslation('ANALYSIS_REMOVE_PROPERTY')}}}, 
  {xtype:'analysisBulletSelector', value:bulletsTypeFromSerie, listeners:{change:me.setBulletType.bind(me)}, triggers:{openDetail:{cls:'x-fal fa-times', weight:-2, handler:me.removeBullets.bind(me), tooltip:BpcCommon.Api.getTranslation('ANALYSIS_REMOVE_PROPERTY')}}}];
}, setBulletType:function(cmp, type) {
  var newBullets = [{children:[{type:type, width:10, height:10, horizontalCenter:'middle', verticalCenter:'middle'}]}];
  this.serie.bullets = newBullets;
  this.onSerieChanged();
}, removeBullets:function(el) {
  el.setValue('');
  delete this.serie.bullets;
  this.onSerieChanged();
}, setLineWidth:function(el, width) {
  this.serie.strokeWidth = width;
  this.onSerieChanged();
}, removeLineWidth:function(el) {
  el.setValue(1);
  delete this.serie.strokeWidth;
  this.onSerieChanged();
}, setFillColor:function(el, newColor) {
  this.serie.fill = newColor;
  this.serie.fillOpacity = 1;
  this.onSerieChanged();
}, removeFillColor:function(el) {
  el.setValue(this.emptyColor);
  delete this.serie.fillOpacity;
  delete this.serie.fill;
  this.onSerieChanged();
}, setLineColor:function(el, newColor) {
  this.serie.stroke = newColor;
  this.onSerieChanged();
}, removeLineColor:function(el) {
  el.setValue(this.emptyColor);
  delete this.serie.stroke;
  this.onSerieChanged();
}, onSerieChanged:function() {
  this.fireEvent('serieChanged', this, this.serie);
}});
Ext.define('analysis.view.chartEditor.components.XYChart.series.SeriesConfigurator', {extend:'Ext.panel.Panel', alias:'widget.analysisSeriesConfigurator', layout:{type:'hbox', align:'stretch'}, viewModel:{data:{serie:undefined, chartConfig:undefined}}, mainReference:undefined, selSerieId:undefined, parentChartConfig:undefined, chartConfig:undefined, selSeriesIndex:undefined, initComponent:function() {
  var me = this;
  me.buttons = [{xtype:'toggleslidefield', localized:{fieldLabel:'ANALYSIS_LIVE_UPDATE_FIELD_LABEL'}, labelAlign:'top', labelWidth:40, bind:{value:'{globalLiveUpdate}'}}, '-\x3e', {iconCls:'x-fal fa-times', ui:'secondary', localized:{tooltip:'ANALYSIS_CANCEL', text:'ANALYSIS_CANCEL'}, handler:function() {
    me.up().fireEvent('closeNoSave', me);
    me.up().close();
  }}, {iconCls:'x-fal fa-sync', ui:'secondary', localized:{tooltip:'ANALYSIS_UNDO_CHANGES', text:'ANALYSIS_UNDO_CHANGES'}, handler:me.renderSeriesConfigurator.bind(me)}, {iconCls:'x-fal fa-save', localized:{tooltip:'ANALYSIS_SAVE', text:'ANALYSIS_SAVE'}, handler:function() {
    me.fireEvent('closeSave', me);
  }}];
  me.callParent();
  me.renderSeriesConfigurator();
}, prepareChartConfig:function() {
  var me = this;
  try {
    var retConfig = Ext.clone(this.parentChartConfig);
    delete retConfig.config.scrollbarX;
    delete retConfig.config.scrollbarY;
    Ext.each(retConfig.config.series, function(serie, idx) {
      if (serie.id === me.selSerieId) {
        me.selSerie = serie;
        me.selSeriesIndex = idx;
      } else {
        serie.hidden = true;
      }
    });
    this.chartConfig = retConfig;
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR prepare Data', dump:e, stack:true, level:'error'});
  }
}, renderSeriesConfigurator:function() {
  var me = this;
  me.prepareChartConfig();
  me.removeAll();
  me.add(me.createItems());
}, syncChart:function() {
  var liveUpdate = this.mainReference.getViewModel().get('globalLiveUpdate');
  if (liveUpdate === false) {
    return;
  }
  var chartViewerCmp = this.down('analysisChartViewer');
  if (chartViewerCmp) {
    chartViewerCmp.chartConfig = this.chartConfig;
    chartViewerCmp.renderChart();
  }
}, syncUI:function() {
  var seriesUi = this.down('analysisSeriesUI');
  if (seriesUi) {
    seriesUi.serie = this.selSerie;
    seriesUi.renderSeriesUI();
  }
}, syncJsonEditor:function() {
  var jsonEditor = this.down('bpcJsonField');
  var itemIndex = this.items.indexOf(jsonEditor);
  this.remove(jsonEditor);
  this.insert(itemIndex, this.getJSONField());
}, getJSONField:function() {
  var me = this;
  return {xtype:'bpcJsonField', flex:1, value:this.selSerie, listeners:{change:me.onSeriesChangedByJsonEditor.bind(me)}};
}, createItems:function() {
  var me = this;
  return [{xtype:'analysisSeriesUI', flex:1, serie:this.selSerie, listeners:{seriesChanged:me.onSeriesChangedByUI.bind(me)}}, {xtype:'analysisChartViewer', flex:2, chartConfig:this.chartConfig, moduleId:me.mainReference.moduleId}, this.getJSONField()];
}, onSeriesChangedByJsonEditor:function(cmp, newVal) {
  if (!newVal) {
    return;
  }
  this.writeSerieInChartConfig(newVal);
  this.syncChart();
  this.syncUI();
}, onSeriesChangedByUI:function(cmp, newVal) {
  if (!newVal) {
    return;
  }
  this.writeSerieInChartConfig(newVal);
  this.syncJsonEditor();
  this.syncChart();
}, writeSerieInChartConfig:function(newSerie) {
  this.selSerie = newSerie;
  this.chartConfig.config.series[this.selSeriesIndex] = newSerie;
}});
Ext.define('analysis.view.chartEditor.components.XYChart.series.SeriesUI', {extend:'Ext.container.Container', alias:'widget.analysisSeriesUI', serie:undefined, initComponent:function() {
  var me = this;
  me.callParent(arguments);
  me.renderSeriesUI();
}, onSerieChanged:function() {
  this.fireEvent('seriesChanged', this, this.serie);
}, renderSeriesUI:function() {
  var me = this;
  me.removeAll();
  me.add(me.createItems());
}, createItems:function() {
  var me = this;
  if (Ext.isEmpty(me.serie)) {
    return [];
  }
  return [{xtype:'analysisFieldSet', localized:{title:'ANALYSIS_DATASET_BASIC_SETTINGS'}, margin:10, items:[{xtype:'XYSeriesTypeSelector', localized:{fieldLabel:'ANALYSIS_XY_SERIES_TYPE'}, value:me.serie.type, listeners:{change:me.changeSeriesType.bind(me)}}, {xtype:'bpcTextField', localized:{fieldLabel:'CORE_NAME'}, value:me.serie.name, listeners:{change:me.changeSeriesName.bind(me)}}]}, {xtype:'analysisLineSeriesStyle', listeners:{serieChanged:me.onSerieChangedBySubCmp.bind(me)}, serie:this.serie}];
}, onSerieChangedBySubCmp:function(cmp, newSerie) {
  this.serie = newSerie;
  this.onSerieChanged();
}, changeSeriesName:function(el, value) {
  this.serie.name = value;
  this.onSerieChanged();
}, changeSeriesType:function(el, value) {
  this.serie.type = value;
  this.onSerieChanged();
}});
Ext.define('analysis.view.chartEditor.components.XYChart.series.XYSeriesGrid', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisXYSeriesGrid', localized:{title:'ANALYSIS_XY_DATA_SELECTOR_TITLE'}, chartData:undefined, dataAttributes:[], viewModel:{}, store:undefined, allAttributeStore:undefined, mainReference:undefined, seriesGridCmp:undefined, seriesGridStore:undefined, initComponent:function() {
  this.callParent();
  this.on('afterrender', this.onAfterRender, this);
}, onAfterRender:function() {
  this.createSeriesGrid();
}, readSeriesConfig:function() {
  var vm = this.mainReference.getViewModel();
  var chartSeries = vm.get('record.config.series');
  var flatSeries = [];
  if (!Ext.isArray(chartSeries)) {
    return [];
  }
  chartSeries.forEach(function(el) {
    var dataFields = el.dataFields;
    var serie = {type:el.type, xAttr:dataFields.dateX || dataFields.valueX || dataFields.categoryX, yAttr:dataFields.dateY || dataFields.valueY || dataFields.categoryY};
    flatSeries.push(serie);
  });
  return flatSeries;
}, createSeriesGrid:function() {
  var flatSeries = this.readSeriesConfig();
  this.seriesGridStore = Ext.create('Ext.data.Store', {model:'analysis.model.XYSeriesModel'});
  this.seriesGridStore.loadRawData(flatSeries);
  this.seriesGridStore.on('datachanged', this.onStoreDataChanged, this);
  this.seriesGridCmp = Ext.create('Ext.grid.Panel', {itemId:'analysisSeriesGridCmp', store:this.seriesGridStore, viewConfig:{markDirty:false}, minButtonWidth:30, selModel:'cellmodel', plugins:{ptype:'cellediting', clicksToEdit:1}, columns:this.createColumns(), buttons:this.createButtons()});
  this.add(this.seriesGridCmp);
}, onStoreDataChanged:function() {
  var myNestedData = BpcCommon.Util.getSerializedStoreData(this.seriesGridStore, 'json', {type:'json', writeAllFields:true, expandData:true, nameProperty:'mapping'});
  if (!Ext.isArray(myNestedData)) {
    myNestedData = [myNestedData];
  }
  this.writeToRecord(myNestedData);
}, writeToRecord:function(newData) {
  var controller = this.mainReference.getController();
  var convertData = controller.convertXYSeries(newData);
  controller.mergeChartSeries(convertData);
  this.adaptXYAxesConfiguration();
}, adaptXYAxesConfiguration:function() {
  var vm = this.getViewModel();
  var mainViewModel = this.mainReference.getViewModel();
  var firstSeriesAttributes = mainViewModel.get('record.config.series.0.dataFields');
  var adativeDataFields;
  var config = Ext.clone(vm.get('record.config'));
  var xAxes = config.xAxes;
  var yAxes = config.yAxes;
  if (firstSeriesAttributes.hasOwnProperty('categoryX')) {
    adativeDataFields = {category:firstSeriesAttributes.categoryX};
    xAxes[0].dataFields = adativeDataFields;
    yAxes[0].dataFields = {};
  } else if (firstSeriesAttributes.hasOwnProperty('categoryY')) {
    adativeDataFields = {category:firstSeriesAttributes.categoryY};
    xAxes[0].dataFields = {};
    yAxes[0].dataFields = adativeDataFields;
  }
  config.xAxes = xAxes;
  config.yAxes = yAxes;
  vm.set('record.config', config);
}, onAddSeries:function() {
  var newSerie = Ext.create('analysis.model.XYSeriesModel');
  this.seriesGridStore.add(newSerie);
}, createButtons:function() {
  var me = this;
  return [{iconCls:'x-fal fa-plus', localized:{tooltip:'ANALYSIS_ADD'}, handler:me.onAddSeries.bind(me)}];
}, createColumns:function() {
  return [{xtype:'rownumberer'}, {text:BpcCommon.Api.getTranslation('CORE_TYPE'), dataIndex:'type', align:'left', sortable:false, flex:1, editor:{completeOnEnter:false, field:{xtype:'XYSeriesTypeSelector'}}}, {text:BpcCommon.Api.getTranslation('ANALYSIS_XY_X_AXES'), dataIndex:'xAttr', align:'left', flex:1, editor:{completeOnEnter:false, field:{xtype:'bpcComboBox', store:this.mainReference.attrKeyStore, displayField:'attr', valueField:'attr'}}}, {text:BpcCommon.Api.getTranslation('ANALYSIS_XY_Y_AXES'), 
  dataIndex:'yAttr', flex:1, align:'left', editor:{completeOnEnter:false, field:{xtype:'bpcComboBox', store:this.mainReference.attrKeyStore, displayField:'attr', valueField:'attr'}}}, {xtype:'actioncolumn', width:35, sortable:false, menuDisabled:true, align:'center', items:[{iconCls:'x-fal fa-cogs', tooltip:BpcCommon.lang.Current.ANALYSIS_ADVANCED_SETTINGS, handler:this.openDetailView.bind(this)}]}, {xtype:'actioncolumn', width:35, sortable:false, menuDisabled:true, align:'center', items:[{iconCls:'x-fal fa-copy', 
  tooltip:BpcCommon.lang.Current.ANALYSIS_DUPLICATE, handler:this.duplicateSerie.bind(this)}]}, {xtype:'actioncolumn', width:35, sortable:false, menuDisabled:true, align:'center', items:[{iconCls:'x-fal fa-trash', tooltip:BpcCommon.lang.Current.CORE_DELETE, handler:function(grid, rowIndex) {
    grid.getStore().removeAt(rowIndex);
  }}]}];
}, openDetailView:function(grid, rowIndex) {
  var controller = this.mainReference.getController();
  var nestedSeries = controller.getChartSeries();
  if (!nestedSeries[rowIndex]) {
    return 0;
  }
  Ext.create({xtype:'bpcWindow', localized:{title:'ANALYSIS_DATA_SELECTOR_TITLE'}, items:[{xtype:'analysisSeriesConfigurator', itemId:'analysisSeriesConfigurator', selSerieId:nestedSeries[rowIndex].id, parentChartConfig:this.mainReference.getViewModel().get('record').getData(), mainReference:this.mainReference, viewModel:{parent:this.getViewModel()}, listeners:{closeSave:this.saveChangesFromDetailView.bind(this)}}]});
}, saveChangesFromDetailView:function(el) {
  var serie = el.selSerie;
  var seriesIndex = el.selSeriesIndex;
  var controller = this.mainReference.getController();
  if (Ext.isEmpty(serie) || Ext.isEmpty(seriesIndex) || Ext.isEmpty(controller)) {
    return;
  }
  controller.replaceChartSerie(serie, seriesIndex);
  var detailWindow = el.up('bpcWindow');
  if (detailWindow) {
    detailWindow.close();
  }
}, duplicateSerie:function(el, row) {
  var seriesList = analysis.assets.Helpers.getRawDataFromStore(this.seriesGridStore);
  var duplicateElement = seriesList[row];
  var newElement = Ext.apply(duplicateElement, {id:Date.now(), stroke:analysis.assets.Colors.virtimoDarkGrey, fill:analysis.assets.Colors.virtimoOrange});
  this.seriesGridStore.add(newElement);
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.ContextVariablesGrid', {extend:'Ext.grid.Panel', alias:'widget.analysisContextVariablesGrid', itemId:'analysisContextVariablesGrid', moduleId:undefined, dataSetId:undefined, selModel:{type:'cellmodel'}, margin:0, plugins:{cellediting:{clicksToEdit:1}}, viewConfig:{markDirty:false}, store:true, initComponent:function() {
  var me = this;
  me.columns = [{localized:{text:'CORE_NAME'}, dataIndex:'name', flex:1, editor:{allowBlank:false, selectOnFocus:false}}, {xtype:'bpcSettingColumn', localized:{text:'CORE_VALUE'}, dataIndex:'value', flex:1, editor:{allowBlank:false, selectOnFocus:false}}];
  var dataSetConfig = analysis.assets.Helpers.getDataSetConfig(me.moduleId, me.dataSetId);
  var variables = [];
  if (dataSetConfig) {
    variables = Ext.clone(dataSetConfig.variables) || [];
  }
  me.store = Ext.create('Ext.data.Store', {data:variables, listeners:{dataChanged:function() {
    this.fireEvent('onDataChange');
  }.bind(me)}});
  Ext.on('saveDataSetConfig', function(dataSetConfig) {
    if (me.dataSetId === dataSetConfig.id) {
      var variables$1 = Ext.clone(dataSetConfig.variables);
      me.setContextVariables(variables$1);
    }
  });
  this.buttons = [{localized:{text:'CORE_REFRESH'}, iconCls:'fal fa-sync', handler:this.refresh.bind(this)}];
  this.callParent();
}, setContextVariables:function(variables) {
  var storeData = variables;
  if (this.store) {
    this.store.setData(storeData);
  } else {
    this.store = Ext.create('Ext.data.Store', {data:storeData});
  }
}, refresh:function() {
  var storeData = this.getStore().getData().items;
  var dataSetList = this.up('analysisDataSetEditorContainer').down('analysisDataSetList');
  var dataSetConfigRecord = dataSetList.getStore().findRecord('id', this.dataSetId);
  var configFormCmp = dataSetConfigRecord.dataSetEditor.down('analysisDataSetConfigForm');
  var vars = storeData.map(function(item) {
    return item.data;
  });
  configFormCmp.getController().runAndSetPreviewDataSetConfig(vars);
}});
Ext.define('analysis.view.dataSetEditor.DataSetEditor', {extend:'Ext.panel.Panel', alias:'widget.analysisDataSetEditor', layout:'fit', moduleId:undefined, scrollable:true, routePath:':dataSetId', initComponent:function() {
  var dataSetId = this.record.get('id');
  this.routePath = dataSetId;
  this.items = [{xtype:'tabpanel', itemId:'analysisDataSetConfig', items:[{xtype:'panel', layout:{type:'hbox', align:'stretch'}, routePath:'editor', iconCls:'x-fal fa-cog', localized:{title:'ANALYSIS_DATA_SET_CONFIG'}, items:[{flex:1, xtype:'analysisDataSetConfigForm', moduleId:this.moduleId, viewModel:{data:{record:this.record}}}, {xtype:'bpcSplitter', collapseTarget:'next'}, {flex:1, xtype:'analysisDataViewerContainer', collapseDirection:'right', floatable:false, collapsible:true, collapsed:true, 
  moduleId:this.moduleId, record:this.record}]}, {xtype:'analysisDataModifier', iconCls:'x-fal fa-random', dataSetConfig:this.record, moduleId:this.moduleId, tabConfig:{tooltip:BpcCommon.Api.getTranslation('ANALYSIS_SAVE_BEFORE_MODIFYING'), style:{pointerEvents:'all'}}, viewModel:{data:{dataSetConfig:this.record}}, bind:{disabled:'{dataSetConfig.dirty}'}}]}];
  this.callParent();
}});
Ext.define('analysis.view.dataSetEditor.DataSetEditorContainer', {extend:'Ext.panel.Panel', alias:'widget.analysisDataSetEditorContainer', itemId:'analysisDataSetEditorContainer', layout:{type:'hbox', align:'stretch'}, viewModel:{data:{}}, routePath:'data', initComponent:function() {
  this.defaults = {moduleId:this.moduleId};
  this.items = [{xtype:'analysisDataSetList', split:true, collapsible:true, collapseDirection:'left', width:300, minWidth:300}, {xtype:'bpcSplitter'}, {xtype:'container', layout:'card', itemId:'analysisDataSetEditorWrapper', flex:3, items:[]}];
  this.callParent();
}});
Ext.define('analysis.view.dataSetEditor.DataSetSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisDataSetSelector', matchFieldWidth:false, valueField:'id', displayField:'name', queryMode:'local', anyMatch:true, moduleId:undefined, editable:false, localized:{emptyText:'ANALYSIS_DATA_SET_SELECTOR_EMPTY_TEXT'}, triggers:{showDataSetEditor:{tooltip:BpcCommon.lang.Current.ANALYSIS_JUMP_TO_DATA_SET, cls:BpcCommon.Icons.LINK, weight:-2, scope:'this', handler:'showDataSetEditor'}}, 
initComponent:function() {
  this.store = Ext.create('Ext.data.ChainedStore', {source:analysis.assets.Helpers.getDataSetListStore(this.moduleId)});
  this.callParent();
  this.store.sort('name', 'ASC');
}, showDataSetEditor:function(me) {
  var mainCmp = me.up('bpcAnalysis');
  mainCmp.jumpTo('analysisDataSetEditorContainer', me.getValue());
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.RelatedItemsSelectorBtn', {extend:'Ext.button.Button', alias:'widget.analysisrelatedItemsSelectorBtn', itemId:'analysisrelatedItemsSelectorBtn', moduleId:undefined, dataSetId:undefined, chartId:undefined, relation:undefined, initComponent:function() {
  var me = this;
  me.menu = this.getMenuItems();
  this.listeners = {mouseover:this.updateMenuItems.bind(this)};
  this.callParent();
}, updateMenuItems:function() {
  var me = this;
  var menuItems = me.getMenuItems();
  me.setMenu(menuItems);
}, getMenuItems:function() {
  var me = this;
  var addNewMenuItem = {localized:{text:'ANALYSIS_ADD_NEW'}, iconCls:'x-fal fa-plus', handler:me.addNew.bind(me, me.relation)};
  var menu = [];
  var relatedConfigs = [];
  if (me.relation === analysis.assets.ConfigKeys.relationType.RELATION_CHARTS_TO_DATA_SET) {
    relatedConfigs = me.getRelatedChartsToDataSet(me.moduleId, me.dataSetId);
  } else if (me.relation === analysis.assets.ConfigKeys.relationType.RELATION_REPORTS_TO_CHART) {
    relatedConfigs = me.getRelatedReportsToChart(me.moduleId, me.chartId);
  }
  var relatedMenuItems = relatedConfigs.map(function(item) {
    return {targetId:item.id, text:item.name, iconCls:'x-fal fa-pencil-alt', handler:me.jumpToTarget.bind(me, me.relation, item.id)};
  });
  return menu.concat(relatedMenuItems).concat(addNewMenuItem);
}, getRelatedChartsToDataSet:function(moduleId, dataSetId) {
  var chartConfigList = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.chartsConfigs);
  var relatedChartsConfigList = chartConfigList.filter(function(item) {
    return item.dataSetId === dataSetId;
  });
  return relatedChartsConfigList;
}, getRelatedReportsToChart:function(moduleId, chartId) {
  var reportConfigList = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.reportsConfigs);
  var relatedReportConfigList = reportConfigList.filter(function(item) {
    var chartList = item.charts;
    if (chartList) {
      if (chartList.find(function(chartConfig) {
        return chartConfig.chartID === chartId;
      })) {
        return true;
      }
    }
    return false;
  });
  return relatedReportConfigList;
}, addNew:function(relation) {
  var me = this;
  if (relation === analysis.assets.ConfigKeys.relationType.RELATION_CHARTS_TO_DATA_SET) {
    var analysisMain = me.up('analysisMain');
    var chartListCmp = analysisMain.down('analysisChartList');
    var chartEditorCmp = analysisMain.down('analysisChartEditorContainer');
    chartListCmp.addNewChart(me.dataSetId);
    analysisMain.setActiveItem(chartEditorCmp);
  } else if (relation === analysis.assets.ConfigKeys.relationType.RELATION_REPORTS_TO_CHART) {
    var analysisMain$2 = me.up('analysisMain');
    var reportListCmp = analysisMain$2.down('analysisReportList');
    var reportEditorCmp = analysisMain$2.down('analysisReportEditorContainer');
    analysisMain$2.setActiveItem(reportEditorCmp);
    reportListCmp.getController().onAddReportConfig();
  }
}, jumpToTarget:function(relation, targetId) {
  var mainCmp = this.up('bpcAnalysis');
  if (relation === analysis.assets.ConfigKeys.relationType.RELATION_CHARTS_TO_DATA_SET) {
    mainCmp.jumpTo('analysisChartEditorContainer', targetId);
  } else if (relation === analysis.assets.ConfigKeys.relationType.RELATION_REPORTS_TO_CHART) {
    mainCmp.jumpTo('analysisReportEditorContainer', targetId);
  }
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.DataSetConfigForm', {extend:'Ext.form.Panel', alias:'widget.analysisDataSetConfigForm', controller:'analysisDataSetConfigFromController', scrollable:true, viewModel:{data:{record:undefined}, formulas:{hasUnsavedChanges:{bind:{bindTo:'{record}', deep:true}, get:function(record) {
  return record ? record.dirty : false;
}}}}, layout:{type:'vbox', align:'stretch'}, defaults:{margin:'0 20px 10px 10px'}, plugins:{bpcFieldValidator:{validationButtonSelector:'#formChecker'}}, initComponent:function() {
  var viewModel = this.getViewModel();
  this.items = [{xtype:'fieldset', localized:{title:'ANALYSIS_DATASET_BASIC_SETTINGS'}, collapsible:true, layout:{type:'vbox', align:'stretch'}, defaults:{labelWidth:100}, items:[{xtype:'fieldcontainer', layout:'hbox', items:[{xtype:'bpcTextField', flex:1, localized:{fieldLabel:'CORE_NAME'}, itemId:'name', bind:{value:'{record.name}'}, allowBlank:false}, {xtype:'bpcComboBox', flex:1, margin:'0 0 0 10', allowBlank:false, editable:false, localized:{fieldLabel:'ANALYSIS_CHOOSE_DATA_SOURCE_TYPE'}, queryMode:'local', 
  displayField:'name', publishes:'value', bind:{value:'{record.sourceType}'}, store:{data:[{name:'Elasticsearch'}, {name:'JSON'}, {name:'HTTP'}, {name:'inubit'}]}}]}]}, {xtype:'fieldset', localized:{title:'ANALYSIS_DATASET_ADDITIONAL_VARS'}, collapsible:true, items:[{xtype:'fieldcontainer', layout:'fit', items:[{xtype:'analysisVariablesGrid', viewModel:this.getViewModel()}]}]}, {xtype:'analysisSpecificConfigs-elasticsearch', viewModel:{data:viewModel.get('record')}, bind:{hidden:"{record.sourceType !\x3d\x3d 'Elasticsearch'}", 
  disabled:"{record.sourceType !\x3d\x3d 'Elasticsearch'}"}, minHeight:500, flex:1, defaults:{labelWidth:100}}, {xtype:'analysisSpecificConfigs-json', viewModel:{data:viewModel.get('record')}, bind:{hidden:"{record.sourceType !\x3d\x3d 'JSON'}", disabled:"{record.sourceType !\x3d\x3d 'JSON'}"}, minHeight:500, flex:1, defaults:{labelWidth:100}}, {xtype:'analysisSpecificConfigs-http', viewModel:{data:viewModel.get('record')}, bind:{hidden:"{record.sourceType !\x3d\x3d 'HTTP'}", disabled:"{record.sourceType !\x3d\x3d 'HTTP'}"}, 
  flex:1, defaults:{labelWidth:100}}, {xtype:'analysisSpecificConfigs-inubit', viewModel:{data:viewModel.get('record')}, bind:{hidden:"{record.sourceType !\x3d\x3d 'inubit'}", disabled:"{record.sourceType !\x3d\x3d 'inubit'}"}, flex:1, defaults:{labelWidth:100}}];
  var itemArray = [{iconCls:'fal fa-exclamation-triangle warningColor', ui:'apptoolbardefault', localized:{text:'ANALYSIS_UNSAVED_CHANGES'}, bind:{hidden:'{!hasUnsavedChanges}'}, handler:'onSave'}, '-\x3e', {iconCls:BpcCommon.Icons.CHECKLIST, ui:'secondary', itemId:'formChecker', margin:5}, {xtype:'button', localized:{text:'ANALYSIS_TEST_QUERY'}, iconCls:'fal fa-play', ui:'secondary', handler:'applyDatasetConfig'}, {xtype:'button', ui:'primary', localized:{text:'CORE_SAVE'}, iconCls:'fal fa-save', 
  handler:'onSave', margin:5}];
  this.dockedItems = [{xtype:'toolbar', dock:'bottom', ui:'footer', overflowHandler:'scroller', items:itemArray}];
  this.callParent();
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.DataSetConfigFromController', {extend:'Ext.app.ViewController', alias:'controller.analysisDataSetConfigFromController', onSave:function() {
  var configForm = this.getView();
  if (!configForm.isValid()) {
    BpcCommon.Api.showNotification({text:'Validierung fehlgeschlagen', popUp:true, type:'error'});
  } else {
    var dataSetEditor = configForm.up('analysisDataSetEditor');
    var moduleId = dataSetEditor.moduleId;
    var viewModel = this.getView().getViewModel();
    var record = viewModel.get('record');
    return record.saveDataSet(moduleId, {success:function() {
      BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_DATA_SET_CONFIG_SAVED')});
      record.save();
      Ext.GlobalEvents.fireEvent('saveDataSetConfig', record.getData());
    }, failure:function(record, operation) {
      var error = operation.error;
      try {
        var response = JSON.parse(error.response.responseText);
        BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
      } catch (err) {
        Ext.log({level:'error', message:'Save data set config error'});
      }
    }});
  }
}, applyDatasetConfig:function() {
  var $jscomp$this = this;
  var configForm = this.getView();
  if (!configForm.isValid()) {
    BpcCommon.Api.showNotification({text:'Validierung fehlgeschlagen', popUp:true, type:'error'});
  } else {
    var dataSetConfig = configForm.getViewModel().get('record');
    var moduleId = configForm.up('analysisDataSetEditor').moduleId;
    analysis.assets.Helpers.updateSettingModel(moduleId, analysis.assets.ConfigKeys.dataSetsConfigs, dataSetConfig.getData()).save({success:function() {
      dataSetConfig.save();
      Ext.GlobalEvents.fireEvent('saveDataSetConfig', dataSetConfig.getData());
      $jscomp$this.runAndSetPreviewDataSetConfig(dataSetConfig.get('variables'));
    }});
  }
}, runAndSetPreviewDataSetConfig:function(vars) {
  var configForm = this.getView();
  var dataSetEditor = configForm.up('analysisDataSetEditor');
  var dataViewerContainer = dataSetEditor.down('analysisDataViewerContainer');
  var dataViewer = dataViewerContainer.down('analysisDataViewer');
  var moduleId = dataSetEditor.moduleId;
  var dataSetConfig = configForm.getViewModel().get('record');
  var dataSetId = dataSetConfig.get('id');
  dataViewerContainer.mask(BpcCommon.Api.getTranslation('CORE_LOAD_DATA'));
  var success = function(response) {
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_DATA_SET_CONFIG_SAVED_AND_EXECUTED')});
    var responseText = response.responseText;
    var responseObj = JSON.parse(responseText);
    var dataViewerViewModel = dataViewer.getViewModel();
    dataViewerViewModel.set('rawData', responseObj);
    dataViewerContainer.setCollapsed(false);
    analysis.assets.Helpers.getModifiedData(moduleId, dataSetId, false, false).then({success:function(response) {
      dataViewerViewModel.set('modifiedData', JSON.parse(response.responseText));
    }, failure:function(response) {
      var modifierResponseObj = JSON.parse(response.responseText);
      modifierResponseObj.error = BpcCommon.Api.getTranslation(modifierResponseObj.error);
      dataViewerViewModel.set('modifiedData', modifierResponseObj);
      BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_SCRIPT_EXECUTION_ERROR') + ': ' + modifierResponseObj.cause});
    }});
    dataViewerContainer.unmask();
    Ext.GlobalEvents.fireEvent('dataSetUpdated', responseObj, dataSetConfig);
  };
  var failure = function(response) {
    var responseText = response.responseText;
    var responseObj = JSON.parse(responseText);
    dataViewerContainer.unmask();
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_LOAD_DATA_ERROR') + ': ' + responseObj.error + ' \n ' + (responseObj.cause ? responseObj.cause : ''), popUp:true, type:'error'});
  };
  analysis.assets.Helpers.getDataSet(moduleId, dataSetId, vars, true).then(success, failure);
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.DataSetModel', {extend:'Ext.data.Model', idProperty:'id', fields:[{name:'id', type:'string'}, {name:'name', type:'string'}, {name:'sourceType', type:'string', defaultValue:'Elasticsearch'}, {name:'variables', defaultValue:[]}, {name:'modifiers', defaultValue:[]}], proxy:{type:'memory'}, saveDataSet:function(moduleId, handlers) {
  var newSetting = this.getData();
  if (moduleId) {
    var newSettingModel = analysis.assets.Helpers.updateSettingModel(moduleId, analysis.assets.ConfigKeys.dataSetsConfigs, newSetting);
    newSettingModel.save(handlers);
  }
}, addModifier:function(modifier) {
  var modifiers = this.get('modifiers');
  modifiers.push(modifier);
}, removeModifier:function(modifierId) {
  var modifiers = this.get('modifiers');
  Ext.Array.removeAt(modifiers, modifiers.findIndex(function(item) {
    return item.id === modifierId;
  }));
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.DataViewer', {extend:'Ext.tab.Panel', alias:'widget.analysisDataViewer', itemId:'analysisDataViewer', flex:1, minWidth:500, scrollable:true, defaults:{layout:'fit'}, viewModel:{data:{rawData:undefined, modifiedData:undefined}}, initComponent:function() {
  this.items = [{xtype:'panel', iconCls:'x-fal fa-database', localized:{title:'ANALYSIS_RAW_DATA'}, items:[{xtype:'bpcJsonField', itemId:'rawDataView', bind:{value:'{rawData}'}, editorConfigs:{readOnly:true}}]}, {xtype:'panel', iconCls:'x-fal fa-random', localized:{title:'ANALYSIS_MODIFIED_DATA'}, items:[{xtype:'bpcJsonField', itemId:'modifiedDataView', bind:{value:'{modifiedData}'}, readOnly:true}]}];
  if (this.dataType === analysis.assets.ConfigKeys.dataTypes.LIST) {
    Ext.Array.insert(this.items, 1, {xtype:'grid', localized:{title:'ANALYSIS_TABLE_DATA_VIEW'}});
  }
  this.callParent();
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.DataViewerContainer', {extend:'Ext.panel.Panel', alias:'widget.analysisDataViewerContainer', itemId:'analysisDataViewerContainer', localized:{title:'ANALYSIS_DATA'}, flex:1, minWidth:500, scrollable:true, layout:{type:'vbox', align:'stretch'}, viewModel:{data:{count:0}}, record:undefined, initComponent:function() {
  this.items = [{xtype:'fieldset', localized:{title:'ANALYSIS_CONTEXT_VARIABLES'}, collapsible:true, collapsed:true, items:[{xtype:'analysisContextVariablesGrid', moduleId:this.moduleId, dataSetId:this.record.get('id')}]}, {xtype:'analysisDataViewer'}];
  this.bbar = [{xtype:'tbtext', ui:'apptoolbardefault', bind:{html:'\x3cspan class\x3d"warningColor"\x3e\n                           \x3ci class\x3d"fal fa-info-circle"\x3e\x3c/i\x3e\n                           {count} ' + BpcCommon.Api.getTranslation('ANALYSIS_DISPLAYED_DATA_COUNT') + '\n                        \x3c/span\x3e', hidden:'{count \x3d\x3d\x3d 0}'}, margin:5}, '-\x3e', {xtype:'analysisrelatedItemsSelectorBtn', ui:'primary', localized:{text:'ANALYSIS_VISUALIZE'}, iconCls:'fal fa-chart-pie-alt', 
  relation:analysis.assets.ConfigKeys.relationType.RELATION_CHARTS_TO_DATA_SET, moduleId:this.moduleId, dataSetId:this.record.get('id'), margin:5}];
  this.callParent();
}, openDataModifier:function() {
  var dataSetConfigForm = this.up().down('analysisDataSetConfigForm');
  var configurationPanel = dataSetConfigForm.up('tabpanel');
  var dataSetConfig = dataSetConfigForm.getViewModel().get('record');
  var dataSetModifier = configurationPanel.down('analysisDataModifier') || configurationPanel.add({xtype:'analysisDataModifier', dataSetConfig:dataSetConfig});
  configurationPanel.setActiveTab(dataSetModifier);
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.SpecificConfigsElasticsearch', {extend:'Ext.form.FieldSet', alias:'widget.analysisSpecificConfigs-elasticsearch', itemId:'analysisSpecificConfigs-elasticsearch', localized:{title:'ANALYSIS_DATASET_SPECIFIC_CONFIGS'}, collapsible:true, layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var esLink = 'https://www.elastic.co/guide/en/elasticsearch/reference/7.x/search-aggregations.html';
  this.items = [{localized:{fieldLabel:'CORE_INDEX_SELECTOR_LABEL'}, xtype:'bpcIndexSelector', allowBlank:false, bind:{value:{bindTo:'{record.indexName}', deep:true}}}, {xtype:'bpcJsonField', fieldLabel:'Query', labelAlign:'top', bind:{value:{bindTo:'{record.query}', deep:true}}, flex:1}, {xtype:'displayfield', hideLabel:true, value:'\x3ca target\x3d"_blank" href\x3d"' + esLink + '"\x3e\n                        \x3ci class\x3d"fal fa-info-circle"\x3e\x3c/i\x3e\n                        ' + BpcCommon.Api.getTranslation('ANALYSIS_SEE_ES_DOCUMENTATION') + 
  '\n                     \x3c/a\x3e'}];
  this.callParent();
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.SpecificConfigsHTTP', {extend:'Ext.form.FieldSet', alias:'widget.analysisSpecificConfigs-http', localized:{title:'ANALYSIS_DATASET_SPECIFIC_CONFIGS'}, collapsible:true, layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  this.items = [{xtype:'bpcTextField', fieldLabel:'URL', bind:{value:{bindTo:'{record.url}', deep:true}}}];
  this.callParent();
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.SpecificConfigsInubit', {extend:'Ext.form.FieldSet', alias:'widget.analysisSpecificConfigs-inubit', localized:{title:'ANALYSIS_DATASET_SPECIFIC_CONFIGS'}, collapsible:true, layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var me = this;
  var inubitReportsStore = Ext.create('Ext.data.Store', {data:[]});
  this.items = [{xtype:'bpcModuleInstanceSelector', fieldLabel:'Inubit Connection', baseModuleName:'httpproxy', instanceType:'http_proxy', bind:{value:'{record.inubit_connectionId}'}, listeners:{change:function(cmp, newValue) {
    me.mask(BpcCommon.Api.getTranslation('ANALYSIS_LOAD_INUBIT_REPORTS'));
    Ext.Ajax.request({url:analysis.assets.ConfigKeys.apiPrefix + '/data/inubit/' + newValue + '/report/reportdata', callback:function() {
      me.unmask();
    }, success:function(response) {
      var responseObj = JSON.parse(response.responseText);
      inubitReportsStore.setData(responseObj.Report);
      var inubitReportSelector = me.down("[name\x3d'analysisInubitReportSelector']");
      inubitReportSelector.updateSelection();
      var currentReportId = me.getViewModel().get('record.inubit_reportId');
      var currentSelectedRecord = inubitReportSelector.getStore().getById(currentReportId);
      inubitReportSelector.updateSelection(currentSelectedRecord);
    }, failure:function() {
      BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_INUBIT_CONNECTION_ERROR'), popUp:true, type:'error'});
    }});
  }}}, {xtype:'combobox', fieldLabel:'Report ID', forceSelection:true, name:'analysisInubitReportSelector', queryMode:'local', valueField:'id', displayField:'name', tpl:Ext.create('Ext.XTemplate', '\x3ctpl for\x3d"."\x3e', "\x3cdiv role\x3d'option' class\x3d'x-boundlist-item'\x3e" + "\x3ci class\x3d'fal fa-calendar-minus'\x3e\x3c/i\x3e {name} - {id}" + '\x3c/div\x3e' + '\x3c/tpl\x3e'), bind:{value:'{record.inubit_reportId}'}, store:inubitReportsStore}];
  this.callParent();
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.SpecificConfigsJSON', {extend:'Ext.form.FieldSet', alias:'widget.analysisSpecificConfigs-json', localized:{title:'ANALYSIS_DATASET_SPECIFIC_CONFIGS'}, collapsible:true, layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var infoTooltip = BpcCommon.Api.getTranslation('ANALYSIS_JSON_DATA_SOURCE_INFO_TOOLTIP');
  this.items = [{xtype:'bpcJsonField', fieldLabel:"JSON Data \x3ci class\x3d'fal fa-info-circle' data-qtip\x3d\"" + infoTooltip + '"\x3e\x3c/i\x3e', labelAlign:'top', bind:{value:{bindTo:'{record.jsonData}', deep:true}}, flex:1}];
  this.callParent();
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.VariablesGrid', {extend:'Ext.grid.Panel', alias:'widget.analysisVariablesGrid', itemId:'analysisVariablesGrid', controller:'analysisVariablesGridController', selModel:{type:'cellmodel'}, margin:0, buttons:[{localized:{text:'ANALYSIS_ADD'}, handler:'addVariable', iconCls:'x-fal fa-plus'}], viewConfig:{markDirty:false}, initComponent:function() {
  var viewModel = this.getViewModel();
  this.store = Ext.create('Ext.data.Store', {data:viewModel.get('record.variables'), listeners:{datachanged:function() {
    this.getViewModel().set('hasUnsavedChanges', true);
  }.bind(this)}});
  this.columns = [{localized:{text:'CORE_NAME'}, dataIndex:'name', flex:1}, {xtype:'bpcSettingColumn', localized:{text:'CORE_DEFAULT_VALUE'}, dataIndex:'value', flex:1}, {localized:{text:'ANALYSIS_MIN_VALUE'}, dataIndex:'min', flex:1}, {localized:{text:'ANALYSIS_MAX_VALUE'}, dataIndex:'max', flex:1}, {xtype:'actioncolumn', width:100, sortable:false, menuDisabled:true, align:'center', items:[{iconCls:'x-fal fa-pencil', tooltip:BpcCommon.Api.getTranslation('ANALYSIS_EDIT_VAR'), handler:'editVar'}, 
  {iconCls:'x-fal fa-trash', tooltip:BpcCommon.Api.getTranslation('CORE_DELETE'), handler:'removeVariable'}]}];
  this.callParent();
}});
Ext.define('analysis.view.dataView.dataSetConfigForm.VariablesGridController', {extend:'Ext.app.ViewController', alias:'controller.analysisVariablesGridController', addVariable:function() {
  this.getVarsConfigWindow(false);
}, removeVariable:function(grid, rowIndex) {
  var view = this.getView();
  var store = view.getStore();
  var parentViewModel = view.lookupViewModel();
  var record = store.getAt(rowIndex);
  store.remove(record);
  parentViewModel.get('record').data.variables = parentViewModel.get('record.variables').filter(function(item) {
    return item.id !== record.get('id');
  });
}, editVar:function(grid, rowIndex) {
  var view = this.getView();
  var store = view.getStore();
  var record = store.getAt(rowIndex);
  this.getVarsConfigWindow(true, record, rowIndex);
}, getVarsConfigWindow:function(shouldEdit, oldVarRecord, recordIndex) {
  var view = this.getView();
  var store = view.getStore();
  var parentViewModel = view.lookupViewModel();
  var oldValue = Ext.clone(parentViewModel.get('record.variables'));
  return Ext.create('Ext.window.Window', {localized:{title:shouldEdit ? 'ANALYSIS_EDIT_VAR' : 'ANALYSIS_ADD_VARIABLE'}, modal:true, height:320, width:400, bodyPadding:10, scrollable:true, items:{xtype:'form', viewModel:{data:oldVarRecord ? oldVarRecord.getData() : {type:'text', min:undefined, max:undefined, dateformat:'Y-m-d'}}, layout:{type:'vbox', align:'stretch'}, defaults:{labelWidth:130}, items:[{xtype:'textfield', allowBlank:false, localized:{fieldLabel:'ANALYSIS_NAME'}, name:'name', bind:{value:'{name}'}}, 
  this.getTypeSelection(), {xtype:'bpcTextField', name:'valuetext', bind:{hidden:"{type !\x3d\x3d 'text'}", disabled:"{type !\x3d\x3d 'text'}", value:'{value}'}, localized:{fieldLabel:'CORE_DEFAULT_VALUE'}}, {xtype:'numberfield', name:'valuenumber', submitLocaleSeparator:false, bind:{hidden:"{type !\x3d\x3d 'number'}", disabled:"{type !\x3d\x3d 'number'}", value:'{value}', maxValue:'{max}', minValue:'{min}'}, localized:{fieldLabel:'CORE_DEFAULT_VALUE'}}, {xtype:'fieldcontainer', layout:'hbox', localized:{fieldLabel:'ANALYSIS_VALUE_RANGE'}, 
  bind:{hidden:"{type !\x3d\x3d 'number'}", disabled:"{type !\x3d\x3d 'number'}"}, items:[{xtype:'bpcNumberField', name:'valuenumbermin', emptyText:'Min', bind:{value:'{min}'}, flex:1}, {xtype:'bpcNumberField', name:'valuenumbermax', emptyText:'Max', bind:{value:'{max}'}, flex:1}]}, {xtype:'checkbox', name:'valueboolean', inputValue:true, bind:{hidden:"{type !\x3d\x3d 'boolean'}", disabled:"{type !\x3d\x3d 'boolean'}", value:'{value}'}, localized:{fieldLabel:'CORE_DEFAULT_VALUE'}}, {xtype:'textfield', 
  name:'dateformat', allowBlank:false, bind:{hidden:"{type !\x3d\x3d 'date'}", disabled:"{type !\x3d\x3d 'date'}", value:'{dateformat}'}, fieldLabel:BpcCommon.Api.getTranslation('ANALYSIS_DATE_FORMAT') + '\n                     \x3ca target\x3d"_blank" href\x3d"https://docs.sencha.com/extjs/7.1.0/classic/Ext.Date.html"\x3e\n                        \x3cspan class\x3d"x-fal fa-info-circle" data-qtip\x3d"' + BpcCommon.Api.getTranslation('ANALYSIS_EXT_DATE_FORMAT_HINT') + '"\x3e\x3c/span\x3e\n                     \x3c/a\x3e'}, 
  {xtype:'datefield', name:'valuedate', submitFormat:'Y-m-d', bind:{hidden:"{type !\x3d\x3d 'date'}", disabled:"{type !\x3d\x3d 'date'}", value:'{value}', minValue:'{min}', maxValue:'{max}'}, localized:{fieldLabel:'CORE_DEFAULT_VALUE'}}, {xtype:'fieldcontainer', layout:'hbox', localized:{fieldLabel:'ANALYSIS_VALUE_RANGE'}, bind:{hidden:"{type !\x3d\x3d 'date'}", disabled:"{type !\x3d\x3d 'date'}"}, items:[{xtype:'datefield', name:'valuedatemin', submitFormat:'Y-m-d', emptyText:'Min', bind:{value:'{min}'}, 
  flex:1}, {xtype:'datefield', name:'valuedatemax', submitFormat:'Y-m-d', emptyText:'Max', bind:{value:'{max}'}, flex:1}]}, {xtype:'tagfield', name:'valuelistselections', valueField:'value', displayField:'value', createNewOnEnter:true, createNewOnBlur:true, publishes:'value', queryMode:'local', value:oldVarRecord ? oldVarRecord.getData()['_valueList'] : '', bind:{hidden:"{type !\x3d\x3d 'list'}", disabled:"{type !\x3d\x3d 'list'}"}, localized:{fieldLabel:'ANALYSIS_VALUE_LIST'}, store:{data:this.getAvailableValueList(oldVarRecord)}, 
  listeners:{change:function(tagfield, newValue) {
    var valueListDefautCmp = this.up().down("[name\x3d'valuelist']");
    valueListDefautCmp.getStore().setData(newValue.map(function(item) {
      return {value:item};
    }));
    var currentValue = valueListDefautCmp.getValue();
    if (!newValue.includes(currentValue)) {
      valueListDefautCmp.setValue('');
    }
  }}}, {xtype:'combobox', name:'valuelist', valueField:'value', displayField:'value', forceSelection:true, store:{data:this.getAvailableValueList(oldVarRecord)}, queryMode:'local', bind:{hidden:"{type !\x3d\x3d 'list'}", disabled:"{type !\x3d\x3d 'list'}", value:'{value}'}, localized:{fieldLabel:'CORE_DEFAULT_VALUE'}}]}, buttons:[{text:BpcCommon.Api.getTranslation('CORE_CANCEL'), iconCls:BpcCommon.Icons.CANCEL, ui:'secondary', handler:function() {
    this.up('window').close();
  }}, {text:BpcCommon.Api.getTranslation('CORE_OK'), iconCls:BpcCommon.Icons.OK, ui:'primary', handler:function() {
    var formCmp = this.up('window').down('form');
    if (formCmp.isValid()) {
      var formValues = formCmp.getValues();
      if (!formValues.valueboolean) {
        formValues.valueboolean = false;
      }
      var newObj = {id:shouldEdit ? oldVarRecord.get('id') : Date.now(), shouldUse:true, name:formValues.name, type:formValues.type, value:formValues['value' + formValues.type]};
      if (formValues.type === 'list') {
        newObj['_valueList'] = formValues.valuelistselections;
      } else if (formValues.type === 'number') {
        newObj['min'] = formValues.valuenumbermin;
        newObj['max'] = formValues.valuenumbermax;
      } else if (formValues.type === 'date') {
        newObj['min'] = formValues.valuedatemin;
        newObj['max'] = formValues.valuedatemax;
        newObj['dateformat'] = formValues.dateformat;
      }
      if (shouldEdit) {
        oldVarRecord.erase();
        store.insert(recordIndex, newObj);
        var newValue = Ext.clone(oldValue);
        newValue[recordIndex] = newObj;
        parentViewModel.get('record').set('variables', newValue);
      } else {
        store.add(newObj);
        parentViewModel.get('record').set('variables', oldValue.concat(newObj));
      }
      this.up('window').close();
    }
  }}]}).show();
}, getTypeSelection:function() {
  return {xtype:'combobox', name:'type', bind:'{type}', localized:{fieldLabel:'ANALYSIS_INDEX_TYPE'}, queryMode:'local', store:{data:[{name:'text'}, {name:'boolean'}, {name:'number'}, {name:'list'}, {name:'date'}]}, displayField:'name'};
}, getAvailableValueList:function(oldVarRecord) {
  if (oldVarRecord && oldVarRecord.getData) {
    if (oldVarRecord.getData()['_valueList']) {
      return oldVarRecord.getData()['_valueList'].map(function(item) {
        return {value:item};
      });
    }
  }
  return [];
}});
Ext.define('analysis.view.dataSetEditor.dataSetList.DataSetList', {extend:'Ext.grid.Panel', alias:'widget.analysisDataSetList', controller:'analysisDataSetListController', itemId:'analysisDataSetList', reference:'analysisDataSetList', cmpType:'listItems', localized:{title:'ANALYSIS_DATA_SETS'}, minButtonWidth:30, plugins:{ptype:'cellediting', clicksToEdit:1}, features:[{ftype:'grouping'}], buttons:[{iconCls:'x-fal fa-plus', localized:{tooltip:'ANALYSIS_ADD'}, handler:'onAddDataSet'}], listeners:{select:'onSelect', 
afterrender:'onAfterRender'}, initComponent:function() {
  var me = this;
  this.store = Ext.create('Ext.data.ChainedStore', {source:analysis.assets.Helpers.getDataSetListStore(this.moduleId), groupField:'sourceType'});
  this.columns = [{localized:{text:'CORE_NAME'}, dataIndex:'name', flex:2}, {text:'ID', dataIndex:'id', hidden:true}, {localized:{text:'CORE_TYPE'}, dataIndex:'sourceType', flex:1}, {xtype:'actioncolumn', width:70, sortable:false, menuDisabled:true, align:'center', items:[{iconCls:'x-fal fa-copy', tooltip:BpcCommon.Api.getTranslation('ANALYSIS_DUPLICATE'), handler:'onDuplicateDataSet'}, {iconCls:'x-fal fa-trash', tooltip:BpcCommon.Api.getTranslation('CORE_DELETE'), handler:'onRemoveDataSet'}]}];
  this.callParent();
  this.getStore().addListener('datachanged', function() {
    me.reconfigure();
  });
}});
Ext.define('analysis.view.dataSetEditor.dataSetList.DataSetListController', {extend:'Ext.app.ViewController', alias:'controller.analysisDataSetListController', onSelect:function(row, record) {
  var view = this.getView();
  var dataSetEditor = view.up().down('#analysisDataSetEditorWrapper');
  if (!record.dataSetEditor) {
    var item = {xtype:'analysisDataSetEditor', moduleId:view.moduleId, minWidth:500, record:record};
    record.dataSetEditor = dataSetEditor.add(item);
  }
  dataSetEditor.setActiveItem(record.dataSetEditor);
}, onAfterRender:function() {
  this.selectFirstElement();
}, selectFirstElement:function() {
  var view = this.getView();
  if (view.getStore().getData().items.length === 0) {
    var editorsWrapper = view.up('analysisDataSetEditorContainer').down('#analysisDataSetEditorWrapper');
    analysis.assets.Helpers.showCentralWarningTextComponentsList(editorsWrapper);
  } else {
    if (view.getSelection().length === 0) {
      view.setSelection(view.getStore().first());
    }
  }
}, onAddDataSet:function() {
  var me = this;
  var grid = me.getView();
  if (grid) {
    var id = Date.now().toString();
    var newRecord = grid.getStore().add({id:id, name:'Data Set ' + id, variables:[], query:{}});
    grid.setSelection(newRecord);
    var moduleId = grid.moduleId;
    var currentSettingsModel = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.dataSetsConfigs, true);
    var currentSettings = currentSettingsModel.get('value');
    currentSettings.push(newRecord[0].getData());
    currentSettingsModel.set('value', currentSettings);
    currentSettingsModel.save({success:function() {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('CORE_OK'));
    }, failure:function(record, operation) {
      var error = operation.error;
      try {
        var response = JSON.parse(error.response.responseText);
        BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
      } catch (err) {
        Ext.log({level:'error', message:'Create data set config error'});
      }
    }});
  }
}, onRemoveDataSet:function(grid, rowIndex) {
  var me = this;
  var view = me.getView();
  Ext.Msg.show({title:BpcCommon.Api.getTranslation('ANALYSIS_DELETE_DATA_SET_CONFIRM_TITLE'), message:BpcCommon.Api.getTranslation('ANALYSIS_DELETE_DATA_SET_CONFIRM_TEXT'), buttons:Ext.Msg.YESNO, icon:Ext.Msg.QUESTION, fn:function(btn) {
    if (btn === 'yes') {
      var moduleId = view.moduleId;
      var store = view.getStore();
      var record = store.getAt(rowIndex);
      var dataSetId = record.get('id');
      var settingsModel = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.dataSetsConfigs, true);
      var settings = settingsModel.get('value');
      var newSettings = Ext.Array.removeAt(settings, settings.findIndex(function(item) {
        return item.id.toString() === dataSetId;
      }));
      settingsModel.set('value', newSettings);
      settingsModel.save({success:function() {
        BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('CORE_OK'));
        record.erase();
        me.selectFirstElement();
      }, failure:function(record, operation) {
        var error = operation.error;
        try {
          var response = JSON.parse(error.response.responseText);
          BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
        } catch (err) {
          Ext.log({level:'error', message:'Create data set config error'});
        }
      }});
    }
  }});
}, onDuplicateDataSet:function(grid, rowIndex) {
  var view = this.getView();
  var selectedRecord = view.getStore().getAt(rowIndex);
  if (selectedRecord) {
    var id = Date.now().toString();
    var newRecordData = Ext.apply(selectedRecord.getData(), {name:'Copy of ' + selectedRecord.get('name'), id:id});
    var moduleId = view.moduleId;
    var settingsModel = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.dataSetsConfigs, true);
    var dataSetList = settingsModel.get('value');
    dataSetList.push(newRecordData);
    settingsModel.set('value', dataSetList);
    settingsModel.save({success:function() {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('CORE_OK'));
      var newRecord = view.getStore().add(newRecordData);
      view.setSelection(newRecord);
    }, failure:function(record, operation) {
      var error = operation.error;
      try {
        var response = JSON.parse(error.response.responseText);
        BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
      } catch (err) {
        Ext.log({level:'error', message:'Create data set config error'});
      }
    }});
  }
}});
Ext.define('analysis.view.dataSetEditor.modifier.DataModifier', {extend:'Ext.panel.Panel', alias:'widget.analysisDataModifier', localized:{title:'ANALYSIS_DATA_MODIFIER'}, layout:{type:'hbox', align:'stretch'}, dataSetConfig:undefined, routePath:'modifier', initComponent:function() {
  var modifiers = this.dataSetConfig.get('modifiers');
  var moduleId = this.up('analysisDataSetEditor').moduleId;
  this.items = [{flex:1, xtype:'analysisModifierStepsList', collapsible:true, collapseDirection:'left', dataSetConfig:this.dataSetConfig, modifiers:modifiers}, {xtype:'panel', layout:'card', itemId:'modifierConfigPanel', region:'center', items:[], flex:2}, {xtype:'bpcSplitter', collapseTarget:'next'}, {xtype:'panel', collapsible:true, collapseDirection:'right', flex:2, layout:{type:'vbox', align:'stretch'}, localized:{title:'ANALYSIS_PREVIEW'}, items:[{xtype:'fieldset', localized:{title:'ANALYSIS_CONTEXT_VARIABLES'}, 
  collapsible:true, collapsed:true, items:[{xtype:'analysisContextVariablesGrid', moduleId:this.moduleId, dataSetId:this.dataSetConfig.get('id'), refresh:this.refreshModifierPreviewer.bind(this)}]}, {xtype:'analysisModifierDataViewer', flex:1, floatable:false, moduleId:moduleId, dataSetConfig:this.dataSetConfig}]}];
  this.callParent();
}, refreshModifierPreviewer:function() {
  var varsGrid = this.down('analysisContextVariablesGrid');
  var storeData = varsGrid.getStore().getData().items;
  var vars = storeData.map(function(item) {
    return item.data;
  });
  var previewer = this.down('analysisModifierDataViewer');
  previewer.setInputData(vars);
  previewer.updateAllPreviewTabs(vars);
}});
Ext.define('analysis.view.dataSetEditor.modifier.ModifierConfig', {extend:'Ext.container.Container', alias:'widget.analysisModifierConfig', layout:'border', scrollable:true, viewModel:{data:{modifierConfig:{id:undefined, name:undefined, description:undefined, type:'groovy', modifier:undefined}}, formulas:{hasUnsavedChanges:{bind:{bindTo:'{modifierConfig}', deep:true}, get:function(modifierConfig) {
  if (modifierConfig.dirty) {
    var view = this.getView();
    var previewCmp = view.up('analysisDataModifier').down('analysisModifierDataViewer');
    if (previewCmp) {
      previewCmp.getViewModel().set('modifiersChanged', true);
    }
  }
  return modifierConfig ? modifierConfig.dirty : false;
}}}}, defaults:{margin:'10 10 0 10'}, routePath:':modifierId', dataSetConfig:undefined, modifierConfig:undefined, initComponent:function() {
  var $jscomp$this = this;
  var modifierId = this.modifierConfig.get('id');
  this.modifierId = modifierId;
  this.items = [{xtype:'form', region:'center', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'fieldcontainer', layout:'hbox', items:[{xtype:'bpcTextField', allowBlank:false, labelWidth:50, flex:1, localized:{fieldLabel:'CORE_NAME'}, bind:{value:'{modifierConfig.name}'}}, {xtype:'bpcComboBox', labelWidth:50, flex:1, margin:'0 0 0 10', bind:{value:'{modifierConfig.type}'}, mode:'local', localized:{fieldLabel:'CORE_TYPE'}, valueField:'value', displayField:'name', store:{data:[{value:'javascript', 
  name:'Javascript'}, {value:'groovy', name:'Groovy'}]}, listeners:{select:function(field, record) {
    try {
      var vm = $jscomp$this.getViewModel();
      var currentModifier = vm.get('modifierConfig.modifier');
      var previousType = field.bind.value.lastValue;
      var currentType = record.get('value');
      var editorFieldXtype = 'bpc' + (currentType[0].toUpperCase() + currentType.slice(1)) + 'Field';
      var editorField = field.up('analysisModifierConfig').down(editorFieldXtype);
      if (previousType) {
        if (currentModifier === $jscomp$this.getDummyModifierCode(previousType)) {
          var editorValue = $jscomp$this.getDummyModifierCode(currentType);
          $jscomp$this.getViewModel().set('modifierConfig.modifier', editorValue);
          editorField.editor.setValue(editorValue, -1);
        } else {
          Ext.create('Ext.window.MessageBox', {closeAction:'destroy', defaultButtonCfg:{no:{text:'ANALYSIS_LOAD_CODE_EXAMPLE', ui:'secondary', iconCls:BpcCommon.Icons.CANCEL}, yes:{text:'ANALYSIS_KEEP_CODE', ui:'primary', iconCls:BpcCommon.Icons.OK}}}).show({title:BpcCommon.Api.getTranslation('CORE_WARNING'), buttons:Ext.Msg.YESNO, icon:Ext.Msg.WARNING, message:BpcCommon.Api.getTranslation('ANALYSIS_KEEP_MODIFIER_CODE'), fn:function(btn) {
            if (btn === 'yes') {
              $jscomp$this.getViewModel().set('modifierConfig.modifier', currentModifier);
              editorField.editor.setValue(currentModifier, -1);
            } else {
              var editorValue$3 = $jscomp$this.getDummyModifierCode(currentType);
              $jscomp$this.getViewModel().set('modifierConfig.modifier', editorValue$3);
              editorField.editor.setValue(editorValue$3, -1);
            }
          }});
        }
      }
    } catch (err) {
      Ext.log({level:'info', message:'Component might not be ready'});
    }
  }}}]}, {xtype:'textarea', labelAlign:'top', grow:true, growMin:30, growMax:90, localized:{fieldLabel:'CORE_DESCRIPTION'}, bind:{value:'{modifierConfig.description}'}}, {xtype:'bpcJavascriptField', minHeight:400, labelAlign:'top', localized:{fieldLabel:'ANALYSIS_MODIFIER'}, flex:1, bind:{value:{bindTo:'{modifierConfig.modifier}', deep:true}, disabled:"{modifierConfig.type !\x3d\x3d 'javascript'}", hidden:"{modifierConfig.type !\x3d\x3d 'javascript'}"}}, {xtype:'bpcGroovyField', minHeight:400, labelAlign:'top', 
  localized:{fieldLabel:'ANALYSIS_MODIFIER'}, flex:1, bind:{value:{bindTo:'{modifierConfig.modifier}', deep:true}, disabled:"{modifierConfig.type !\x3d\x3d 'groovy'}", hidden:"{modifierConfig.type !\x3d\x3d 'groovy'}"}}], bbar:[{iconCls:'fal fa-exclamation-triangle warningColor', ui:'apptoolbardefault', localized:{text:'ANALYSIS_UNSAVED_CHANGES'}, bind:{hidden:'{!hasUnsavedChanges}'}, margin:5, handler:this.onSave.bind(this)}, '-\x3e', {xtype:'button', localized:{tooltip:'ANALYSIS_LOAD_CODE_EXAMPLE'}, 
  iconCls:'fal fa-code', ui:'secondary', margin:5, handler:function() {
    Ext.create('Ext.window.MessageBox', {closeAction:'destroy', defaultButtonCfg:{no:{text:'CORE_CANCEL', ui:'secondary', iconCls:BpcCommon.Icons.CANCEL}, yes:{text:'ANALYSIS_LOAD_CODE_EXAMPLE', ui:'primary', iconCls:BpcCommon.Icons.OK}}}).show({title:BpcCommon.Api.getTranslation('CORE_WARNING'), buttons:Ext.Msg.YESNO, icon:Ext.Msg.WARNING, message:BpcCommon.Api.getTranslation('ANALYSIS_LOAD_MODIFIER_CODE'), fn:function(btn) {
      if (btn === 'yes') {
        var modifierType = $jscomp$this.getViewModel().get('modifierConfig.type');
        $jscomp$this.getViewModel().set('modifierConfig.modifier', $jscomp$this.getDummyModifierCode(modifierType));
      }
    }});
  }}, {xtype:'button', localized:{tooltip:'ANALYSIS_RUN_MODIFIER_STEP'}, iconCls:'fal fa-play', ui:'secondary', margin:5, handler:function() {
    $jscomp$this.runModifier(null);
  }}, {xtype:'button', ui:'primary', localized:{text:'CORE_SAVE'}, iconCls:'fal fa-save', margin:5, handler:this.onSave.bind(this)}]}];
  this.callParent();
  var viewModel = this.getViewModel();
  if (viewModel.get('modifierConfig.type') === 'groovy' && !viewModel.get('modifierConfig.modifier')) {
    viewModel.set('modifierConfig.modifier', this.getDummyModifierCode('groovy'));
  }
  if (viewModel.get('modifierConfig.type') === 'javascript' && !viewModel.get('modifierConfig.modifier')) {
    viewModel.set('modifierConfig.modifier', this.getDummyModifierCode('javascript'));
  }
}, runModifier:function(vars) {
  var $jscomp$this = this;
  var me = this;
  var configForm = me.down('form');
  if (!configForm.isValid()) {
    BpcCommon.Api.showNotification({text:'Validierung fehlgeschlagen', popUp:true, type:'error'});
    return;
  }
  var analysisDataModifierCmp = me.up('analysisDataModifier');
  var viewModel = me.getViewModel();
  var modifierConfig = viewModel.get('modifierConfig');
  var modifiersList = analysisDataModifierCmp.down('analysisModifierStepsList');
  var modifiersStore = modifiersList.getStore();
  var thisModifierIndex = modifiersStore.indexOf(modifierConfig);
  var dataSetConfig = me.dataSetConfig;
  var moduleId = me.up('analysisDataSetEditor').moduleId;
  var dataSetId = dataSetConfig.get('id');
  if (!vars) {
    vars = dataSetConfig.get('variables');
  }
  var modifierDataViewer = analysisDataModifierCmp.down('analysisModifierDataViewer');
  modifierDataViewer.mask(BpcCommon.Api.getTranslation('CORE_LOAD_DATA'));
  var success = function(response) {
    var responseObj = Ext.decode(response.responseText);
    if (!modifierConfig.modifierDataViewerTab) {
      var viewerTab = $jscomp$this.getDataViewerTabCmp(true, modifierConfig, responseObj);
      modifierConfig.modifierDataViewerTab = modifierDataViewer.insert(thisModifierIndex + 1, viewerTab);
      BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_SCRIPT_EXECUTION_SUCCESS')});
    } else {
      modifierConfig.modifierDataViewerTab.updatePreviewTab(true, responseObj);
      modifierDataViewer.insert(thisModifierIndex + 1, modifierConfig.modifierDataViewerTab);
    }
    modifierDataViewer.setActiveTab(modifierConfig.modifierDataViewerTab);
    modifierDataViewer.unmask();
  };
  var failure = function(response) {
    var responseObj = Ext.decode(response.responseText);
    modifierDataViewer.unmask();
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation(responseObj.error) + ': ' + responseObj.cause, type:'error', popUp:true});
    responseObj.NOTE = 'This is just an error, not modified data';
    responseObj.error = BpcCommon.Api.getTranslation(responseObj.error);
    var viewerTab = $jscomp$this.getDataViewerTabCmp(false, modifierConfig, responseObj);
    if (!modifierConfig.modifierDataViewerTab) {
      modifierConfig.modifierDataViewerTab = modifierDataViewer.insert(thisModifierIndex + 1, viewerTab);
    } else {
      modifierConfig.modifierDataViewerTab.updatePreviewTab(false, responseObj);
      modifierDataViewer.insert(thisModifierIndex + 1, modifierConfig.modifierDataViewerTab);
    }
    modifierDataViewer.setActiveTab(modifierConfig.modifierDataViewerTab);
  };
  dataSetConfig.saveDataSet(moduleId, {success:function() {
    modifierConfig.save();
    analysis.assets.Helpers.getModifiedData(moduleId, dataSetId, thisModifierIndex, vars).then(success, failure);
  }, failure:function() {
    BpcCommon.Api.showNotification({text:'ANALYSIS_SAVE_ERROR', popUp:true, type:'error'});
  }});
}, onSave:function() {
  var me = this;
  var configForm = me.down('form');
  if (!configForm.isValid()) {
    BpcCommon.Api.showNotification({text:'Validierung fehlgeschlagen', popUp:true, type:'error'});
    return;
  }
  var dataSetConfig = this.dataSetConfig;
  var modifier = this.getViewModel().get('modifierConfig');
  var dataSetEditor = this.up('analysisDataSetEditor');
  var moduleId = dataSetEditor.moduleId;
  dataSetConfig.saveDataSet(moduleId, {success:function() {
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_DATA_SET_CONFIG_SAVED')});
    modifier.save();
  }, failure:function(record, operation) {
    var error = operation.error;
    try {
      var response = JSON.parse(error.response.responseText);
      BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
    } catch (err) {
      Ext.log({level:'error', message:'Save data set config error'});
    }
  }});
}, getDummyModifierCode:function(type) {
  if (type === 'javascript') {
    return '/**\n' + ' * Your modifier rules must be defined in this function.\n' + ' * You can also define some help functions,\n' + ' * which can make your modifier code more readable.\n' + ' * @param data JSON object or array, which is result of previous step.\n' + ' * @param vars You can get data set variables by accessing properties of this object.\n' + ' * For example: vars.MY_VARIABLE\n' + ' * @returns JSON object, which is input for following step\n' + ' * or data for chart.\n' + ' */\n' + 
    'function modify (data, vars) {\n' + '   const result \x3d helper(data);\n' + '   return result;\n' + '}\n' + '\n' + 'function helper (data) {\n' + '   return data;\n' + '}';
  } else if (type === 'groovy') {
    return '/* Your modifier rules must be defined in this code block.\n' + ' * You can access current data via the object "data".\n' + ' * Result of this step is input for the following step\n' + ' * or can be used as data for chart.\n' + ' * @return a JSON object\n' + ' * You can get data set variables by accessing properties of this object: "vars".\n' + ' * For example: vars.MY_VARIABLE\n' + ' */\n' + 'return data;';
  }
}, getDataViewerTabCmp:function(isSuccessful, modifierConfig, previewData) {
  return {xtype:'analysisModifierDataViewerTab', modifierConfig:modifierConfig, viewModel:{data:{modifierConfig:modifierConfig, isSuccessful:isSuccessful}}, previewData:previewData};
}});
Ext.define('analysis.view.dataSetEditor.modifier.ModifierDataViewer', {extend:'Ext.tab.Panel', alias:'widget.analysisModifierDataViewer', itemId:'analysisModifierDataViewer', minWidth:500, scrollable:true, defaults:{layout:'fit'}, moduleId:undefined, dataSetConfig:undefined, viewModel:{data:{inputData:undefined, modifiersChanged:false}}, initComponent:function() {
  var $jscomp$this = this;
  var me = this;
  me.items = [{xtype:'panel', localized:{title:'ANALYSIS_INPUT_DATA', iconCls:'x-fal fa-sign-in'}, items:[{xtype:'bpcJsonField', itemId:'inputDataView', bind:{value:'{inputData}'}, editorConfigs:{readOnly:true}}]}];
  me.bbar = [{iconCls:'fal fa-exclamation-triangle warningColor', ui:'apptoolbardefault', localized:{text:'ANALYSIS_PREVIEW_NOT_UP_TO_DATE', tooltip:'ANALYSIS_MODIFIERS_CHANGED'}, bind:{hidden:'{!modifiersChanged}'}, margin:5, handler:function() {
    $jscomp$this.updateAllPreviewTabs();
  }}, '-\x3e', {xtype:'analysisrelatedItemsSelectorBtn', ui:'primary', localized:{text:'ANALYSIS_VISUALIZE'}, margin:5, iconCls:'fal fa-chart-pie-alt', relation:analysis.assets.ConfigKeys.relationType.RELATION_CHARTS_TO_DATA_SET, moduleId:me.moduleId, dataSetId:me.dataSetConfig.id}];
  me.listeners = {afterrender:function() {
    me.setInputData();
  }};
  me.callParent();
  Ext.on('dataSetUpdated', function(data, dataSetConfig) {
    if (me.dataSetConfig.id === dataSetConfig.get('id')) {
      var vm = $jscomp$this.getViewModel();
      vm.set('inputData', data);
      vm.set('modifiersChanged', true);
    }
  });
}, setInputData:function(vars) {
  var me = this;
  var moduleId = me.moduleId;
  var dataSetConfig = me.dataSetConfig;
  var dataSetId = dataSetConfig.get('id');
  if (!vars) {
    vars = dataSetConfig.get('variables');
  }
  me.mask(BpcCommon.Api.getTranslation('CORE_LOAD_DATA'));
  var success = function(response) {
    var responseText = response.responseText;
    var responseObj = JSON.parse(responseText);
    var viewModel = me.getViewModel();
    viewModel.set('inputData', responseObj);
    me.setCollapsed(false);
    me.unmask();
  };
  var failure = function(response) {
    var responseText = response.responseText;
    var responseObj = JSON.parse(responseText);
    me.setCollapsed(true);
    me.unmask();
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_LOAD_DATA_ERROR') + ': ' + responseObj.error + ' ' + responseObj.cause, popUp:true, type:'error'});
  };
  analysis.assets.Helpers.getDataSet(moduleId, dataSetId, vars, true).then(success, failure);
}, updateAllPreviewTabs:function(vars) {
  var me = this;
  var tabs = me.query("[name\x3d'modifierStepDataPreview']");
  tabs.forEach(function(tab) {
    var modifierConfigRecord = tab.modifierConfig;
    var modifierConfigCmp = modifierConfigRecord.modifierConfigCmp;
    modifierConfigCmp.runModifier(vars);
  });
  me.getViewModel().set('modifiersChanged', false);
}});
Ext.define('analysis.view.dataSetEditor.modifier.ModifierDataViewerTab', {extend:'Ext.panel.Panel', alias:'widget.analysisModifierDataViewerTab', name:'modifierStepDataPreview', closable:true, iconCls:'x-fal fa-random', modifierConfig:undefined, previewData:undefined, viewModel:{data:{modifierConfig:undefined, isSuccessful:undefined}}, bind:{title:'{modifierConfig.name} \n               \x3ci class\x3d"{isSuccessful ? "successColor fas fa-check-circle" : "failureColor fas fa-times-circle"}"\x3e\n               \x3c/i\x3e'}, 
initComponent:function() {
  var modifierConfig = this.modifierConfig;
  this.listeners = {close:function() {
    delete modifierConfig.modifierDataViewerTab;
  }};
  this.items = [{xtype:'bpcJsonField', value:this.previewData, editorConfigs:{readOnly:true}}];
  this.callParent();
}, updatePreviewTab:function(isSuccessful, previewData) {
  var viewModel = this.getViewModel();
  viewModel.set('isSuccessful', isSuccessful);
  var editorField = this.down('bpcJsonField');
  editorField.setValue(previewData);
}});
Ext.define('analysis.view.dataSetEditor.modifier.ModifierStepsList', {extend:'Ext.grid.Panel', alias:'widget.analysisModifierStepsList', controller:'analysisModifierStepsListController', width:300, localized:{title:'ANALYSIS_DATA_MODIFIER_STEPS'}, listeners:{select:'onSelect', afterrender:'onAfterrender', drop:'onDrop'}, viewConfig:{plugins:{ptype:'gridviewdragdrop'}}, minButtonWidth:30, dataSetConfig:undefined, modifiers:undefined, initComponent:function() {
  this.columns = [{xtype:'bpcHandleColumn'}, {localized:{text:'CORE_NAME'}, sortable:false, dataIndex:'name', flex:1}, {localized:{text:'CORE_TYPE'}, dataIndex:'type', sortable:false, flex:1}, {xtype:'actioncolumn', menuDisabled:true, align:'center', width:70, items:[{iconCls:'x-fal fa-play', tooltip:BpcCommon.Api.getTranslation('ANALYSIS_RUN_MODIFIER_STEP'), handler:'onRunModifierStep'}, {iconCls:'x-fal fa-trash', tooltip:BpcCommon.Api.getTranslation('ANALYSIS_DELETE'), handler:'onRemoveModifier'}]}];
  this.buttons = [{localized:{text:'ANALYSIS_RUN_ALL_MODIFIER_STEPS'}, iconCls:'fal fa-play', handler:'runAllModifiers'}, '-\x3e', {iconCls:'fal fa-plus', localized:{tooltip:'CORE_ADD'}, handler:'onAddModifier'}];
  this.store = {data:this.modifiers};
  this.callParent();
}});
Ext.define('analysis.view.dataSetEditor.modifier.ModifierStepsListController', {extend:'Ext.app.ViewController', alias:'controller.analysisModifierStepsListController', onAfterrender:function(view) {
  if (view.getStore().getData().items.length === 0) {
    var configPanel = view.up('analysisDataModifier').down('#modifierConfigPanel');
    analysis.assets.Helpers.showCentralWarningTextComponentsList(configPanel);
  } else {
    view.setSelection(view.getStore().first());
  }
}, onSelect:function(row, record, index) {
  var view = this.getView();
  var modifierConfigPanel = view.up('analysisDataModifier').down('#modifierConfigPanel');
  if (!record.modifierConfigCmp) {
    record.modifierConfigCmp = modifierConfigPanel.add({xtype:'analysisModifierConfig', dataSetConfig:view.dataSetConfig, modifierConfig:record, viewModel:{data:{modifierConfig:record, index:index === -1 ? 0 : index}}});
  }
  modifierConfigPanel.setActiveItem(record.modifierConfigCmp);
  if (record.modifierDataViewerTab) {
    var modifierDataViewer = view.up('analysisDataModifier').down('analysisModifierDataViewer');
    modifierDataViewer.setActiveItem(record.modifierDataViewerTab);
  }
}, onAddModifier:function() {
  var view = this.getView();
  var dataSetConfig = view.dataSetConfig;
  var dataSetEditor = view.up('analysisDataSetEditor');
  var moduleId = dataSetEditor.moduleId;
  var lastModifier = dataSetConfig.get('modifiers').slice(-1).pop();
  var newModifier = {id:Date.now(), name:'Name', type:lastModifier ? lastModifier.type : 'groovy', description:BpcCommon.Api.getTranslation('CORE_DESCRIPTION'), modifier:''};
  var store = view.getStore();
  var newModifierCmp = store.add(newModifier);
  dataSetConfig.addModifier(newModifier);
  dataSetConfig.saveDataSet(moduleId, {success:function() {
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_DATA_SET_CONFIG_SAVED')});
    view.setSelection(newModifierCmp);
    window.close();
  }, failure:function(record, operation) {
    var error = operation.error;
    try {
      var response = JSON.parse(error.response.responseText);
      BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
    } catch (err) {
      Ext.log({level:'error', message:'Save data set config error'});
    } finally {
      window.close();
    }
  }});
}, onRemoveModifier:function(tableView, rowIndex) {
  var view = this.getView();
  var store = view.getStore();
  Ext.Msg.show({title:BpcCommon.Api.getTranslation('CORE_INSTANCE_DELETE_TITLE'), message:BpcCommon.Api.getTranslation('CORE_INSTANCES_DELETE'), buttons:Ext.Msg.YESNO, icon:Ext.Msg.QUESTION, fn:function(btn) {
    if (btn === 'yes') {
      var modifierConfig = store.getAt(rowIndex);
      var modifierId = modifierConfig.get('id');
      var dataSetConfig = view.dataSetConfig;
      var modifiermodifierDataViewerTab = modifierConfig.modifierDataViewerTab;
      var dataSetEditor = view.up('analysisDataSetEditor');
      var moduleId = dataSetEditor.moduleId;
      dataSetConfig.removeModifier(modifierId);
      dataSetConfig.saveDataSet(moduleId, {success:function() {
        BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('CORE_OK'));
        modifierConfig.erase();
        if (modifiermodifierDataViewerTab) {
          modifiermodifierDataViewerTab.close();
        }
        if (store.getData().items.length === 0) {
          var configPanel = view.up('analysisDataModifier').down('#modifierConfigPanel');
          analysis.assets.Helpers.showCentralWarningTextComponentsList(configPanel);
        }
      }, failure:function(record, operation) {
        var error = operation.error;
        try {
          var response = JSON.parse(error.response.responseText);
          BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
        } catch (err) {
          Ext.log({level:'error', message:'Create data set config error'});
        }
      }});
    }
  }});
}, runAllModifiers:function() {
  var view = this.getView();
  var modifierRecords = view.getStore().getData().getRange();
  modifierRecords.forEach(function(record) {
    view.setSelection(record);
    var modifierConfigCmp = record.modifierConfigCmp;
    modifierConfigCmp.runModifier();
  });
}, onDrop:function() {
  var view = this.getView();
  var previewCmp = view.up('analysisDataModifier').down('analysisModifierDataViewer');
  if (previewCmp) {
    previewCmp.getViewModel().set('modifiersChanged', true);
  }
  var dataSetConfig = view.dataSetConfig;
  var dataSetEditor = view.up('analysisDataSetEditor');
  var moduleId = dataSetEditor.moduleId;
  var newModifiers = view.getStore().getData().getRange().map(function(modifier) {
    return modifier.getData();
  });
  var oldModifiers = dataSetConfig.get('modifiers');
  newModifiers.forEach(function(item, index) {
    var oldIndex = oldModifiers.findIndex(function(oldItem) {
      return oldItem.id === item.id;
    });
    var oldItem = oldModifiers[oldIndex];
    oldModifiers.splice(oldIndex, 1);
    oldModifiers.splice(index, 0, oldItem);
  });
  dataSetConfig.saveDataSet(moduleId, {success:function() {
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_MODIFIERS_REORDERD')});
  }, failure:function(record, operation) {
    var error = operation.error;
    try {
      var response = JSON.parse(error.response.responseText);
      BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
    } catch (err) {
      Ext.log({level:'error', message:'Save data set config error'});
    }
  }});
}, onRunModifierStep:function(tableView, rowIndex) {
  var view = this.getView();
  var selectedRecord = view.getStore().getAt(rowIndex);
  view.setSelection(selectedRecord);
  var modifierConfigCmp = selectedRecord.modifierConfigCmp;
  modifierConfigCmp.runModifier();
}});
Ext.define('analysis.view.reportEditor.ReportEditor', {extend:'Ext.panel.Panel', alias:'widget.analysisReportEditor', itemId:'analysisReportEditor', layout:{type:'hbox', align:'stretch'}, viewModel:{data:{record:undefined, liveUpdate:true}, formulas:{hasUnsavedChanges:{bind:{bindTo:'{record}', deep:true}, get:function(record) {
  return record ? record.dirty : false;
}}}}, routePath:':reportId', initComponent:function() {
  var me = this;
  var vm = me.getViewModel();
  vm.set('record', me.record);
  me.reportId = vm.get('record.id');
  me.routePath = me.reportId;
  me.items = [{xtype:'analysisReportConfigForm', routePath:'editor', localized:{title:'ANALYSIS_REPORT_CONFIGURATION'}, moduleId:this.moduleId, flex:1, mainReference:this, viewModel:{parent:this.getViewModel()}}, {xtype:'bpcSplitter', collapseTarget:'next'}, {xtype:'analysisReportViewer', localized:{title:'ANALYSIS_REPORT_PREVIEW_TITLE'}, collapsible:true, collapsed:false, collapseDirection:'right', moduleId:this.moduleId, flex:1, mainReference:this}];
  me.callParent();
}, triggerUpdate:function() {
  var me = this;
  var reportViewer = me.down('analysisReportViewer');
  if (reportViewer && Ext.isFunction(reportViewer.onLiveUpdate)) {
    reportViewer.onLiveUpdate();
  }
}});
Ext.define('analysis.view.reportEditor.ReportEditorContainer', {extend:'Ext.panel.Panel', alias:'widget.analysisReportEditorContainer', layout:{type:'hbox', align:'stretch'}, viewModel:{data:{}}, routePath:'report', initComponent:function() {
  this.defaults = {moduleId:this.moduleId};
  this.items = [{xtype:'analysisReportList', split:true, collapsible:true, collapseDirection:'left', width:300, minWidth:300}, {xtype:'bpcSplitter'}, {xtype:'panel', layout:'card', itemId:'analysisReportEditorWrapper', flex:3, items:[]}];
  this.callParent();
}});
Ext.define('analysis.view.reportEditor.charts.ReportChartList', {extend:'Ext.grid.Panel', alias:'widget.analysisReportChartList', controller:'analysisReportChartListController', listeners:{select:'onSelect', afterrender:'onAfterrender'}, minButtonWidth:30, plugins:{ptype:'cellediting', clicksToEdit:1}, emptyText:BpcCommon.lang.Current.ANALYSIS_NO_REPORT_CHARTS, reportConfig:undefined, viewModel:{}, mainReference:undefined, viewConfig:{plugins:{ptype:'gridviewdragdrop'}, markDirty:false}, chartList:undefined, 
layoutType:undefined, initComponent:function() {
  var me = this;
  var vm = me.getViewModel();
  var record = vm.get('record');
  this.chartList = record.get('charts');
  this.layoutType = record.get('layout');
  me.store = Ext.create('Ext.data.Store', {model:'analysis.model.ReportChartsModel'});
  this.store.loadRawData(this.chartList);
  this.createColumns();
  this.createButtons();
  this.on('select', this.onSelectChart, this);
  this.store.on('datachanged', this.onDataChanged, this);
  this.on('afterrender', this.onAfterRender, this);
  me.callParent();
}, onAfterRender:function() {
}, createColumns:function() {
  this.columns = [{xtype:'bpcHandleColumn'}, {dataIndex:'chartID', renderer:function(chartID) {
    return this.getChartName(chartID);
  }.bind(this), localized:{text:'ANALYSIS_REPORT_CHART_LIST_CHART'}, sortable:false, flex:1, editor:{listeners:{complete:this.onCompleteChartSelection.bind(this)}, completeOnEnter:false, field:{xtype:'analysisReportChartSelector', moduleId:this.mainReference.moduleId}}}, {dataIndex:'title', localized:{text:'ANALYSIS_REPORT_CHART_LIST_CHART_TITLE'}, renderer:function(title) {
    if (title === '') {
      return '----';
    }
    return title;
  }, editor:{completeOnEnter:false, field:{xtype:'bpcTextField'}}}, {localized:{text:'CORE_TYPE'}, dataIndex:'chartID', sortable:false, flex:1, renderer:function(chartId) {
    var chartType = this.getChartType(chartId);
    return analysis.assets.Icons.getChartTypeIcon(chartType);
  }.bind(this)}, {text:BpcCommon.Api.getTranslation('ANALYSIS_LAYOUT_PARAMETER'), xtype:'bpcSettingColumn', type:'json', dataIndex:'additionalParameters', sortable:false, flex:1}, {xtype:'actioncolumn', iconCls:BpcCommon.Icons.LINK, menuDisabled:true, align:'center', width:30, handler:'onJumpToChartEditor', localized:{tooltip:'ANALYSIS_JUMP_TO_CHART_EDITOR'}}, {xtype:'actioncolumn', iconCls:'fal fa-trash', menuDisabled:true, align:'center', width:30, handler:'onRemoveChart', localized:{tooltip:'ANALYSIS_DELETE'}}];
}, createButtons:function() {
  this.buttons = [{iconCls:'fal fa-plus', ui:'secondary', localized:{tooltip:'ANALYSIS_ADD_CHART', text:'ANALYSIS_ADD_CHART'}, handler:this.onAddChart.bind(this), margin:5}];
}, onDataChanged:function() {
  var rawData = analysis.assets.Helpers.getRawDataFromStore(this.store);
  this.getViewModel().get('record').set('charts', rawData);
  this.mainReference.triggerUpdate();
}, getAllAvailableCharts:function() {
  var allChartsStore = Ext.data.StoreManager.lookup(this.mainReference.moduleId + 'ChartListStore');
  return analysis.assets.Helpers.getRawDataFromStore(allChartsStore);
}, getChartName:function(chartId) {
  var foundChart = this.getAllAvailableCharts().find(function(el) {
    return parseInt(chartId) === parseInt(el.id);
  }) || {name:BpcCommon.Api.getTranslation('ANALYSIS_REPORT_CHART_SELECTOR_EMPTY_TEXT')};
  return foundChart.name;
}, getChartType:function(chartId) {
  var foundChart = this.getAllAvailableCharts().find(function(el) {
    return parseInt(chartId) === parseInt(el.id);
  }) || {chartType:''};
  return foundChart.chartType;
}, onAddChart:function() {
  var me = this;
  var view = me.getView();
  var store = view.getStore();
  var newChart = Ext.create('analysis.model.ReportChartsModel', {id:Date.now().toString()});
  var newChartCmp = store.add(newChart);
  this.setSelection(newChartCmp);
}, onCompleteChartSelection:function(editor) {
  var record = editor.context.record;
  var chartId = record.get('chartID');
  var moduleId = this.mainReference.moduleId;
  var variableList = analysis.assets.Helpers.getChartVariables(moduleId, chartId);
  record.set('variables', variableList);
}, onSelectChart:function(el, record, index) {
  var reportViewerCmp = this.mainReference.down('analysisReportViewer');
  var reportViewerCmpId = reportViewerCmp.getId();
  var wrapperCmp = reportViewerCmp.down('#' + reportViewerCmpId + 'reportWrapper');
  var layoutType = this.getViewModel().get('record.layout');
  if (wrapperCmp && layoutType === 'tab') {
    wrapperCmp.setActiveTab(index);
  }
}});
Ext.define('analysis.view.reportEditor.charts.ReportChartListController', {extend:'Ext.app.ViewController', alias:'controller.analysisReportChartListController', onAfterrender:function(view) {
  if (!view.getStore().getData().items.length === 0) {
    view.setSelection(view.getStore().first());
  }
}, onSelect:function() {
}, onRemoveChart:function(tableView, rowIndex) {
  var view = this.getView();
  var store = view.getStore();
  Ext.Msg.show({title:BpcCommon.Api.getTranslation('ANALYSIS_REPORT_DELETE_CHART_TITLE'), message:BpcCommon.Api.getTranslation('ANALYSIS_REPORT_DELETE_CHART_TEXT'), buttons:Ext.Msg.YESNO, icon:Ext.Msg.QUESTION, fn:function(btn) {
    if (btn === 'yes') {
      store.removeAt(rowIndex);
    }
  }});
}, onJumpToChartEditor:function(grid, rowIndex) {
  var rec = grid.getStore().getAt(rowIndex);
  var mainView = this.getView().up('bpcAnalysis');
  mainView.jumpTo('analysisChartEditorContainer', rec.get('chartID'));
}});
Ext.define('reportEditor.components.ExternalReportViewer', {extend:'Ext.container.Container', alias:'widget.analysisExternalReportViewer', reportData:undefined, reportCmp:undefined, layout:'fit', showHeader:true, initComponent:function() {
  this.callParent();
  this.on('afterrender', this.getReportData, this);
}, getReportData:function() {
  if (!this.reportData || analysis.assets.Helpers.isObjectEmpty(this.reportData)) {
    var msg = 'ANALYSIS_REPORT_NOT_FOUND';
    this.centerMsg(msg);
    return;
  }
  this.createItems();
}, centerMsg:function(msg) {
  this.removeAll();
  var errCmp = Ext.create('BpcCommon.component.CenterMessageCmp', {message:msg || 'error'});
  this.add(errCmp);
}, createItems:function() {
  this.showHeader = this.showHeader === undefined ? false : this.showHeader;
  this.reportCmp = Ext.create({xtype:'analysisReportViewer', title:this.reportData.name, header:this.showHeader, bodyPadding:10, scrollable:true, layout:'fit', moduleId:this.moduleId, flex:1, viewModel:{data:{record:this.reportData}}});
  this.add({xtype:'panel', layout:{type:'vbox', align:'stretch'}, items:[this.reportCmp]});
}});
Ext.define('analysis.view.reportEditor.components.LayoutConfigurator', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisLayoutConfigurator', localized:{title:'ANALYSIS_LAYOUT_CONFIGURATOR_TITLE'}, viewModel:{data:{record:undefined}}, items:[], layoutSelectorCmp:undefined, specificLayoutCmp:undefined, columnLayoutCmp:undefined, layoutList:undefined, initComponent:function() {
  var me = this;
  this.createLayoutList();
  me.callParent();
  me.createLayoutSelector();
}, createLayoutSelector:function() {
  this.layoutSelectorCmp = Ext.create({xtype:'bpcComboBox', localized:{fieldLabel:'ANALYSIS_REPORT_LAYOUT_TYPE'}, valueField:'type', displayField:'name', store:this.layoutList, bind:{value:'{record.layout}'}, listeners:{change:this.onChange.bind(this)}, labelWidth:200, margin:'0 20px 10px 10px', editable:false});
  this.add(this.layoutSelectorCmp);
}, createLayoutList:function() {
  this.layoutList = [{name:BpcCommon.Api.getTranslation('ANALYSIS_VERTICAL_LAYOUT_OPTION'), type:'vbox'}, {name:BpcCommon.Api.getTranslation('ANALYSIS_HORIZONTAL_LAYOUT_OPTION'), type:'hbox'}, {name:BpcCommon.Api.getTranslation('ANALYSIS_COLUMN_LAYOUT_OPTION'), type:'column'}, {name:BpcCommon.Api.getTranslation('ANALYSIS_TAB_LAYOUT_OPTION'), type:'tab'}, {name:BpcCommon.Api.getTranslation('ANALYSIS_ACCORDION_LAYOUT_OPTION'), type:'accordion'}];
}, onChange:function(cmp, newValue, oldValue) {
  var me = this;
  if (oldValue === null || oldValue === undefined) {
    return;
  }
  setTimeout(function() {
    me.mainReference.triggerUpdate();
  }, 50);
}});
Ext.define('analysis.view.reportEditor.components.ReportChartSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisReportChartSelector', matchFieldWidth:false, valueField:'id', displayField:'name', queryMode:'local', anyMatch:true, moduleId:undefined, displayTpl:null, localized:{emptyText:'ANALYSIS_REPORT_CHART_SELECTOR_EMPTY_TEXT'}, initComponent:function() {
  var me = this;
  this.store = Ext.create('Ext.data.ChainedStore', {source:Ext.data.StoreManager.lookup(this.moduleId + 'ChartListStore')});
  Ext.on('chartListUpdated', function(newDataSetList) {
    var store = me.getStore();
    if (store) {
      store.setData(newDataSetList);
    }
  });
  me.tpl = '\x3ctpl for\x3d"."\x3e\x3cdiv class\x3d\'x-boundlist-item\'\x3e{name}\x3c/div\x3e\x3c/tpl\x3e';
  me.callParent();
  me.store.sort('name', 'ASC');
}});
Ext.define('analysis.view.reportEditor.components.ReportRightsConfigurator', {extend:'analysis.components.AnalysisFieldSet', alias:'widget.analysisReportRightsConfigurator', rightsSelector:undefined, rolesSelector:undefined, organisationsSelector:undefined, UIFieldWidth:80, localized:{title:'ANALYSIS_REPORT_RIGHTS_ROLES_ORGANISATION_FIELDSET_TITLE'}, initComponent:function() {
  this.record = this.mainReference.getViewModel().get('record');
  this.createItems();
  this.items = [this.updateRightsField, this.rightsSelector, this.rolesSelector, this.organisationsSelector];
  this.callParent();
}, createItems:function() {
  var vm = this.mainReference.getViewModel();
  var reportData = vm.get('record');
  var rightsList = reportData.get('right');
  var rolesList = reportData.get('role');
  var organisationsList = reportData.get('organisation');
  var userIsAllowedAutoUpdate = reportData.get('userIsAllowedUpdateFrequency');
  var userIsAllowedUpdateFrequency = reportData.get('userIsAllowedUpdateFrequency');
  this.updateRightsField = Ext.create({xtype:'fieldcontainer', layout:'hbox', margin:'10 20 20 10', defaults:{labelWidth:200, flex:1}, items:[{xtype:'checkbox', localized:{fieldLabel:'ANALYSIS_REPORT_USER_ALLOW_AUTO_UPDATE'}, value:userIsAllowedAutoUpdate, listeners:{change:this.onChangeUserIsAllowedAutoUpdate.bind(this)}}, {xtype:'checkbox', localized:{fieldLabel:'ANALYSIS_REPORT_USER_ALLOW_UPDATE_FREQUENCY'}, value:userIsAllowedUpdateFrequency, listeners:{change:this.onChangeUserIsAllowedUpdateFrequency.bind(this)}}]});
  this.rightsSelector = Ext.create({xtype:'analysisRightsSelector', value:rightsList, width:this.UIFieldWidth, listeners:{change:this.onRightsSelect.bind(this)}, labelWidth:200, margin:'0 20px 10px 10px'});
  this.rolesSelector = Ext.create({xtype:'analysisRolesSelector', value:rolesList, width:this.UIFieldWidth, listeners:{change:this.onRolesSelect.bind(this)}, labelWidth:200, margin:'0 20px 10px 10px'});
  this.organisationsSelector = Ext.create({xtype:'analysisOrganisationSelector', value:organisationsList, width:this.UIFieldWidth, listeners:{change:this.onOrganisationsSelect.bind(this)}, labelWidth:200, margin:'0 20px 10px 10px'});
}, onRightsSelect:function(cmp, val) {
  this.record.set('right', val);
}, onRolesSelect:function(cmp, val) {
  this.record.set('role', val);
}, onOrganisationsSelect:function(cmp, val) {
  this.record.set('organisation', val);
}, onChangeUserIsAllowedAutoUpdate:function(el, val) {
  this.record.set('userIsAllowedAutoUpdate', val);
}, onChangeUserIsAllowedUpdateFrequency:function(el, val) {
  this.record.set('userIsAllowedUpdateFrequency', val);
}});
Ext.define('analysis.view.reportEditor.components.ReportViewer', {extend:'Ext.panel.Panel', alias:'widget.analysisReportViewer', viewModel:{data:undefined}, chartList:undefined, layout:'fit', chartCmpList:undefined, wrapperCmp:undefined, updateTaskInstance:undefined, pendingUpdate:false, activeTab:0, initComponent:function() {
  var me = this;
  me.callParent();
  var vm = me.getViewModel();
  var reportData = vm.get('record');
  var allowedToSee = BpcCommon.Api.isUserAllowedToSee(reportData);
  if (!allowedToSee) {
    this.showMissingRights();
    return;
  }
  me.on('updateReportConfig', me.onUpdateReportConfig.bind(me));
  me.on('afterrender', this.onAfterRender.bind(this));
  me.on('beforedestroy', this.onDestroy, this);
}, onLiveUpdate:function() {
  if (this.getLiveUpdate() === true) {
    this.onUpdateReportConfig();
  }
}, getLiveUpdate:function() {
  return this.getViewModel().get('record.globalLiveUpdate');
}, onAfterRender:function() {
  this.getEl().on('activate', this.onFocusReport, this);
  this.activateUpdateTask();
  var liveUpdate = this.getViewModel().get('globalLiveUpdate');
  if (!liveUpdate) {
    this.onUpdateReportConfig();
  }
}, onDestroy:function() {
  this.stopUpdateTask();
}, stopUpdateTask:function() {
  if (this.updateTaskInstance) {
    this.updateTaskInstance.stop();
  }
}, startUpdateTask:function() {
  if (this.updateTaskInstance) {
    this.updateTaskInstance.start();
  }
}, setNewUpdateTaskFrequency:function(newFrequency) {
  var vm = this.getViewModel();
  vm.set('record.updateFrequency', newFrequency);
  this.activateUpdateTask();
}, activateUpdateTask:function() {
  this.stopUpdateTask();
  var vm = this.getViewModel();
  var updateFrequency = vm.get('record.updateFrequency');
  var updateFrequencyMilliSeconds = parseInt(updateFrequency * 1000);
  var runner = new Ext.util.TaskRunner();
  if (typeof updateFrequency !== 'number' || updateFrequency < 1) {
    return;
  }
  this.updateTaskInstance = runner.newTask({run:this.checkForUpdate.bind(this), interval:updateFrequencyMilliSeconds, repeat:-1});
  this.updateTaskInstance.start();
}, onFocusReport:function() {
  if (this.pendingUpdate) {
    this.pendingUpdate = false;
    this.updateChartData();
  }
}, checkForUpdate:function() {
  try {
    var vm = this.getViewModel();
    var updateEnabled = vm.get('record.enableUpdate');
    if (this.isVisible() && updateEnabled) {
      this.updateChartData();
    } else {
      this.pendingUpdate = true;
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR checkForUpdate', dump:e, stack:true, level:'error'});
  }
}, updateChartData:function() {
  this.setReportChartVariableAssociation();
  var chartViewerList = this.query('analysisChartViewer');
  if (Ext.isArray(chartViewerList) && chartViewerList.length > 0) {
    chartViewerList.forEach(function(el) {
      el.reloadData();
    });
  }
}, showMissingRights:function() {
  var errCmp = {xtype:'bpcCenterMessageCmp', message:'CORE_AUTHORIZATION_FAILED'};
  this.add(errCmp);
}, createWrapper:function(children) {
  var me = this;
  var vm = me.getViewModel();
  var layout = vm.get('record.layout');
  var wrapperConfig;
  if (this.wrapperCmp) {
    this.remove(this.wrapperCmp);
  }
  switch(layout) {
    case 'hbox':
      wrapperConfig = {xtype:'panel', layout:{type:'hbox', align:'stretch'}, id:me.id + 'reportWrapper', items:children};
      break;
    case 'vbox':
      wrapperConfig = {xtype:'panel', layout:{type:'vbox', align:'stretch'}, id:me.id + 'reportWrapper', items:children};
      break;
    case 'column':
      wrapperConfig = {xtype:'container', layout:{type:'column', align:'stretch'}, id:me.id + 'reportWrapper', items:children};
      break;
    case 'tab':
      wrapperConfig = {xtype:'tabpanel', id:me.id + 'reportWrapper', activeTab:this.activeTab, listeners:{tabchange:this.onTabChange.bind(this)}, items:children};
      break;
    case 'accordion':
      wrapperConfig = {xtype:'panel', layout:{type:'accordion', align:'stretch', titleCollapse:true, animate:true, activeOnTop:false, multi:true}, id:me.id + 'reportWrapper', items:this.transformAccordionItems(children)};
      break;
  }
  this.wrapperCmp = this.add(wrapperConfig);
}, transformAccordionItems:function(items) {
  var accordeonItems = [];
  Ext.each(items, function(el) {
    if (!el) {
      return;
    }
    accordeonItems.push({title:el.title, layout:'fit', items:[el]});
  });
  return accordeonItems;
}, onTabChange:function(cmp) {
  var tab = cmp.getActiveTab();
  this.activeTab = cmp.items.indexOf(tab);
  if (this.mainReference === undefined) {
    return;
  }
  var reportEditorChartGrid = this.mainReference.down('analysisReportChartList');
  if (reportEditorChartGrid) {
    var selection = reportEditorChartGrid.getStore().getAt(this.activeTab);
    reportEditorChartGrid.setSelection(selection);
  }
}, setReportChartVariableAssociation:function() {
  var me = this;
  var vm = this.getViewModel();
  var chartList = vm.get('record.charts');
  if (!Ext.isArray(chartList)) {
    return;
  }
  var defaultValueChartList = chartList.map(function(el) {
    el.variables = analysis.assets.Helpers.getChartVariables(me.moduleId, el.chartID, true);
    return el;
  });
  var reportVarList = vm.get('record.reportVariables');
  if (!Ext.isArray(reportVarList)) {
    return;
  }
  reportVarList.map(function(reportVar) {
    if (reportVar.externalSource === true) {
      var globalVar = analysis.assets.Helpers.getGlobalVariable(reportVar.globalId);
      if (!globalVar) {
        return reportVar;
      }
      if (globalVar.value !== undefined && globalVar.value !== null) {
        reportVar.globalPreviewValue = globalVar.value;
      } else {
        reportVar.globalPreviewValue = reportVar.value;
      }
    }
    return reportVar;
  });
  reportVarList.forEach(function(reportVar) {
    reportVar.association.forEach(function(association) {
      var foundChartIndex = defaultValueChartList.findIndex(function(item) {
        return parseInt(item.id) === parseInt(association.connectedChartId);
      });
      if (foundChartIndex !== -1) {
        var foundChartId = defaultValueChartList[foundChartIndex].chartID;
        var foundChartVariables = analysis.assets.Helpers.getChartVariables(me.moduleId, foundChartId);
        var foundVariableIndex = foundChartVariables.findIndex(function(item) {
          return parseInt(item.id) === parseInt(association.variableId);
        });
        if (foundVariableIndex !== -1) {
          var replaceValue = reportVar.externalSource ? reportVar.globalPreviewValue : reportVar.value;
          defaultValueChartList[foundChartIndex].variables[foundVariableIndex].value = replaceValue;
        } else {
        }
      } else {
      }
    });
  });
  vm.set('record.charts', defaultValueChartList);
}, onUpdateReportConfig:function() {
  this.setReportChartVariableAssociation();
  var me = this;
  var vm = me.getViewModel();
  var chartList = vm.get('record.charts');
  var reportWrapper = me.down('#' + me.id + 'reportWrapper');
  if (reportWrapper) {
    me.remove(reportWrapper);
  }
  var chartCmpList = me.renderCharts(chartList);
  me.createWrapper(chartCmpList);
}, renderCharts:function(chartList) {
  var me = this;
  var items = [];
  Ext.Array.each(chartList, function(el) {
    items.push(me.validateChart(el));
  });
  return items;
}, validateChart:function(reportChartConfig) {
  var me = this;
  var chartConfig = analysis.assets.Helpers.getChartConfiguration(me.moduleId, reportChartConfig.chartID);
  if (chartConfig) {
    return me.createSuccessChart(reportChartConfig, chartConfig);
  }
}, getMainTitle:function(chartName, chartTitle) {
  return chartTitle === '' ? chartName : chartTitle;
}, createSuccessChart:function(reportChartConfig, chartConfig) {
  var chartTitle = this.getMainTitle(chartConfig.name, reportChartConfig.title);
  var me = this;
  var variables = reportChartConfig.variables;
  var chartCmp = {xtype:'analysisChartViewer', title:chartTitle, chartConfig:chartConfig, moduleId:me.moduleId, variables:variables, flex:1};
  Ext.apply(chartCmp, reportChartConfig.additionalParameters);
  return chartCmp;
}, createFailureChart:function(errMsg) {
  return {xtype:'bpcCenterMessageCmp', message:errMsg};
}, setAutoUpdate:function(el, val) {
  this.updateChartData();
  if (val) {
    this.startUpdateTask();
  } else {
    this.stopUpdateTask();
  }
}, setNewConfiguration:function(newConfiguration) {
  var vm = this.getViewModel();
  vm.set('record', newConfiguration);
  this.activateUpdateTask();
  this.onUpdateReportConfig();
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.ReportConfigForm', {extend:'Ext.form.Panel', alias:'widget.analysisReportConfigForm', controller:'analysisReportConfigFromController', scrollable:true, layout:{type:'vbox', align:'stretch'}, defaults:{margin:'0 20px 10px 10px'}, mainReference:undefined, generalSettingsCmp:undefined, chartListCmp:undefined, layoutCmp:undefined, variablesCmp:undefined, initComponent:function() {
  this.createButtons();
  this.callParent();
  this.createUI();
  this.on('afterrender', this.onAfterRender, this);
}, onAfterRender:function() {
  var me = this;
  var controller = me.getController();
  if (controller && Ext.isFunction(controller.executeReportConfig)) {
    controller.executeReportConfig();
  }
}, createUI:function() {
  this.createGeneralSettings();
  this.createLayoutConfigurator();
  this.createChartListConfigurator();
  this.createVariableConfigurator();
  this.createRightRolesSelector();
}, createButtons:function() {
  var itemArray = [{xtype:'toggleslidefield', localized:{fieldLabel:'ANALYSIS_LIVE_UPDATE_FIELD_LABEL'}, labelAlign:'top', labelWidth:40, bind:{value:'{record.globalLiveUpdate}'}, listeners:{change:'onChangeLiveUpdate'}}, {iconCls:'x-fal fa-exclamation-triangle warningColor', itemId:'reportUnsavedChangesIcon', ui:'apptoolbardefault', localized:{text:'ANALYSIS_UNSAVED_CHANGES'}, bind:{hidden:'{!hasUnsavedChanges}'}, handler:'onSave'}, '-\x3e', {xtype:'button', localized:{text:'ANALYSIS_TEST_QUERY'}, 
  iconCls:'x-fal fa-play', ui:'secondary', handler:'executeReportConfig'}, {xtype:'button', ui:'primary', localized:{text:'CORE_SAVE'}, iconCls:'x-fal fa-save', handler:'onSave', margin:10}];
  this.dockedItems = [{xtype:'toolbar', dock:'bottom', ui:'footer', overflowHandler:'scroller', items:itemArray}];
}, createGeneralSettings:function() {
  var vm = this.mainReference.getViewModel();
  var updateFrequency = vm.get('record.updateFrequency');
  var autoUpdateEnabled = vm.get('record.enableUpdate');
  this.generalSettingsCmp = this.add({xtype:'analysisFieldSet', itemId:'analysisReportGeneralSettings', collapsed:false, localized:{title:'ANALYSIS_DATASET_BASIC_SETTINGS'}, layout:{type:'vbox', align:'stretch'}, defaults:{labelWidth:200, margin:'0 20px 10px 10px'}, items:[{xtype:'bpcTextField', itemId:'analysisReportNameSelector', localized:{fieldLabel:'CORE_NAME'}, bind:{value:'{record.name}'}, allowBlank:false}, {xtype:'fieldcontainer', layout:'hbox', margin:'10 20px 10px 10px', defaults:{labelWidth:150, 
  flex:1}, items:[{xtype:'toggleslidefield', labelAlign:'left', localized:{fieldLabel:'ANALYSIS_AUTO_UPDATE_FIELD_LABEL'}, listeners:{change:this.onChangeAutoUpdateEnabled.bind(this)}, value:autoUpdateEnabled}, {xtype:'bpcNumberField', localized:{fieldLabel:'ANALYSIS_REPORT_UPDATE_FREQUENCY_FIELD_LABEL'}, value:updateFrequency, minValue:1, listeners:{change:this.setUpdateFrequency.bind(this)}}]}]});
}, createRightRolesSelector:function() {
  this.rightRolesCmp = this.add({xtype:'analysisReportRightsConfigurator', mainReference:this.mainReference, collapsed:false});
}, createChartListConfigurator:function() {
  this.chartListCmp = this.add({xtype:'analysisFieldSet', localized:{title:'ANALYSIS_REPORT_CHART_LIST'}, items:[{xtype:'analysisReportChartList', mainReference:this.mainReference, viewModel:{parent:this.getViewModel()}}]});
}, createLayoutConfigurator:function() {
  this.layoutCmp = this.add({xtype:'analysisLayoutConfigurator', layout:{type:'vbox', align:'stretch'}, collapsed:false, mainReference:this.mainReference});
}, createVariableConfigurator:function() {
  this.variablesCmp = this.add({xtype:'analysisReportVariablesFieldSet', mainReference:this.mainReference});
}, onChangeAutoUpdateEnabled:function(el, val) {
  var vm = this.mainReference.getViewModel();
  vm.set('record.enableUpdate', val);
}, setUpdateFrequency:function(el, val) {
  this.mainReference.down('analysisReportViewer').setNewUpdateTaskFrequency(val);
}});
Ext.define('analysis.view.dataSetEditor.dataSetConfigForm.ReportConfigFromController', {extend:'Ext.app.ViewController', alias:'controller.analysisReportConfigFromController', onSave:function() {
  var configForm = this.getView();
  if (!configForm.isValid()) {
    BpcCommon.Api.showNotification({text:'Validierung fehlgeschlagen', popUp:true, type:'error'});
    return;
  }
  var dataSetEditor = configForm.up('analysisReportEditor');
  var moduleId = dataSetEditor.moduleId;
  var viewModel = this.getView().getViewModel();
  var record = viewModel.get('record');
  return record.saveReport(moduleId, {success:function() {
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('ANALYSIS_REPORT_CONFIG_SAVED'), toast:false});
    record.save();
  }, failure:function(record, operation) {
    var error = operation.error;
    try {
      var response = JSON.parse(error.response.responseText);
      BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
    } catch (err) {
      Ext.log({level:'error', message:'Save data set config error'});
    }
  }});
}, executeReportConfig:function() {
  var me = this;
  var view = me.getView();
  var reportView = view.up('analysisReportEditor').down('analysisReportViewer');
  if (reportView) {
    reportView.fireEvent('updateReportConfig');
  }
}, onChangeLiveUpdate:function(cmp, newVal, oldVal) {
  if (oldVal === '' || oldVal === undefined || oldVal === null) {
    return;
  }
  if (newVal === true) {
    this.executeReportConfig();
  }
}});
Ext.define('analysis.view.reportEditor.reportConfigForm.ReportModel', {extend:'Ext.data.Model', idProperty:'id', fields:[{name:'id', type:'string'}, {name:'name', type:'string'}, {name:'charts', defaultValue:[]}, {name:'layout', type:'string', defaultValue:'vbox'}, {name:'variables', defaultValue:[]}, {name:'enableUpdate', defaultValue:true}, {name:'userIsAllowedAutoUpdate', defaultValue:true}, {name:'userIsAllowedUpdateFrequency', defaultValue:true}, {name:'globalVariables', defaultValue:[]}], proxy:{type:'memory'}, 
saveReport:function(moduleId, handlers) {
  var newSetting = this.getData();
  if (moduleId) {
    var newSettingModel = analysis.assets.Helpers.updateSettingModel(moduleId, analysis.assets.ConfigKeys.reportsConfigs, newSetting);
    newSettingModel.save(handlers);
  }
}, addChart:function(chart) {
  var charts = this.get('charts');
  charts.push(chart);
}, removeChart:function(chartId) {
  var charts = this.get('charts');
  Ext.Array.removeAt(charts, charts.findIndex(function(item) {
    return item.id === chartId;
  }));
}});
Ext.define('analysis.view.reportEditor.reportList.ReportList', {extend:'Ext.grid.Panel', alias:'widget.analysisReportList', itemId:'analysisReportList', cmpType:'listItems', controller:'analysisReportListController', localized:{title:'ANALYSIS_REPORTS'}, minButtonWidth:30, buttons:[{iconCls:'x-fal fa-plus', localized:{tooltip:'ANALYSIS_ADD'}, handler:'onAddReportConfig'}], listeners:{select:'onSelect', afterrender:'onAfterRender'}, initComponent:function() {
  var moduleId = this.moduleId;
  this.store = Ext.create('Ext.data.ChainedStore', {source:analysis.assets.Helpers.getReportListStore(moduleId), sorters:['name']});
  this.columns = [{localized:{text:'CORE_NAME'}, dataIndex:'name', flex:2}, {text:'ID', dataIndex:'id', hidden:true}, {xtype:'actioncolumn', width:70, sortable:false, menuDisabled:true, align:'center', items:[{iconCls:'x-fal fa-copy', tooltip:BpcCommon.Api.getTranslation('ANALYSIS_DUPLICATE'), handler:'onDuplicateReport'}, {iconCls:'x-fal fa-trash', tooltip:BpcCommon.lang.Current.CORE_DELETE, handler:'onRemoveReport'}]}];
  this.callParent();
}});
Ext.define('analysis.view.reportEditor.reportList.ReportListController', {extend:'Ext.app.ViewController', alias:'controller.analysisReportListController', onSelect:function(row, record) {
  var view = this.getView();
  var reportEditor = view.up().down('#analysisReportEditorWrapper');
  if (!record.reportEditor) {
    var item = {xtype:'analysisReportEditor', moduleId:view.moduleId, minWidth:500, record:record};
    record.reportEditor = reportEditor.add(item);
  }
  reportEditor.setActiveItem(record.reportEditor);
}, onAfterRender:function() {
  this.selectFirstElement();
}, selectFirstElement:function() {
  var view = this.getView();
  if (view.getStore().getData().items.length === 0) {
    var editorsWrapper = view.up('analysisReportEditorContainer').down('#analysisReportEditorWrapper');
    analysis.assets.Helpers.showCentralWarningTextComponentsList(editorsWrapper);
  } else {
    view.setSelection(view.getStore().first());
  }
}, onAddReportConfig:function() {
  var me = this;
  var grid = me.getView();
  if (grid) {
    var id = Date.now().toString();
    var newRecord = grid.getStore().add({id:id, name:'Report ' + id, charts:[], layout:'vbox', updateFrequency:120, reportVariables:[], dataSetVariables:[], chartVariables:[]});
    grid.setSelection(newRecord);
    var moduleId = grid.moduleId;
    var currentSettingsModel = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.reportsConfigs, true);
    var currentSettings = currentSettingsModel.get('value');
    currentSettings.push(newRecord[0].getData());
    currentSettingsModel.set('value', currentSettings);
    currentSettingsModel.save({success:function() {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('CORE_OK'));
    }, failure:function(record, operation) {
      var error = operation.error;
      try {
        var response = JSON.parse(error.response.responseText);
        BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
      } catch (err) {
        Ext.log({level:'error', message:'Create data set config error'});
      }
    }});
  }
}, onRemoveReport:function(grid, rowIndex) {
  var me = this;
  var view = me.getView();
  Ext.Msg.show({title:BpcCommon.Api.getTranslation('ANALYSIS_DELETE_REPORT_CONFIRM_TITLE'), message:BpcCommon.Api.getTranslation('ANALYSIS_DELETE_REPORT_CONFIRM_TEXT'), buttons:Ext.Msg.YESNO, icon:Ext.Msg.QUESTION, fn:function(btn) {
    if (btn === 'yes') {
      var moduleId = view.moduleId;
      var store = view.getStore();
      var record = store.getAt(rowIndex);
      var reportId = record.get('id');
      var settingsModel = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.reportsConfigs, true);
      var settings = settingsModel.get('value');
      var newSettings = Ext.Array.removeAt(settings, settings.findIndex(function(item) {
        return item.id.toString() === reportId;
      }));
      settingsModel.set('value', newSettings);
      settingsModel.save({success:function() {
        BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('CORE_OK'));
        record.erase();
        me.selectFirstElement();
      }, failure:function(record, operation) {
        var error = operation.error;
        try {
          var response = JSON.parse(error.response.responseText);
          BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
        } catch (err) {
          Ext.log({level:'error', message:'Delete Report config error'});
        }
      }});
    }
  }});
}, onDuplicateReport:function() {
  var me = this;
  var grid = me.getView();
  var selectedRecord = grid.getSelection()[0];
  if (selectedRecord) {
    var id = Date.now().toString();
    var newRecordData = Ext.apply(selectedRecord.getData(), {name:'Copy of ' + selectedRecord.get('name'), id:id});
    var moduleId = grid.moduleId;
    var settingsModel = BpcCommon.Api.getSetting(moduleId, analysis.assets.ConfigKeys.reportsConfigs, true);
    var reportList = settingsModel.get('value');
    reportList.push(newRecordData);
    settingsModel.set('value', reportList);
    settingsModel.save({success:function() {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('CORE_OK'));
      var newRecord = grid.getStore().add(newRecordData);
      grid.setSelection(newRecord);
    }, failure:function(record, operation) {
      var error = operation.error;
      try {
        var response = JSON.parse(error.response.responseText);
        BpcCommon.Api.showNotification({text:response.error, popUp:true, type:'error'});
      } catch (err) {
        Ext.log({level:'error', message:'Create Report config error'});
      }
    }});
  }
}});
Ext.define('analysis.view.reportEditor.variables.ChartVariablesGrid', {extend:'Ext.grid.Panel', alias:'widget.analysisChartVariablesGrid', viewConfig:{markDirty:false}, disableSelection:true, mainReference:undefined, detailWindow:undefined, initComponent:function() {
  var me = this;
  me.store = Ext.create('Ext.data.Store', {grouper:{property:'connectedChartId'}, fields:[{name:'id', type:'string'}, {name:'name', type:'string'}, {name:'type', type:'string'}, {name:'state', type:'string'}]});
  me.features = [{ftype:'grouping', groupHeaderTpl:["{translate:translate('ANALYSIS_CHART')}: " + '{name:this.getChartName}', {getChartName:me.getChartName.bind(me)}]}];
  me.columns = [{xtype:'checkcolumn', dataIndex:'state', localized:{text:'ANALYSIS_ASSOCIATED'}, setRecordCheck:function(record) {
    var me = this;
    var state = record.get('state');
    var controller = me.lookupController();
    var newState = '';
    if (state === 'enabledChecked') {
      controller.writeAssociations(record, false);
      newState = 'enabledUnchecked';
    } else if (state === 'enabledUnchecked') {
      controller.writeAssociations(record, true);
      newState = 'enabledChecked';
    } else {
      return;
    }
    record.set('state', newState);
  }.bind(me), renderer:function(value, cellValues) {
    var me = this;
    var cls = me.checkboxCls, tip = '';
    switch(value) {
      case 'disabledUnchecked':
        cellValues.tdCls += ' ' + me.disabledCls;
        tip = BpcCommon.Api.getTranslation('ANALYSIS_CHECKBOX_TOOLTIP_NO_TYPE_MATCHING');
        break;
      case 'disabledChecked':
        cls += ' ' + me.checkboxCheckedCls;
        cellValues.tdCls += ' ' + me.disabledCls;
        tip = BpcCommon.Api.getTranslation('ANALYSIS_CHECKBOX_TOOLTIP_ASSOCIATED_BY_OTHERS');
        break;
      case 'enabledUnchecked':
        tip = BpcCommon.Api.getTranslation('ANALYSIS_CHECKBOX_TOOLTIP_TYPE_MATCHING');
        break;
      case 'enabledChecked':
        cls += ' ' + me.checkboxCheckedCls;
        tip = BpcCommon.Api.getTranslation('ANALYSIS_CHECKBOX_TOOLTIP_ASSOCIATED_BY_SELECTION');
        break;
      case 'default':
        cellValues.tdCls += ' ' + me.disabledCls;
        break;
      default:
        break;
    }
    me.checkedTooltip = 'tip';
    if (tip) {
      cellValues.tdAttr += ' data-qtip\x3d"' + Ext.htmlEncode(tip) + '"';
    }
    me.updateHeaderState();
    return '\x3cspan class\x3d"' + cls + '" role\x3d"' + me.checkboxAriaRole + '"' + (!me.ariaStaticRoles[me.checkboxAriaRole] ? ' tabIndex\x3d"0"' : '') + '\x3e\x3c/span\x3e';
  }, width:100}, {localized:{text:'CORE_NAME'}, sortable:false, dataIndex:'name', flex:1}, {xtype:'bpcSettingColumn', localized:{text:'CORE_VALUE'}, dataIndex:'value', sortable:false, flex:1}, {localized:{text:'CORE_TYPE'}, dataIndex:'type', sortable:false, width:80}];
  this.callParent();
}, getChartName:function(id) {
  var vm = this.getViewModel();
  var charts = vm.get('record.charts');
  var foundChart = charts.find(function(el) {
    return parseInt(el.id) === parseInt(id);
  });
  if (foundChart.title && foundChart.title !== '') {
    return foundChart.title;
  }
  var chartId = foundChart.chartID;
  var moduleId = this.mainReference.moduleId;
  return analysis.assets.Helpers.getChartName(moduleId, chartId);
}});
Ext.define('analysis.view.reportEditor.variables.ExternalVariableView', {extend:'Ext.panel.Panel', alias:'widget.analysisExternalVariableView', moduleId:undefined, mainReference:undefined, layout:{type:'vbox', align:'stretch'}, bodyPadding:10, reportData:undefined, actOnStoreChanges:true, initComponent:function() {
  this.buttons = [{xtype:'button', localized:{text:'CORE_APPLY'}, iconCls:BpcCommon.Icons.OK, handler:function() {
    this.fireEvent('showReportContent');
  }.bind(this)}];
  this.callParent();
  this.createItems();
}, createItems:function() {
  this.removeAll();
  if (analysis.assets.Helpers.isObjectEmpty(this.reportData)) {
    this.add({xtype:'container', flex:1, items:[{xtype:'bpcCenterMessageCmp', message:'ANALYSIS_REPORT_NOT_FOUND', messageIconCls:'x-fal fa-exclamation-triangle'}]});
    return;
  }
  this.createUpdateUI();
  this.createReportVariablesGrid();
  this.add([this.reportVariablesGrid, this.updateUI]);
}, createUpdateUI:function() {
  var autoUpdateEnabled = this.reportData.enableUpdate;
  var updateFrequency = this.reportData.updateFrequency || 0;
  var userIsAllowedAutoUpdate = this.reportData.userIsAllowedAutoUpdate;
  var userIsAllowedUpdateFrequency = this.reportData.userIsAllowedUpdateFrequency;
  var userUpdateRights = userIsAllowedAutoUpdate || userIsAllowedUpdateFrequency;
  this.updateUI = Ext.create({flex:1, xtype:'analysisFieldSet', localized:{title:'ANALYSIS_UPDATE_SETTINGS'}, hidden:!userUpdateRights, items:[{xtype:'fieldcontainer', layout:'hbox', defaults:{labelWidth:140, flex:1}, items:[{xtype:'toggleslidefield', stateful:true, stateId:'report_AutoUpdate_' + this.reportData.id, localized:{fieldLabel:'ANALYSIS_AUTO_UPDATE_FIELD_LABEL'}, value:autoUpdateEnabled, hidden:!userIsAllowedAutoUpdate, listeners:{change:this.onChangAutoUpdate.bind(this)}}, {xtype:'bpcNumberField', 
  stateful:true, stateId:'report_UpdateFrequency_' + this.reportData.id, localized:{fieldLabel:'ANALYSIS_REPORT_UPDATE_FREQUENCY_FIELD_LABEL'}, listeners:{change:this.onChangeAutoUpdateFrequency.bind(this)}, minValue:1, value:updateFrequency, hidden:!userIsAllowedUpdateFrequency}]}]});
}, createReportVariablesGrid:function() {
  var reportVariables = this.reportData.reportVariables;
  this.reportVariablesStore = Ext.create('Ext.data.Store', {});
  this.reportVariablesStore.loadRawData(reportVariables);
  this.reportVariablesStore.on('datachanged', this.onChangeReportVariables.bind(this));
  this.reportVariablesStore.addFilter({property:'userVisibility', value:true});
  this.reportVariablesGrid = Ext.create({flex:3, xtype:'grid', localized:{title:'ANALYSIS_REPORT_VARIABLES_GRID_TITLE'}, store:this.reportVariablesStore, plugins:{ptype:'cellediting', clicksToEdit:1}, columns:[{dataIndex:'name', localized:{text:'CORE_NAME'}, flex:1}, {dataIndex:'type', localized:{text:'CORE_TYPE'}, flex:1}, {dataIndex:'source', localized:{text:'ANALYSIS_SOURCE'}, flex:1}, {dataIndex:'value', localized:{text:'CORE_VALUE'}, xtype:'bpcSettingColumn', flex:1, editor:{editable:false, 
  disabled:true, completeOnEnter:false, allowBlank:false}}]});
}, onChangeReportVariables:function() {
  if (this.actOnStoreChanges) {
    if (this.reportVariablesGrid) {
      var store = this.reportVariablesGrid.getStore();
      if (store) {
        var newStoreData = analysis.assets.Helpers.getRawDataFromStore(store);
        this.reportData.reportVariables = newStoreData;
        this.emitReportDataChangeEvent();
      }
    }
  }
}, onChangAutoUpdate:function(el, val) {
  this.reportData.enableUpdate = val;
  this.emitReportDataChangeEvent();
}, onChangeAutoUpdateFrequency:function(el, val) {
  this.reportData.updateFrequency = val;
  this.emitReportDataChangeEvent();
}, emitReportDataChangeEvent:function() {
  this.fireEvent('reportDataChanged', this.reportData);
}, setNewConfiguration:function(newConfiguration) {
  this.reportData = newConfiguration;
  this.createItems();
  this.actOnStoreChanges = true;
}});
Ext.define('analysis.view.reportEditor.variables.NewVariableWindow', {extend:'BpcCommon.component.window.Window', alias:'widget.analysisNewReportVariableWindow', localized:{title:'ANALYSIS_ADD_VARIABLE'}, viewModel:{data:{variableType:undefined, variableName:undefined}}, modal:true, bodyPadding:10, iconCls:BpcCommon.Icons.ADD, width:400, minHeight:300, height:300, initComponent:function() {
  var me = this;
  me.items = [{xtype:'form', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'bpcTextField', localized:{fieldLabel:'CORE_NAME'}, allowBlank:false, bind:{value:'{variableName}'}}, {xtype:'analysisReportVariableTypeSelector', localized:{fieldLabel:'CORE_TYPE'}, bind:{value:'{variableType}'}}, {xtype:'bpcToolbarMsg', iconCls:BpcCommon.Icons.WARNING, style:'', iconColorCls:'warningColor', text:'ANALYSIS_VARIABLE_TYPE_CAN_NOT_BE_CHANGED'}], buttons:[{localized:{text:'CORE_CANCEL'}, iconCls:BpcCommon.Icons.CANCEL, 
  ui:'secondary', handler:me.callbackCancel}, {localized:{text:'CORE_ADD'}, itemId:'bpcLanguageKeysAddLanguageFormConfirmButton', iconCls:BpcCommon.Icons.ADD, ui:'primary', formBind:true, handler:me.callback}]}];
  me.callParent();
}, callback:function() {
}, callbackCancel:function() {
}});
Ext.define('analysis.view.reportEditor.variables.ReportVariablesController', {extend:'Ext.app.ViewController', alias:'controller.analysisReportVariablesController', control:{'analysisReportVariablesGrid':{}}, listen:{store:{'#Fieldset_AnalysisReportVariablesGridStore':{datachanged:'onReportVariablesStoreChange'}}}, onReportVariablesStoreChange:function(store) {
  if (store.isFilled) {
    var me = this;
    var vm = me.getView().mainReference.getViewModel();
    var rawData = analysis.assets.Helpers.getRawDataFromStore(store);
    vm.set('record.reportVariables', rawData);
    me.getView().mainReference.triggerUpdate();
  }
}, openDirectMappingDialog:function() {
  var me = this;
  var reportVariableList = me.getView().mainReference.getViewModel().get('record.reportVariables');
  if (Ext.isArray(reportVariableList) && reportVariableList.length === 0) {
    me.setDirectMapping();
    return;
  }
  Ext.Msg.show({title:BpcCommon.Api.getTranslation('ANALYSIS_SET_DIRECT_MAPPING_CONFIRM_TITLE'), message:BpcCommon.Api.getTranslation('ANALYSIS_SET_DIRECT_MAPPING_CONFIRM_MESSAGE'), buttons:Ext.Msg.YESNO, icon:Ext.Msg.QUESTION, fn:function(btn) {
    if (btn === 'yes') {
      me.setDirectMapping();
    }
  }});
}, setDirectMapping:function() {
  var me = this;
  var chartList = me.getChartList();
  var view = me.getView();
  var mainReference = view.mainReference;
  var moduleId = mainReference.moduleId;
  var vm = mainReference.getViewModel();
  var reportVarList = [];
  chartList.forEach(function(chart) {
    var chartVariables = chart.variables;
    chartVariables.forEach(function(variable) {
      var variableName = variable.name;
      var chartName = analysis.assets.Helpers.getChartName(moduleId, chart.chartID);
      var reportVariableName = chartName + '_' + variableName;
      var association = [{chartId:chart.chartID, connectedChartId:chart.id, variableId:variable.id, variableName:variableName, value:variable.value}];
      var newReportVariable = Ext.apply({association:association, variableId:variable.id, reportVariableName:reportVariableName, userVisibility:true}, variable, {});
      delete newReportVariable.id;
      reportVarList.push(newReportVariable);
    });
  });
  vm.set('record.reportVariables', reportVarList);
  this.reloadGridStore();
}, getChartList:function() {
  var me = this;
  var view = me.getView();
  var mainReference = view.mainReference;
  var vm = mainReference.getViewModel();
  var moduleId = mainReference.moduleId;
  var chartList = vm.get('record.charts');
  chartList.forEach(function(singleChart, idx) {
    chartList[idx].variables = analysis.assets.Helpers.getChartVariables(moduleId, singleChart.chartID, true);
  });
  vm.set('record.charts', chartList);
  return chartList;
}, closeDetailVariableWindow:function() {
  this.reloadGridStore();
}, reloadGridStore:function() {
  var me = this;
  var view = me.getView();
  var grid = view.down('analysisReportVariablesGrid');
  if (grid) {
    grid.fillStore();
  }
}, openDetailVariableWindow:function() {
  var me = this;
  Ext.create({xtype:'bpcWindow', localized:{title:'ANALYSIS_REPORT_VARIABLES_DETAIL_WINDOW_TITLE'}, iconCls:analysis.assets.Icons.variableAssociation, items:{xtype:'analysisReportVariablesDetail', mainReference:me.getView().mainReference}, listeners:{close:this.closeDetailVariableWindow.bind(this)}});
}});
Ext.define('analysis.view.reportEditor.variables.ReportVariablesFieldSet', {alias:'widget.analysisReportVariablesFieldSet', extend:'analysis.components.AnalysisFieldSet', controller:'analysisReportVariablesController', layout:{type:'vbox', align:'stretch'}, localized:{title:'ANALYSIS_REPORT_VARIABLE_FIELDSET_TITLE'}, initComponent:function() {
  var me = this;
  me.items = [{xtype:'analysisReportVariablesGrid', mainReference:me.mainReference, storeIdPrefix:'Fieldset', buttons:['-\x3e', {xtype:'button', ui:'secondary', itemId:'analysisReportStandardAssociation', iconCls:analysis.assets.Icons.oneToOneAssociation, localized:{tooltip:'ANALYSIS_REPORT_RESET_VARIABLE_DETAIL_TOOLTIP', text:'ANALYSIS_REPORT_RESET_VARIABLE_DETAIL_TEXT'}, handler:'openDirectMappingDialog', margin:5}, {xtype:'button', ui:'secondary', iconCls:analysis.assets.Icons.variableAssociation, 
  itemId:'analysisReportAssociationWindowButton', localized:{tooltip:'ANALYSIS_REPORT_OPEN_VARIABLE_DETAIL_TOOLTIP', text:'ANALYSIS_REPORT_OPEN_VARIABLE_DETAIL_TEXT'}, handler:'openDetailVariableWindow', margin:5}]}];
  this.callParent();
}});
Ext.define('analysis.view.reportEditor.variables.ReportVariablesGrid', {extend:'Ext.grid.Panel', alias:'widget.analysisReportVariablesGrid', itemId:'analysisReportVariablesGrid', moduleId:undefined, mainReference:undefined, allowDeselect:false, plugins:{ptype:'cellediting', clicksToEdit:1}, emptyText:BpcCommon.lang.Current.ANALYSIS_NO_REPORT_VARIABLES, storeIdPrefix:'', initComponent:function() {
  var me = this;
  me.store = Ext.create('Ext.data.Store', {model:'analysis.model.ReportVariablesModel', storeId:me.storeIdPrefix + '_AnalysisReportVariablesGridStore', isFilled:false});
  this.fillStore();
  me.columns = [{localized:{text:'CORE_NAME'}, dataIndex:'name', flex:1, editor:{xtype:'bpcTextField'}}, {xtype:'bpcSettingColumn', itemId:'analysisVariableValueCell', localized:{text:'CORE_VALUE'}, dataIndex:'value', sortable:false, flex:1, editor:{completeOnEnter:false, selectOnFocus:false, allowBlank:false}}, {localized:{text:'CORE_TYPE', emptyCellText:'empty'}, dataIndex:'type', width:80}, {xtype:'checkcolumn', localized:{text:'ANALYSIS_REPORT_VISIBLE', tooltip:'ANALYSIS_USER_VISIBILITY_TOOLTIP'}, 
  dataIndex:'userVisibility', width:80}, {xtype:'checkcolumn', localized:{text:'ANALYSIS_GLOBAL_ACTIVE', tooltip:'ANALYSIS_GLOBAL_ACTIVE_TOOLTIP'}, dataIndex:'externalSource', width:120}, {xtype:'bpcSettingColumn', localized:{text:'Globale Variable'}, dataIndex:'globalId', width:120, type:'list', editor:{xtype:'bpcCellEditor'}, renderer:function(value, metaData, record) {
    var globalActive = record.get('externalSource');
    if (!globalActive) {
      metaData.tdCls += Ext.baseCSSPrefix + 'item-disabled';
      return BpcCommon.Api.getTranslation('ANALYSIS_NOT_ACTIVE');
    }
    return value;
  }.bind(me)}, {xtype:'actioncolumn', width:60, sortable:false, menuDisabled:true, align:'center', items:[{iconCls:'x-fal fa-trash', handler:this.onDeleteReportVariable.bind(this)}]}];
  this.callParent();
}, fillStore:function() {
  var me = this;
  var vm = me.mainReference.getViewModel();
  var reportVariableList = vm.get('record.reportVariables');
  reportVariableList.map(function(variable) {
    variable['_valueList'] = analysis.assets.Helpers.getTypeMatchingGlobalVariables(variable.type);
    return variable;
  });
  me.store.loadRawData(reportVariableList);
  me.store.isFilled = true;
}, onDeleteReportVariable:function(grid, rowIndex) {
  grid.getStore().removeAt(rowIndex);
}});
Ext.define('analysis.view.reportEditor.variables.VariableConfigForm', {extend:'Ext.panel.Panel', alias:'widget.analysisReportVariableConfigForm', minButtonWidth:30, layout:{type:'vbox', align:'stretch'}, viewModel:{data:{}}, fieldSetSettingsCmp:undefined, fieldSetValueCmp:undefined, initComponent:function() {
  var me = this;
  var vm = me.getViewModel();
  vm.set('record', this.record);
  me.items = [{xtype:'analysisFieldSet', margin:10, collapsible:false, items:[{xtype:'bpcTextField', bind:{value:'{record.name}'}, localized:{fieldLabel:'CORE_NAME', emptyText:'ANALYSIS_NO_NAME_SET'}, allowBlank:false}, {xtype:'analysisReportVariableTypeSelector', bind:{value:'{record.type}'}, readOnly:true, disabled:true, localized:{fieldLabel:'CORE_TYPE'}, allowBlank:false}, {xtype:'analysisValueField', listeners:{customChange:'timedRefreshChartVariables'}, record:me.record}, {xtype:'checkbox', 
  bind:{value:'{record.userVisibility}'}, localized:{fieldLabel:'ANALYSIS_REPORT_VISIBLE'}}]}];
  this.callParent();
}});
Ext.define('analysis.view.reportEditor.variables.VariableTypeSelector', {extend:'BpcCommon.component.form.field.ComboBox', alias:'widget.analysisReportVariableTypeSelector', matchFieldWidth:true, queryMode:'local', anyMatch:true, forceSelection:true, localized:{fieldLabel:'ANALYSIS_VARIABLE_TYPE'}, allowBlank:false, initComponent:function() {
  this.store = ['number', 'text', 'boolean', 'list', 'date'];
  this.callParent();
}});
Ext.define('analysis.view.reportEditor.variables.VariablesDetail', {extend:'Ext.panel.Panel', alias:'widget.analysisReportVariablesDetail', controller:'analysisReportVariablesDetailController', bodyPadding:10, layout:{type:'hbox', align:'stretch'}, viewModel:{data:undefined}, chartList:undefined, initComponent:function() {
  var me = this;
  var vm = me.mainReference.getViewModel();
  var dockedItemArray = [{xtype:'button', iconCls:BpcCommon.Icons.INFO, ui:'secondary', iconColorCls:'successColor', tooltip:{dismissDelay:0, text:BpcCommon.Api.getTranslation('ANALYSIS_ASSOCIATION_EXPLANATION'), frame:true}}, '-\x3e', {xtype:'button', ui:'secondary', localized:{text:'CORE_CANCEL'}, itemId:'analysisReportVariableDetailCloseButton', iconCls:'x-fal fa-times', handler:this.onCancel.bind(this), margin:10}, {xtype:'button', ui:'primary', localized:{text:'CORE_SAVE'}, bind:{disabled:'{!reportVariablesValid}'}, 
  iconCls:'fal fa-save', handler:'onSaveReportDetail', margin:10}];
  me.dockedItems = [{xtype:'toolbar', dock:'bottom', ui:'footer', overflowHandler:'scroller', items:dockedItemArray}];
  me.items = [{xtype:'panel', localized:{title:'ANALYSIS_REPORT_VARIABLES_GRID_TITLE'}, iconCls:analysis.assets.Icons.reports, border:true, flex:2, layout:{type:'hbox', align:'stretch'}, collapseDirection:'left', items:[{xtype:'analysisReportVariablesGrid', flex:1, mainReference:me.mainReference, viewModel:{parent:vm}, storeIdPrefix:'DetailWindow', buttons:[{iconCls:'x-fal fa-plus', ui:'secondary', localized:{text:'ANALYSIS_NEW_VARIABLE', tooltip:'ANALYSIS_NEW_REPORT_VARIABLE_TOOLTIP'}, handler:'openNewVariableWindow'}]}]}, 
  {xtype:'panel', border:true, layout:{type:'hbox', align:'stretch'}, flex:1, localized:{title:'ANALYSIS_CHART_VARIABLES'}, iconCls:analysis.assets.Icons.charts, items:[{layout:{type:'fit'}, flex:1, xtype:'analysisChartVariablesGrid', viewModel:{parent:vm}, mainReference:me.mainReference}]}];
  me.callParent();
}, onCancel:function() {
  this.up('bpcWindow').close();
}, onReportVariablesStoreChange:function() {
  var controller = this.getController();
  controller.refreshChartVariables();
}});
Ext.define('analysis.view.reportEditor.variables.VariablesDetailController', {extend:'Ext.app.ViewController', alias:'controller.analysisReportVariablesDetailController', control:{'analysisChartVariablesGrid':{afterrender:'onAfterRenderChartVariablesGrid'}, 'analysisReportVariablesGrid':{select:'onSelectReportVariablesGrid', afterrender:'onAfterRenderReportVariablesGrid'}}, listen:{store:{'#DetailWindow_AnalysisReportVariablesGridStore':{datachanged:'onReportVariablesStoreChange'}}}, onReportVariablesStoreChange:function(store) {
  var me = this;
  if (store.isFilled) {
    me.refreshChartVariables();
  }
}, onAfterRenderChartVariablesGrid:function(grid) {
  var me = this;
  var gridStore = grid.getStore();
  var chartVariables = me.getChartVariables();
  gridStore.loadRawData(chartVariables);
}, timedRefreshChartVariables:function() {
  var me = this;
  setTimeout(function() {
    me.refreshChartVariables();
  }, 100);
}, refreshChartVariables:function() {
  var me = this;
  var view = me.getView();
  var reportViewCmp = view.mainReference.down('analysisReportViewer');
  if (reportViewCmp) {
    reportViewCmp.setReportChartVariableAssociation();
  }
  var chartVarGrid = view.down('analysisChartVariablesGrid');
  if (!chartVarGrid) {
    return;
  }
  var chartVarGridStore = chartVarGrid.getStore();
  chartVarGridStore.loadRawData(me.getChartVariables());
  var reportVarGrid = view.down('analysisReportVariablesGrid');
  if (!chartVarGrid) {
    return;
  }
  me.selectGridElement(reportVarGrid, false);
}, onAfterRenderReportVariablesGrid:function(grid) {
  var me = this;
  setTimeout(function() {
    me.selectGridElement(grid, true);
  }, 50);
}, selectGridElement:function(grid, first) {
  var gridStore = grid.getStore();
  var amountOfItems = gridStore.getRange().length;
  if (amountOfItems === 0) {
  } else {
    if (first) {
      grid.setSelection(0);
      grid.setSelection(gridStore.first());
    } else {
      var actualSelection = grid.getSelection();
      grid.setSelection(0);
      grid.setSelection(actualSelection);
    }
  }
}, openNewVariableWindow:function() {
  Ext.create({xtype:'analysisNewReportVariableWindow', callback:this.addNewReportVariable.bind(this), callbackCancel:this.closeWindow.bind(this)}).show();
}, addNewReportVariable:function(source) {
  var me = this;
  var sourceVm = source.lookupViewModel();
  var variableType = sourceVm.get('variableType');
  var variableName = sourceVm.get('variableName');
  var grid = me.getView().down('analysisReportVariablesGrid');
  var newVariable = Ext.create('analysis.model.ReportVariablesModel');
  newVariable.set('name', variableName);
  newVariable.set('type', variableType);
  newVariable.set('id', Date.now().toString());
  newVariable.set('_valueList', analysis.assets.Helpers.getTypeMatchingGlobalVariables(variableType));
  if (variableType === 'date') {
    newVariable.set('value', Date.now());
  }
  var newElement = grid.getStore().add(newVariable);
  grid.setSelection(newElement);
  me.closeWindow(source);
}, closeWindow:function(source) {
  source.up('window').close();
}, onSelectReportVariablesGrid:function(grid, record) {
  var vm = this.getView().getViewModel();
  vm.set('selectedRecord', record);
  this.resetChartVariablesState();
  this.typeMatchingVariables(record);
  this.associatedByOthers(record, grid);
  this.activeAssociations(record);
}, resetChartVariablesState:function() {
  this.getChartVariablesStore().each(function(chartVariable) {
    chartVariable.set('state', 'default');
  });
}, typeMatchingVariables:function(record) {
  var reportVariableType = record.get('type');
  this.getChartVariablesStore().each(function(chartVariable) {
    var chartVariableType = chartVariable.get('type');
    if (reportVariableType === chartVariableType) {
      chartVariable.set('state', 'enabledUnchecked');
    }
  });
}, activeAssociations:function(record) {
  var selectedAssociations = record.get('association');
  this.getChartVariablesStore().each(function(chartVariable) {
    Ext.each(selectedAssociations, function(association) {
      if (parseInt(association.connectedChartId) === parseInt(chartVariable.get('connectedChartId'))) {
        if (parseInt(association.variableId) === parseInt(chartVariable.get('variableId'))) {
          chartVariable.set('state', 'enabledChecked');
          if (record.get('externalSource')) {
            var globalId = record.get('globalId');
            var globalValue = analysis.assets.Helpers.getGlobalVariableValue(globalId);
            if (globalValue && globalValue !== '') {
              chartVariable.set('value', globalValue);
            } else {
              chartVariable.set('value', record.get('value'));
            }
          } else {
            chartVariable.set('value', record.get('value'));
          }
        }
      }
    }, this);
  }, this);
}, associatedByOthers:function(record, grid) {
  var selectedId = record.get('id');
  var reportVarGridStore = grid.getStore();
  var chartVarGridStore = this.getChartVariablesStore();
  reportVarGridStore.each(function(reportVariable) {
    if (reportVariable.get('id') !== selectedId) {
      var notSelAssociations = reportVariable.get('association');
      Ext.each(notSelAssociations, function(association) {
        chartVarGridStore.each(function(chartVariable) {
          if (parseInt(association.connectedChartId) === parseInt(chartVariable.get('connectedChartId'))) {
            if (parseInt(association.variableId) === parseInt(chartVariable.get('variableId'))) {
              chartVariable.set('state', 'disabledChecked');
            }
          }
        });
      });
    }
  });
}, writeAssociations:function(record, add) {
  var me = this;
  var reportVarGrid = this.getView().down('analysisReportVariablesGrid');
  var selection = reportVarGrid.getSelection();
  if (!Ext.isArray(selection) || selection.length !== 1) {
    return;
  }
  var selectedRecord = selection[0];
  var targetArray = selectedRecord.get('association');
  if (add) {
    var newAssociation = Ext.create('analysis.model.ReportVariableAssociationModel');
    newAssociation.set('connectedChartId', record.get('connectedChartId'));
    newAssociation.set('variableId', record.get('variableId'));
    targetArray.push(newAssociation.getData());
  } else {
    var foundEntryIndex = targetArray.findIndex(function(el) {
      return parseInt(el.connectedChartId) === parseInt(record.get('connectedChartId')) && parseInt(el.variableId) === parseInt(record.get('variableId'));
    });
    targetArray.splice(foundEntryIndex, 1);
  }
  selectedRecord.set('association', targetArray);
  me.timedRefreshChartVariables();
}, getChartVariablesStore:function() {
  var chartVariableStore = this.getView().down('analysisChartVariablesGrid').getStore();
  if (chartVariableStore) {
    return chartVariableStore;
  }
  return Ext.create('Ext.data.Store');
}, getReportVariablesStore:function() {
  var reportVariableStore = this.getView().down('analysisReportVariablesGrid').getStore();
  if (reportVariableStore) {
    return reportVariableStore;
  }
  return Ext.create('Ext.data.Store');
}, getChartVariables:function() {
  var vm = this.getView().mainReference.getViewModel();
  var charts = vm.get('record.charts');
  var allVariablesList = [];
  Ext.each(charts, function(singleChart) {
    Ext.each(singleChart.variables, function(singleVariabale) {
      var singleVar = Ext.clone(singleVariabale);
      var listVariable = Ext.apply(singleVar, {chartId:singleChart.chartID, connectedChartId:singleChart.id, variableId:singleVar.id, variableName:singleVar.name, state:'default', active:false});
      delete singleVar.id;
      allVariablesList.push(listVariable);
    });
  });
  return allVariablesList;
}, onSaveReportDetail:function() {
  var me = this;
  var view = me.getView();
  var reportVariableStore = me.getReportVariablesStore();
  var reportVariables = analysis.assets.Helpers.getRawDataFromStore(reportVariableStore);
  var vm = view.mainReference.getViewModel();
  vm.set('record.reportVariables', reportVariables);
  view.mainReference.down('analysisReportConfigForm').getController().onSave();
  view.up('bpcWindow').close();
}});
Ext.define('analysis.view.tree.AbstractTree', {extend:'Ext.tree.Panel', alias:'widget.abstractTree', stateful:true, stateEvents:['selectionchange'], getState:function() {
  if (this.getSelectionModel().getSelection().length > 0) {
    return {'selection':this.getSelectionModel().getSelection()[0].getId()};
  }
}, applyState:function(state) {
  var me = this;
  try {
    if (state.selection) {
      var record = this.getStore().getById(state.selection);
      this.suspendEvents(true);
      me.getSelectionModel().select(record);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR applyState', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('analysis.view.widget.chart.WidgetConfigurator', {extend:'Ext.panel.Panel', alias:'widget.analysisChartWidgetConfigurator', localized:{title:'ANALYSIS_WIDGET_SETTINGS_FIELDSET_TITLE'}, moduleId:undefined, chartId:undefined, bodyPadding:10, instanceSelector:undefined, chartSelector:undefined, widgetTitle:undefined, widgetIconCls:undefined, showReportTitle:false, initComponent:function() {
  this.createButtons();
  this.callParent();
  this.createTitleIconSelector();
  this.createInstanceSelector();
  this.createChartSelector();
}, createButtons:function() {
  this.buttons = [{xtype:'button', ui:'primary', localized:{text:'CORE_SAVE'}, iconCls:'fal fa-save', handler:this.onSaveConfiguration.bind(this)}];
}, createTitleIconSelector:function() {
  this.TitleIconSelector = this.add({xtype:'container', items:[{xtype:'bpcTextField', labelWidth:200, margin:'0 20px 10px 10px', localized:{fieldLabel:'ANALYSIS_WIDGET_TITLE_FIELD_LABEL'}, layout:'fit', listeners:{change:this.onChangeTitle.bind(this)}, value:this.widgetTitle}, {xtype:'bpcIconPicker', labelWidth:200, margin:'0 20px 10px 10px', localized:{fieldLabel:'ANALYSIS_WIDGET_ICON_FIELD_LABEL'}, listeners:{change:this.onChangeIcon.bind(this)}, value:this.widgetIconCls}]});
}, createInstanceSelector:function() {
  this.instanceSelector = this.add({xtype:'analysisInstancePicker', value:this.moduleId, listeners:{change:this.onWidgetInstanceChange.bind(this)}});
}, createChartSelector:function() {
  var chartSelector = {xtype:'analysisCatalogChartSelector', value:this.chartId, moduleId:this.moduleId, labelWidth:200, margin:'0 20px 10px 10px', listeners:{change:this.setchartId.bind(this)}};
  if (this.chartSelector === undefined) {
    this.chartSelector = this.add(chartSelector);
  } else {
    var index = this.items.indexOf(this.chartSelector);
    this.remove(this.chartSelector);
    this.chartSelector = this.insert(index, chartSelector);
  }
}, setchartId:function(el, val) {
  this.chartId = val;
}, onWidgetInstanceChange:function(el, val) {
  this.moduleId = val;
  this.chartId = undefined;
  this.createChartSelector();
}, onChangeIcon:function(el, val) {
  this.widgetIconCls = val;
}, onChangeTitle:function(el, val) {
  this.widgetTitle = val;
}, onSaveConfiguration:function() {
  this.up().onSaveConfiguration();
}});
Ext.define('analysis.view.widget.chart.WidgetViewPanel', {extend:'Ext.panel.Panel', alias:'widget.analysisChartWidgetViewPanel', moduleId:undefined, chartId:undefined, showReportTitle:undefined, layout:'fit', padding:0, initComponent:function() {
  var $jscomp$this = this;
  var me = this;
  me.createReportConfiguration();
  me.callParent();
  Ext.Deferred.all([lazyLoad.AmCharts(), lazyLoad.DOMPurify()]).then(function() {
    me.add([{xtype:'analysisReportViewer', header:$jscomp$this.showHeader, scrollable:true, layout:'fit', moduleId:$jscomp$this.moduleId, flex:1, viewModel:{data:{record:$jscomp$this.reportConfig}}}]);
  });
}, createReportConfiguration:function() {
  this.reportConfig = {name:'singleChart', charts:[{id:Ext.id(), title:'', chartID:this.chartId, variables:[], additionalParameters:{}}], layout:'vbox', updateFrequency:30, reportVariables:[], enableUpdate:true, userIsAllowedAutoUpdate:true, userIsAllowedUpdateFrequency:true, liveUpdate:true};
}});
Ext.define('analysis.view.widget.report.WidgetConfigurator', {extend:'Ext.panel.Panel', alias:'widget.analysisReportWidgetConfigurator', localized:{title:'ANALYSIS_WIDGET_SETTINGS_FIELDSET_TITLE'}, moduleId:undefined, reportId:undefined, bodyPadding:10, instanceSelector:undefined, reportSelector:undefined, widgetTitle:undefined, widgetIconCls:undefined, showReportTitle:false, initComponent:function() {
  this.createButtons();
  this.callParent();
  this.createTitleIconSelector();
  this.createInstanceSelector();
  this.createReportSelector();
  this.createShowTitleCombo();
}, createButtons:function() {
  this.buttons = [{xtype:'button', ui:'primary', localized:{text:'CORE_SAVE'}, iconCls:'fal fa-save', handler:this.onSaveConfiguration.bind(this)}];
}, createTitleIconSelector:function() {
  this.TitleIconSelector = this.add({xtype:'container', items:[{xtype:'bpcTextField', labelWidth:200, margin:'0 20px 10px 10px', localized:{fieldLabel:'ANALYSIS_WIDGET_TITLE_FIELD_LABEL'}, layout:'fit', listeners:{change:this.onChangeTitle.bind(this)}, value:this.widgetTitle}, {xtype:'bpcIconPicker', labelWidth:200, margin:'0 20px 10px 10px', localized:{fieldLabel:'ANALYSIS_WIDGET_ICON_FIELD_LABEL'}, listeners:{change:this.onChangeIcon.bind(this)}, value:this.widgetIconCls}]});
}, createInstanceSelector:function() {
  this.instanceSelector = this.add({xtype:'analysisInstancePicker', value:this.moduleId, listeners:{change:this.onWidgetInstanceChange.bind(this)}});
}, createShowTitleCombo:function() {
  this.showTitleCombo = this.add({xtype:'checkboxfield', localized:{fieldLabel:'ANALYSIS_CHART_SHOW_TITLE_FIELD_LABEL'}, labelWidth:200, margin:'0 20px 10px 10px', value:this.showReportTitle, listeners:{change:this.onchangeShowTitleCombo.bind(this)}});
}, onchangeShowTitleCombo:function(el, val) {
  this.showReportTitle = val;
}, createReportSelector:function() {
  var reportSelector = {xtype:'analysisCatalogReportSelector', value:this.reportId, moduleId:this.moduleId, labelWidth:200, margin:'0 20px 10px 10px', listeners:{change:this.setReportId.bind(this)}};
  if (this.reportSelector === undefined) {
    this.reportSelector = this.add(reportSelector);
  } else {
    var index = this.items.indexOf(this.reportSelector);
    this.remove(this.reportSelector);
    this.reportSelector = this.insert(index, reportSelector);
  }
}, setReportId:function(el, val) {
  this.reportId = val;
  this.triggerReportReload();
}, onWidgetInstanceChange:function(el, val) {
  this.moduleId = val;
  this.reportId = undefined;
  this.createReportSelector();
  this.triggerReportReload();
}, triggerReportReload:function() {
  this.fireEvent('reportConfigChanged', this.moduleId, this.reportId);
}, onChangeIcon:function(el, val) {
  this.widgetIconCls = val;
}, onChangeTitle:function(el, val) {
  this.widgetTitle = val;
}, onSaveConfiguration:function() {
  this.up('analysisReportWidget').onSaveConfiguration();
}});
Ext.define('analysis.view.widget.report.WidgetViewPanel', {extend:'Ext.panel.Panel', alias:'widget.analysisReportWidgetViewPanel', moduleId:undefined, reportId:undefined, showReportTitle:undefined, layout:'fit', padding:0, initComponent:function() {
  var me = this;
  this.callParent();
  Ext.Deferred.all([lazyLoad.AmCharts(), lazyLoad.DOMPurify()]).then(function() {
    me.add({xtype:'analysisExternalReportViewer', moduleId:me.moduleId, reportId:me.reportId, showHeader:me.showHeader, reportData:me.reportData});
  });
}});
